WinMerge 2.16 ヘルプ

Varis Kimmo [FAMILY Given]

Bradford Denis [FAMILY Given]

Grimm Dean [FAMILY Given]

Ganier Laurent [FAMILY Given]

Gerundt Tim [FAMILY Given]

Rapp Perry [FAMILY Given]

List Christian [FAMILY Given]

[FAMILY Given]

そして、すべての協力者の方々。

Revision 1.7.11

製作著作 © 2004-2023 Thingamahoochie Software

この文書の情報は予告なしに変更されます。 この文書に引用された製品や企業は、 それらの企業・権利者の商標、および、 登録商標です。


WinMergeヘルプについて

このドキュメントはWinMerge 2.16 のヘルプです。

1. 対象読者と範囲

WinMergeヘルプは、新しいユーザーと経験豊かなユーザー両方を対象としています。WinMergeヘルプは、WinMergeの使い方を説明し、能力と限界を文書化します。

2. ヘルプへのアクセス方法

WinMergeヘルプトピックは、2つの形式で提供されます:

  • Microsoft HTML ヘルプ (WinMerge.chm), インストールディレクトリのWinMerge\Docsにあります。

  • WinMergeウェブサイトのHTML マニュアル

以下のいくつかの方法でWinMergeヘルプにアクセスできます:

WinMergeヘルプメニュー

WinMerge使用中に、ヘルプ → WinMergeヘルプをクリックします。 HTMLヘルプの最初(このトピック)が開かれます。

状況依存のヘルプ

何らかのWinMergeウィンドウを使用中に、F1を押してください。現在のウィンドウに関するトピックがあれば、そのトピックのヘルプを開きます。 もしなければ、最初のトピックを開きます。

WinMergeコマンドライン

コマンドラインからWinMergeを実行しているときは、/?か -?スイッチを使用してください。HTMLヘルプが最初のトピックを開きます。

WinMergeウェブサイト

winmerge.orgをブラウザーで開いてください。DocumentationのManualリンクをたどってください。最新版のヘルプが開きます。

3. ヘルプの使い方

最も重要なWinMergeの基本を学ぶために、次のトピックを読んでください。

クイックスタート

WinMergeを手早く使い始められるようにし、基本的な使用方法を示します。

フォルダーの比較とマージ

フォルダー比較ウィンドウでの可能な操作、結果表示のカスタマイズの仕方を説明します。

テキストファイルの比較とマージ

ファイル比較・マージウィンドウでの可能な操作、ナビゲーションの方法、モードについて説明します。

画像ファイルの比較

画像比較・マージウィンドウについて説明します。

Hex形式比較

HEX比較・マージウィンドウについて説明します。

テーブル形式比較

テーブル比較・マージウィンドウについて説明します。

Webページの比較

Webページ比較ウィンドウについて説明します。

オプションとコンフィグレーション

空白、色、テキストエンコーディングの取り扱いを含めたWinMergeの設定方法について説明します。

もっと詳細にWinMergeについて学習したい場合、次のトピックを読んでください:

ファイルとフォルダーを開く

WinMergeでファイルとフォルダーを開くいくつかの方法(たくさんあります!)について紹介します。例えば、詳細モードでのシェル拡張コンテキストメニューの使い方を知っていますか?

プラグイン

プラグイン機構を使用してWinMergeに追加できるオプション機能について説明します。

フィルターの使用

フォルダーやファイル比較ウィンドウで比較される対象を制御する方法を説明します。

コマンドライン

他のツールと連携やスクリプトから起動するときに使用できるコマンドラインパラメーターを記載します。

よくたずねられる質問

開発者に尋ねられたたくさんの共通的な質問に対する回答を含んでいます。

質問をGitHub,にする前に、よくたずねられる質問トピックで質問が回答されていないか確認してください。

4. ドキュメント表記規則

例 | 意味
フィールドにUTF-8と入力してください。

パスを辿るために、参照ボタンをクリックしてください。

ウィンドウを更新するために、F5を一回押下してください。

 説明文中のボールドフォントは、以下の内容を表します:

  • 入力を指示された、値、または、文字列

  • GUIボタンかキーの名前
Ctrl+Oを押下してください | 押下は、キーボード操作を表します。この例では、CtrlとOキーの組み合わせで押下します。

OKをクリックしてください。

 クリックは、メニューアイテムやボタンの様な対象の上での、マウスの左クリックを表します。
ファイル → 開くをクリックしてください。 | 矢印は、メニューを表します。この例では、WinMergeのファイルメニューの中の開くを選択してください。
行を右クリックして、比較ショートカットを選択してください。 | コンテキストメニューを開くために、対象の上で右クリックしてください。そして、コンテキストメニュー中のアイテムを、左か右クリックしてください。
options file.iniを入力してください。

操作対象からファイルを除外するためにフィルターフィールドを使用してください。

連続した1つかそれ以上の差異行は、一つの差異(またはdiff差分)を形成します。

 イタリック体のテキストは、次の内容を表します:

  • 置き換え可能な値、または、文字列。最初の例では、イタリック体の語句の代わりに実際のファイル名を用いるでしょう。

  • WinMerge ウィンドウ内のフィールド、メニュー、コントロールの名前です。

  • 重要な単語、または、フレーズです。
パス%WORKDIR%\project1は、C:\workfiles\project1に展開されます。
TwoWords
 等幅のテキストは、次の内容を表します:

  • パス、ファイル名、または、その他のシステム項目

  • サンプルコードの一部

  • サンプル出力

  • フォームかコマンドライン上で入力する情報

command inputpath [outputpath]

 シンタックス行では、ブラケット(大括弧)は省略可能な要素を表します。この例では、コマンドと入力パスを入力しなければなりません。出力パスも入力できますが、入力しなくてもコマンドは有効です。


クイックスタート

1. 比較するファイルとフォルダーの選択

WinMergeをインストールしたら、トピック中の手順と議論を通じて、 基本的なWinMergeの操作と概念を学んでください。 その方法は、一つではありません。各タスクを実行するには、通常いくつの方法があります。 これが完了したら、他のヘルプトピックでカバーされる他の方法やより高度なスキルを学ぶことができます。

1.1. WinMerge ウィンドウの起動

いくつかの方法をご紹介します:

  • デスクトップにあるWinMergeのショートカットをダブルクリックします。

  • スタートメニューにあるWinMergeのランチャーから操作します。

  • コマンドプロンプトで、WinMergeをインストールしたディレクトリへ移動し、 WinMergeUと入力します。

  • Windows+Rキーを押下し、winmergeと入力します。

1.2. ファイルまたはフォルダーの選択 ダイアログを開く

WinMergeウィンドウにて以下の方法で、ファイルまたはフォルダーの選択 ダイアログを開きます:

  • ファイル(F) → 開く(O)をクリックします。

  • ツールバーの開くボタン WinMerge open button をクリックします。

  • Ctrl+Oを押下します。

1.3. ファイルまたはフォルダーの選択 ダイアログ

1.3.1. ファイルとフォルダーの指定

1番目と2番目 のフィールドに、次のいくつかの方法で、比較するファイルやフォルダーを指定してください。

  • このフィールドに、直接、パスを入力してください。

  • 参照ボタンをクリックし、望みのパスを ナビゲートしてください。

    開くダイアログの中の、開く(M)フィールドの 初期状態は、Folder Selection.と表示されています。 あなたがどれを選択するかは、比較したい形式によります。

    • ファイルを比較するなら、目的のファイルを選択してください。 Folder Selectionという文字が、選択したファイル名で上書きされます。

    • フォルダーを比較するなら、(ファイルを選択せずに)目的のフォルダーを開いてください。 Folder Selectionという文字は、きちんと残ったままになります。

    開くボタンをクリックして、開くダイアログを閉じ、 選択した項目を1番目、または、2番目フィールドに読み込んでください。 もし、フォルダーを選択したなら、パスの最後にバックスラッシュ ( \ )を含んでいます。

  • コンボボックスをクリックして、以前使用したパスを選択してください。

    ティップ

    よく使うパスを、より簡単に選択するには、開くダイアログのオートコンプリート(O) オプションを有効にすることを考慮に入れてください。 このオプションにより、WinMergeは、あなたがこのフィールドに入力する時に、有効なパスの一覧を表示します。 詳しくは、オプションとコンフィグレーションを参照してください。

  • ファイル、フォルダーをダイアログ、または、1番目、 または、2番目のフィールドへドラッグ・アンド・ドロップしてください。

注意

あなたは、一組のファイル、または、フォルダーを比較することができます。 もし、ファイルとフォルダーを選択するか、または、ファイルやフォルダーが存在しない場合、 WinMergeは、ダイアログの比較ボタンを使用不可にします。

ダイアログ下部のステータス・メッセージでも、 もし、パスが不正な場合は、通知します。

1.3.2. フォルダー比較範囲の制御

もし、フォルダーを比較しているなら、その操作からファイルを除外するために、 フィルターフィールドを使用することができます。 そのフィールドには、選択されたパスの中にあるファイルの一部を指定します。 すべての明示していないファイルは、除外されます。

ファイルをフィルターするための、ファイル・マスクを入力することができます。 例えば、この式は、CとC++のソースファイルだけを含みます(他のすべてのファイル形式は除外されます)。

*.cpp;*.hpp;*.c;*.h

より強固なフィルタリングのため、ファイルマスクの代わりに、フィルターファイルを入力してください。 フィルター(F)フィールドの次にある、選択ボタンをクリックして、 有効なフィルターの中から選択してください。 ファイルフィルターは、いくつかの含めるか、除外するかのルールから成ります。 WinMergeは、フィルターファイルのセットをインストールします。 それらは、編集、または、強化することができます。

ファイル・マスクとファイル・フィルターについての、完全な詳細は、フィルターの使用 を参照してください。

サブフォルダーを含む(I)チェックボックスは、 フォルダー比較の範囲を制御する、もう一つの方法です。 このオプションをチェックすると、WinMergeは、サブフォルダーを再帰的に比較し、すべてのファイルとフォルダーを一覧表示します。 このオプションを無効にした場合は、カレントフォルダーのみが比較されます。 サブフォルダーは名前で一覧表示(フォルダーの中身は除く)され、フォルダーの中を閲覧することができます。

1.3.3. 展開プラグインの使用

展開プラグイン(U)フィールドは、プラグインを使用した比較操作を可能にします。

1.4. ファイルとフォルダーを開く他の方法

ファイルまたはフォルダーの選択ダイアログは、ファイルやフォルダーを開くための主要なインターフェイスです。 しかし、他の多くの方法も使用することができます。

  • 「Project files」は、よく使うパスを、もっとも簡単かつ高速に開く方法です。
  • 「WindowsエクスプローラーからWinMergeの起動」.
  • コマンドラインインターフェイスを使用して、 他のアプリケーション、コマンド・プロンプト、バッチ、または、スクリプトファイルから WinMergeを起動してください。
  • ファイルやフォルダーを、WinMergeのウィンドウかデスクトップのショートカットへ直接、ドラッグ・アンド・ドロップしてください。

2. フォルダーの比較

もし、開くダイアログで、2つのフォルダーを選択したなら、フォルダー比較ウィンドウが開かれます。フォルダー比較ウィンドウは、比較対象フォルダー中で見つかった項目の表です。それぞれの行は、見つかったファイルについて、左の列にファイル名、その他の列に付加的な情報を表示します。

WinMergeは、変更元と変更後 という概念を持っていません。 代わりに、選択された二つのフォルダー間の差異を、単に表示します。 一方でしか見つからなかったファイル、または、フォルダーは、単に見つかった方にのみ存在する項目として表示されます。 例えば、上の図の比較結果(Comparison Result)カラムにある、 Merge.apsとMerge.rc.bakは、 どちらも比較されたフォルダーの一方でしか見つかりませんでした。

マージ(M)メニュー、ツールバーボタン、または、コンテキスト(右クリック)メニューなど、 多くの方法で、ファイルとフォルダーを管理できます。 The most important action is making files or folders identical in both sides by selecting one of several Copy items. ファイル、または、フォルダーを他方へコピーした時、比較結果は、同一に変わります。

もし、ファイル、または、フォルダーが、左右両方に存在した(かつ、バイナリファイルでない)場合、 これらのうち一つの方法で、比較するために、ファイルを開くことができます。

  • WinMergeメニューから、マージ(M) → 比較(M)をクリックする。
  • 行を右クリックして、比較ショートカットを選択してください。
  • 行をダブルクリックする。
  • 行を選択し、Enterを入力してください。

サブフォルダーを比較する場合、新しいフォルダー比較テーブルが、 現在のフォルダー比較ウィンドウ内に読み込まれます。 フォルダー比較を完了したら、ファイル名列の一番上の上矢印ボタン Navigator up arrow button をダブルクリックし、親フォルダーに戻ることができます。

ファイルを比較する場合、WinMergeは、次のセクションで説明される、ファイル比較ウィンドウを開きます。ファイル比較ウィンドウ内で、ファイルを変更するなら、フォルダー比較ウィンドウに戻った時、ファイルのデータが更新されていることを確認できるでしょう。

3. ファイルの比較

ファイル比較ウィンドウは、分割されたファイルペインに、二つの選択されたファイルをとなり同士に表示します。 異なる行は、背景色がハイライト表示されます。 ひとつ、または、連続した異なる行は、ひとつの差異(diff)として表されます。 In the preceding example, a single difference is selected in the File panes and displayed by itself in the Diff Pane. WinMerge mainly works with these differences, not separate lines. 差異をマージすると、その差異のすべての行を他方にコピーします。

重要項目

同じ行が、いつも隣同士に並べられるように、WinMergeが、どのように無くなった行を埋めるかに、 注意してください。これは、他のほとんどの、比較/マージプログラムと異なり、学ぶためにしばらく時間がかかります。

WinMergeは、テキストの基本的な入力、コピー、カット・アンド・ペースト機能を持った、シンプルな実装のエディターを備えています。 もし、 自動再スキャンが有効なら、WinMergeは、あなたがファイルを編集している間、ファイルの差異を更新します。 もし、自動再スキャンが無効なら、手動でファイルを更新できます。表示(V) → 最新の情報に更新(S)をクリックしてください。 表示更新ボタン をクリックするか、 F5を押してください。


WinMergeの紹介

WinMergeは、オープンソース の、Windows用差分表示／マージツールです。WinMergeは、 フォルダーとファイルの両方(または3つすべて)をわかり易く、 そして扱い易いヴィジュアル形式で比較できます。

WinMergeは、プロジェクトバージョン間の変更点を特定したり、マージしたりする際に、非常に有効です。 WinMergeは、外部の差分／マージツール、または、単体のアプリケーションとして 使用することができます。

さらに、WinMergeは、比較、同期、マージを簡単に、そして便利にする多くの役立つ特徴を備えています。 いくつかのプログラミング言語とその他のファイル形式は、シンタックスハイライトされます。

WinMergeは、バイナリエディターではありません。WinMergeは、バイナリ・ファイルの内容と 差分を表示することができます。しかし、その情報は表示専用を意図しています (WinMergeでのバイナリ・ファイル編集は、ファイルを壊すかもしれません)。

WinMerge開発のゴールは、フォルダーやファイルを比較、同期、 そして、マージを簡単かつ迅速に行えるようにすることです。 使い易さは、間違いを減らすために重要なことです。 最新版 2.16 は、 安定性と信頼性が考慮されています。

The latest version 2.16 is considered a stable and reliable program to use.

注意

WinMergeは、( 多くのWebサイトで言及されているように)フリーウェアでないことに注意してください。 それは、GPLでライセンスされています。

私たちは、「使える」ツールを無料で提供します。そのため、使用許諾を尊重し改善提案をしてください。 すべてのユーザーのメリットとなる、WinMergeの改良を手助けしていただき、私たちは嬉しく思います。

1. WinMergeのバージョン

ダウンロード ページに、三種類のバージョンがあります。

1.1. 安定版

安定版は、ほとんどのユーザーに推奨されます。もし、どのバージョンを使えば良いかわからない場合は、最新の安定版を使用してください。安定版は、最後の数字が偶数のバージョンです。例えば、2.14.0、2.16.2や2.16.4などです。

1.2. ベータ版

ベータ版は、最新の機能や安定版からの改良箇所を試してみたい人向けです。 ベータ版は、広くテストされておらず、いくつかのバグがあるでしょう。 ベータ版は、最後の数字が奇数のバージョンです。例えば、2.16.3 や 2.16.5 などです。 ベータ版には、メジャーなバグは無いと思われるので、生産に使用することができます。 しかし、ベータレベルのリリースを使用することは、常にリスクを伴うため、よく考えてください。 私たちは、年に一度は新しい安定版をリリースしようとしました。 したがって、次の安定版リリースまで数ヶ月待つ価値があるかもしれません。。。

2. サポートとバグの報告

The Discussion forums are the fastest way to get help:

  • WinMerge discussions
  • Image Compare discussions
  • Website discussions

もし、バグを発見したら、バグレポートを通じて それを提出してください。より多くの情報を添えてください(少なくとも、使用しているWinMergeのバージョン番号は)。 可能なら、WinMergeのウィンドウの ヘルプ → 設定のクリックで表示できる、設定情報を添えてください。 バグレポート中の良い情報は、バグが素早く修正されるのに役立ちます。

重要項目

バグレポートに、バージョン番号を含めてください。バージョン番号は、 ヘルプ → WinMergeについてをクリックすることで確認できます。

3. WinMergeのソースコードと開発

WinMergeのソースコードは、ダウンロード ページと、 GitHub プロジェクトページより入手可能です。 誰でもソースをダウンロードでき、勉強したり、改変したりできます。 もし、バグを発見(や修正)したり、何かを改良するなどしたら、変更点を パッチやプルリクエストとして提出してください。そして、この製品を改良するのを手助けしてください！もし、あなたが改変したバージョンを公開するなら、 そのソースコードも一緒に公開する必要があります。これは、GPLライセンスによるもので、それに配慮してください。

WinMerge development work is done by people in their spare time. Nobody gets paid for improving WinMerge. We try to fix bugs as we find them or when somebody reports them to us. We really try - we use WinMerge too. But there are absolutely no promises for new features. We always appreciate any help with WinMerge, be it testing, documenting, translating, or coding.


WinMergeのダウンロードとインストール

WinMergeは、インストーラー、または、アーカイブから展開したファイルにより、インストールすることができます。 インストーラーを使用するのが、オススメの方法です。

1. ファイルのダウンロード

最新のリリースは、WinMergeのホームページより、いつでもダウンロード可能です。 最新リリースのためのホームページ更新に、遅れが生じることに注意してください。 しかし、SourceForge.netの、プロジェクトステータスページは、 最新のファイルを表示します。 安定リリースは、いくつかのファイルダウンロードサイトより入手可能です。

2. 互換性

  • WinMerge 2.16.8 (64 bit) supports Windows 7 and later. It runs on 64 bit Windows.

  • WinMerge 2.16.8 (32 bit) supports Windows XP SP3 and later. It runs on both 32 bit and 64 bit Windows.

  • WinMerge 2.16.0 supports Windows XP SP3 and later. It runs on both 32 bit and 64 bit Windows.

  • WinMerge 2.14.0 was the last version to support Windows 2000.

  • WinMerge 2.12.4 was the last version to support Windows 95, 98, ME and NT.

  • WinMerge is not supported on Windows RT.

3. インストーラーを使用する (推奨)

注意

インストーラーは、Administrator権限を必要とします。 Administrator権限を持っていないなら、アーカイブファイルより展開するか、 ユーザー単位インストーラー(WinMerge-x.x.x-x64-PerUser-Setup.exe)を使用することで、 WinMergeをインストールできます(「圧縮ファイルからのインストール」を参照してください).

インストーラーを使用することは、ほとんどのユーザーにオススメです。 インストーラーは、WinMergeがインストールされる場所を促します。 ファイルがインストールされるとき、シェル統合、WinMergeをスタートメニューに追加するなどを設定します。 WinMergeのインストール:

  1. インストーラーの開始(通常、 WinMerge-version-setup.exeのような名前)。
  2. ライセンス認証画面の次へをクリックしてください。
  3. In the Select Destination Location page, accept the location for WinMerge or, if you choose another location, we recommend that you install WinMerge in its own folder. 次へをクリックしてください。

  4. コンポーネントの選択ページ中の、一番上の項目の中から、予め設定されたインストール方法を選択してください。 ほとんどのユーザーには、標準インストールをオススメします。 下部のボックスは、すべての有効なコンポーネントを表示します。 コンポーネントのチェックをON、または、OFFにすることで、既定の設定を変更することができます。 たとえば、英語より異なった言語用のWinMergeローカライゼーションを使用したいなら、 言語コンポーネントを選択してください。

    WinMergeコアファイル

    WinMerge実行ファイル、ヘルプ、その他必要なファイル。 チェックを外すことはできません。

    32-bit WinMerge ShellExtension

    The option enables you to launch WinMerge directly from Windows Explorer, comparing items that you have selected there.

    フィルター

    ファイル・フィルターファイルは、比較範囲を限定することができます。

    プラグイン

    WinMergeプラグインは、COM APIで書かれたカスタムDLL、または、スクリプトレットで、 比較前にデータを前処理するために使用することができます。

    言語

    WinMerge翻訳ファイル。WinMergeを、英語より異なる言語で使用したいなら、 この項目を展開し、有効な翻訳ファイルをひとつ以上選択してください。 インストーラーは、WinMergeフォルダーの中に、あなたが選択した言語の*.po翻訳ファイルを含むLanguagesサブフォルダーを作成します。 インストール後、WinMergeを起動し、ローカライズを変更することができます。 詳しくは、ロケールサポートを参照してください。

    次へをクリックしてください。

  5. プログラムグループの指定ページでは、WinMergeのショートカットを設定することができます。

    • プログラムショートカット作成の、既定の設定を受け入れるか、異なるフォルダーを指定してください。

    • 任意で、プログラムグループを作成しない(D)をチェックしてください。

    次へをクリックしてください。

  6. 追加タスクの選択ページでは、いくつかの追加タスクを指定してください。

    エクスプローラーのコンテキストメニューに追加(E)

    Windowsエクスプローラーから、WinMergeの比較操作を行うことを可能にします (このシェル統合は、WinMergeの設定の中で、有効、または、無効にすることができます)。

    システム環境変数PATHへWinMergeのフォルダーを追加する(A)

    WinMergeのインストールフォルダーを、システム環境変数へ追加します。

    Integrate with TortoiseCVS

    WinMergeを、TortoiseCVSの差分比較ツールに設定します。

    Integrate with TortoiseSVN

    WinMergeを、TortoiseSVNの差分比較ツールに設定します。

    Integrate with TortoiseGit

    Sets WinMerge to be the TortoiseGit diff application.

    デスクトップ上へアイコンを作成

    デスクトップへ、WinMergeのショートカットを追加します。

    次へをクリックしてください。

  7. In the 3-way merge wizard page, register WinMerge as 3-way merge tool for TortoiseSVN/Git.

    Register WinMerge as a 3-way merge tool

    Register WinMerge as 3-way merge tool for TortoiseSVN/Git.

    Merge at right pane

    Merge at right pane.

    Merge at center pane

    Merge at center pane.

    Merge at left pane

    Merge at left pane.

    Auto-merge at startup time

    Optionally, disable the option Auto-merge at startup time.

    次へをクリックしてください。

  8. インストール準備完了ページでは、インストール内容の設定を確かめてください。 もし必要なら、戻る(B)をクリックし、前のページで内容を変更してください。 インストール作業を続ける準備ができているなら、インストール(I)をクリックしてください。

  9. インストーラーが、ファイルのコピーを完了すると、最後の画面が表示されます。 二つのチェックボックスを使用して、作成されたWinMergeのスタートメニューフォルダーが開けるかどうか、 WinMergeが起動可能かどうかを確認することができます。

4. 圧縮ファイルからのインストール

WinMergeは、他のシステムコンポーネントから、ほとんど独立しています。 それはしっかりとWindowsに統合されず、多くのDLLを使用しません。

アーカイブファイルは、正しいフォルダー構成を持ちます。WinMergeは、 このフォルダー構成を保ったまま、インストール場所へ展開されるべきです。 たとえば、ルートフォルダーが、C:\Program Files\以下の WinMerge-version (WinMerge-2.6.0など)フォルダーに作成されます。 このフォルダーをリネーム、または、ファイルを別のフォルダーへ(フォルダー構成を保ったまま!)コピーすることができます。

ファイル展開後、WinMergeは、起動する準備ができています。 シェル統合とアーカイブ統合は、次のセクションで説明される、追加のステップが必要です。

5. インストーラーなしでWindowsエクスプローラーシェル統合を有効にする

もし、インストールプログラムを使用せずに、シェル統合を有効にしたいなら、 シェル統合DLL(ShellExtension*.dll)を別に登録しなければなりません。

注意

シェル統合のインストールは、Administrator権限を必要とします。

Open WinMerge and using the 「シェル統合ページ」 in the Options window. In the Options window use the Register shell extension or Unregister shell extension buttons.


ファイル比較とマージの概観

ここでの主題は、WinMergeがどのようにして、テキストファイル中の 差分を見つけ、また、表示するのかということ。 そして、単純なファイルの比較とマージ操作のデモを行います。 バイナリファイルに関する情報は、Hex形式比較を参照してください。

1. ファイルの比較

私たちは、ある方法で関連付られる二つのファイルを、いつも比較します。 たとえば、別々の時間、または、別々の人によって編集された二つのバージョンのファイルなどです。 そのような二つのファイルを検査すれば、いくつかの同じような領域と 同様に、異なる文字と単語、異なる行、連続したテキストブロックの差分など、くつかの違いを見つけることができます。 しかし、二つのファイル間のすべての差異を、お気に入りのエディターで調べることは、 退屈で間違いを起こしやすいでしょう。 WinMergeの様な、比較／マージに特化したツールは、 この作業を体系的かつ効率的に 行えるように設計されています。

多くの人が使っている、スペルチェッカーのような、シンプルな差分ユーティリティは、 体系的な手段で文書の最後まで、辞書と異なる単語をハイライトし、 スペル間違いを解決するのを助けます。 しかしながら、文字と単語のみで見ることは、複数ファイル間の差異を理解するために 効率的な方法ではありません。 この理由で、多くの差分ユーティリティは比較の基本単位として、 行を代わりに使用します。

WinMergeも、比較の基本単位として、行を使用します。 単語と文字は、比較とマージ操作の中では、個別には扱われません。 例証するために、一行を除いて同一の二つのファイルを考えてください。 一行が、異なる4単語を含む二つのバージョンで、一方のバージョンには、 余分なスペースがある時、ファイルには5つではなく、 1つの差異があると判断します。

単語よりも、行比較の方が速い場合、 一度に一行を比較する代わりに、単一の違いとして行全体を扱うことは、さらに有効です。 あとで見るように、複数行の差分を見つけることは、 マージにも効率的です。

1.1. 単純なファイル操作

このセクションは、二つのファイル間の差分を、 WinMergeで行比較する方法の単純な例を述べています。

  1. テキストエディターを使って、ここに示す内容と名前の二つのファイルを、単語と改行に注意して正確に作成してください。

    File1:

    It's slow comparing words
and characters. Instead,
WinMerge compares lines.
Believe it or else.

    File2:

    It's slow comparing words.
WinMerge compares lines.
Believe it or not.

  2. WinMergeを起動してください。例えば、デスクトップの WinMerge desktop shortcut WinMergeへのショートカットをダブルクリックしてください。

  3. ファイルとフォルダーの選択ダイアログで、 File1を1番目に、 File2を2番目のファイルに指定し、 比較をクリックしてください。このように、左と右のファイルペインに二つのファイルが開かれ、 ファイル比較ウィンドウが表示されます。

    Compare Files screenshot

    この要素は、テキストファイルの比較とマージで、 さらに詳細に説明されています。 以下はこの例で注意すべきいくつかの点です。

    差分の個数

    このメッセージは、 WinMergeウィンドウ下部のステータスバーにあり、 2つの差分が見つかったことを説明しています。

    異なった色

    差分ブロックは異なる背景色でマークされます。 (デフォルトは、ゴールド)

    行差分は、単語背景色を使用して、 差分ブロック中の変更されたテキストをマークすることができます。 (デフォルトは、ライトイエロー)

    同じ行はマークされません。 これらは、例の3行目のような、白の背景色です。

    空白行

    左の比較ペインに注目してください。 2行目にはテキストがあります。 他方のペインは、同じ場所が灰色の空行になっています。 この空行は、File2ソースファイルには、存在しません。 WinMergeが何をしたのでしょう？

    WinMergeは、他方のバージョンにより多くの行が存在すると、 1行、または、それより多くの灰色の空行を、一方のバージョンに挿入します。 これらの灰色の空行は、ソースファイル中の空行を表しているわけではありません。 これらは、表示上のプレースホルダーに過ぎません。 プレースホルダー行の目的は、左と右のバージョンの差分を垂直に整列させることです。 例で述べたように、 WinMerge compares linesのテキストは、 たとえソースファイル中では異なる行にあっても、 比較ウィンドウには並んで表示されます。 このことが、WinMergeでの差分比較を、 従来のエディターより容易にさせています。

    ティップ

    空行の一つの重要性は、たとえ、ソースファイルではそうでなくても、 ファイル比較ウィンドウの両方(または3つすべて)のペインには、 いつも同じ総行数が表示されていることです。

    WinMergeが、どのように差異を検出して、表示するかということを 理解しているので、次のステップで示されるように、 効率的な比較機能を使用できます。

  4. ツールバーにある、 現在の差異ボタン 現在の差異をクリック (または、Alt+Enterキーを押下)してください。このボタンが使えない(例えば、カーソルが違う行にある)時は、 代わりに、 最初の差異ボタン 最初の差異をクリック(または、Alt+Homeキーを押下)してください。

    差異を選択したら、Diffペインに二つのバージョンがロードされます。 Diffペインで、どの行に差異が含まれているか確認し、残りのファイルから独立して、それらを調べることができます。 この例では、違いの一つは明確で、二つの行を持っています。

    Compare Files Diff Pane

  5. ツールバーの、 次の差異ボタン 次の差異をクリック (または、Alt+Enterキーを押下)してください。 これは、同じ行(差異ではない)を飛び越し、 最後の行を選択します。

    ファイルの最後に到達し、すべての差異を検査するチャンスを得ることができました。 これは、つまらない例です。ここに、ただ二つの差異があります。 そして、WinMergeで、これらの差異を比較する方法が二つあります。 しかしそれは、 WinMergeナビゲーション・コントロールを使用することの有効性を証明しています。

2. ファイルのマージ

マージの目的は、二つのファイルの変更を一つのファイルへ結合することです。 マージは、比較操作で使われる、概念と機能を拡張します。 このセクションを始める前に、これまでのセクションを読んでください。 さらに、二つのファイルバージョン間の差異を見つけ、差異を解決し、結果を一つの targetバージョンに保存します。

ファイルのマージは、同時開発を可能にし、それは、チーム環境の中でありふれたタスクです。 例えば、あなたともう一人の人が、 同時期に同じプログラムファイルにコードを追加したいとします。 あなたは、両方ともファイルの同一のコピーからはじめます。 しかし、開発中に、同一でない個別のバージョンを作成します。 ある時点で、二つのバージョンは、 それぞれの貢献者による変更を保ったまま、 一つにマージされなければなりません。

SubversionやGitのようなバージョン管理システムは、マージを 促すことができます(または、開始させられます)。 例えば、お使いのバージョン管理システムが、マージ・コンフリクトにより、リポジトリへのサブミットを妨害するかもしれません。 あなたが自分のバージョンで作業中に、他の誰かが、同じファイルの異なるバージョンをチェックインして、 バージョン管理システムが差分を自動マージできなかった場合、競合が発生します。 競合が発生した場合、あなたのバージョンを提出する前に、 競合しているバージョンをマージする必要があるかもしれません。 多くのシステムには、差分とマージツールが統合されています。 しかし、あなたは、代わりにWinMergeを使いたいかもしれません。

Just as with comparing, you use WinMerge's toolbar controls (or keyboard shortcuts) to systematically step through the differences. Resolve each difference by copying either its left or right candidate to the other side. すべての差異を解決した時、 WinMergeは、すべての差異が解決されたことを知らせ、 マージ作業を完了します。

2.1. 単純なマージ操作

このちょっとした課題は、 ファイル比較ウィンドウのコントロールを、 先に示したシンプルなファイルを体系的にマージするために、どのように使用するかを示しています。

  1. ツールバーの、 現在の差異ボタン 現在の差異ボタンをクリックして、 最初の差異を選択してください。このボタンが使えない場合、 代わりに、 最初の差異ボタン 最初の差異ボタンを クリックしてください。

  2. 右へコピーボタン 右へコピーをクリックすると、 File1から、File2へ、 一つの差異がマージされます。 File2の中の差分1行が、 File1の2行で置き換えられ、 灰色の空行が無くなっていることに注意してください。

  3. 次の差異ボタン 次の差異をクリックすると、 2番目の差異を選択します。これは、差異を自分で発見して選択するより簡単です。 そして、すべての差異を端から端まで難なく調べたいなら、特に便利です。

  4. 左へコピーボタン 左へコピー をクリックすると、 2番目の差異を、File2から、 File1へマージします。

    マージが完了してファイルが同一になると、メッセージが表示されます。

  5. OKをクリックし、メッセージを閉じてください。 差異のステータスが、 差異 1/1から、 同一に変わります

  6. Ctrl+Sを押下して変更を保存してください。

非常にシンプルであると同時に、 この例のデモは、 ある程度の比較をしたり差異をマージしたりする基本的な手順です。

2.2. マージしたファイルの保存先を選択

マージ結果が保たれるようにコントロールしてください。 WinMergeのファイル比較ウインドウには、幾つかのマージツールがそうであるように、 分割された結果ペインがありません。 最も単純な方策は、片方、または、両方(または3つすべて)のソースファイルの変更を保存することです。 Ctrl+Sを押下して、両方のファイルの変更を何度か保存してください。 代わりに、ファイル → 保存 → 左側のファイルを保存、または、ファイル → 保存 → 右側のファイルを保存をクリックして、片方のファイルを保存してください。

どちらか一方のソースファイルの代わりに、別のファイルに書き込むには、 ファイル → 名前を付けて保存を使用してください。例えば、ターゲットファイルが、バージョン管理システムによって作成された、 差分ファイル、または、競合ファイルなどの場合です。

同様に、WinMergeのコマンドラインで、コマンドラインで説明されている、 任意のoutputfile引数を使用して、 両方(または3つすべて)のソースファイルが変更されていない状態のままにしておくことができます。


ファイルとフォルダーを開く

WinMerge provides several ways to specify paths and open files or folders:

  • 「ファイル・フォルダー選択-ダイアログ」

  • 「WindowsエクスプローラーからWinMergeの起動」

  • 「ドラッグアンドドロップの使用」

  • 「Project files」

1. ファイル・フォルダー選択-ダイアログ

クイックスタート describes the Select Files or Folders dialog. This section provides more details, and some tips for using the Select Files or Folders dialog more efficiently.

1.1. 環境変数の使用

You can use environment variables in your paths. Windows expands the variable name between % (percent) delimiters. For example, if an environment variable named WORKDIR has the value c:\workfiles, then the path %WORKDIR%\project1 is expanded to c:\workfiles\project1 .

1.2. アーカイブファイルを開く

WinMerge archive support is provided in the 7-Zip plugin. See WinMergeのダウンロードとインストール to install this plugin.

Opening two archive files is similar to opening normal files: specify two archive files in the Open-dialog's 1st and 2nd fields. If WinMerge recognizes the archive format, it opens the contents of the archive files in the Folder Compare window.

The フォルダーの比較とマージ topic describes how to work with archive files. For example, if an archive file contains two subfolders named Original/ and Altered/, you can compare the contents of the two subfolders by specifying the same archive file in both sides in the Select Files or Folders dialog or WinMerge command line.

ティップ

When you drag an archive file to the WinMerge window, press Shift when dropping the file: WinMerge automatically copies the same filename to both sides and opens the archive file.

1.3. フィルターの指定

The Filter edit field enables you to restrict the files to be included in your folder compare. You can specify one or more file masks, or a single file filter (not both).

A mask is a simple expression based on file extensions. For example, this list of file masks includes only files with the specified extensions; all others are excluded from the selection when the compare operation starts:

*.h;*.cpp;*.txt,*.ini

File masks are practical for simple filtering; for more advanced selecting, use filter files. Filter files are collections of regular expressions that can either include or exclude files. WinMerge installs a number of predefined filter files in its Filters folder, and you can create your own, too.

To specify a filter, click the Select button next to the Filters field to choose from a list of available filters. Or, click the Filter drop-down list and choose a recently-used filter file.

For full information about filter masks and filter files, see フィルターの使用.

1.4. ファイル比較で使用する展開プラグインの選択

Unpackers are plugins that are installed with WinMerge to provide functionality that is not used by default. Plugins that can be used to preprocess certain types of files before comparing them. For example, WinMerge cannot normally compare MS Word doc files, but by unpacking them, you can compare just the text contents. See プラグイン for details.

To apply a plugin to your file comparison, click the Select button for the Unpacker option. In the Select Unpacker dialog:

  1. 自動展開を設定するか、または手動でプラグインを選んでください。

    • 自動展開モード(最初の利用可能なプラグインを適用)を使用するには、ファイル展開プラグイン にて<自動展開>を選択してください。

    • 異なったプラグイン(利用可能であれば)を選択したい場合は、ファイル展開プラグインにてプラグインを選択してください。

      デフォルトでは、比較する対象にファイルに応じた拡張子用のプラグインだけを表示します。すべての利用可能なプラグインを見るためには、 すべての展開プラグインを表示し、拡張子をチェックしませんオプションを有効にしてください。

    • プラグインを使用せずに比較を行い対場合は、ファイル展開プラグインにて <なし>を選んでください。

  2. OKをクリックして、展開プラグインの選択ダイアログを閉じてください。

Your choice is displayed in the Unpacker field. Note that you cannot select an unpacker when launching a Folder Compare operation.

2. WindowsエクスプローラーからWinMergeの起動

The optional Windows shell integration enables you to run WinMerge compare operations directly from Windows Explorer, using WinMerge shortcuts in the context menu.

2.1. Windowsエクスプローラー統合を有効にする

The Windows Explorer shell integration is available only if enabled. You can enable it either during WinMerge installation or later, using the 「シェル統合ページ」 in the Options window. In the Options window, configure the Add to context menu option, including its suboptions if you like.

2.2. WinMergeショートカットを使用する

If you enable Add to context menu without the advanced menu suboption, the WinMerge shortcut is added to the Explorer context menu. For example:

To use the basic shell integration, begin by selecting two paths in Windows Explorer. Then, right-click and choose WinMerge in the context menu. For example:

WinMerge command in Windows Explorer context menu

WinMerge opens the paths directly in the File Compare or Folder Compare window.

The left and right sides are determined by the sort order in Windows Explorer. In the preceding screenshot, the Windows Explorer file list is in ascending order, so WinMerge opens with File2 on the 1st side and File1 on the 2nd..

注意

If either path cannot be opened for any reason, WinMerge opens the Select Files or Folders dialog, where you can specify new paths. Similarly, if you select only a single path, the Select Files or Folders dialog opens with the selected file or folder in the 1st field, leaving the 2nd path for you to specify.

The WinMerge shortcut is quick and easy to use, but you can compare only files or folders that you are able to select concurrently in Windows Explorer. For more flexible selections, consider enabling the advanced menu, described in the next section.

2.3. 高度なメニューの使用

If you choose the Enable advanced menu, the WinMerge shortcut is replaced with two Compare shortcuts:

Advanced WinMerge context menu

Use the Compare shortcuts in this order:

  1. Right-click the first path and choose Compare To. WinMerge stores the path in memory until you select the second path.

  2. If you decide that you have chosen the wrong first path, you can change it before choosing the second path:

    Right-click the new path and choose the Re-select First shortcut. The new selection overrides your previous path, and you can go on to the next step.

  3. Navigate to the second file or folder that you want to compare. The second path can be in any folder, or even in a different Windows Explorer window from the first path. Right-click the second path and choose Compare.

    WinMerge opens the File Compare or Folder Compare window, loading the first and second paths in the 1st and 2nd sides, respectively.

注意

If you click Compare before designating the first path, the Select Files or Folders dialog is opened, with your selection as the first (1st) path. Specify the second path in the 2nd field to continue with the comparison.

The Compare To paths is stored in memory until WinMerge is opened. As a result, you don't need to select both files at the same time or even using the same Windows Explorer view: you can choose one, open a different directory, and choose the other one. Both paths are discarded from memory after a compare operation. This means that you cannot select one Compare To path and compare it against several paths.

2.4. Windowsエクスプローラー統合使用時にサブフォルダーを含める

By default, folder compares that you do using the WinMerge or Compare shortcut are recursive. There is a way to launch non-recursive compares with the Windows Explorer integration:

  • Disable Include subfolders in the Folder page of the WinMerge Options dialog.

ティップ

Press Ctrl while selecting the WinMerge or Compare shortcut in the Windows Explorer context menu to force a reverse comparison with the current 'Include subfolders' settings.

3. ドラッグアンドドロップの使用

From any Windows source that allows you to drag objects, such as Windows Explorer or the Desktop, you can drag and drop one or two paths into the WinMerge window. If you drop only one path into WinMerge, the Select Files or Folders dialog opens for you to select the second path. If the single path specifies a project file, then the project file is opened.

By default, WinMerge does include subfolders in compare operations. To not include subfolders, press and hold Ctrl while dropping paths. Another useful key when dropping paths is Shift: To open the same path in both sides of a Compare window, press and hold Shift while dropping only one path. This is a handy way to open archive files (see 「アーカイブファイルを開く」).

You can drop paths into the Select Files or Folders dialog. A typical procedure is to drag and drop the first path into the WinMerge window, and then drag and drop the second path into the Select Files or Folders dialog. When a path is dropped into the Select Files or Folders dialog, it is loaded into either the 1st or 2nd path field:

1st

If the 1st field is empty or both path fields already contain paths

2nd

If the 1st path is not empty and the 2nd path is empty

4. Project files

You can save the currently open paths and filters in a project file. Then, you can easily open the project later to compare the same files. Project files are handy if you compare the same files repeatedly.

4.1. プロジェクトファイルの使用

To use a project file In the WinMerge window, click File → Open Project. WinMerge reads the paths from the project file. If the project file has two or three paths, two or three paths are opened. If only one path is given or one of the paths is invalid, WinMerge opens the Select Files or Folders dialog, where you can add or correct the path information. Here are a few things to consider:

  • If you specify two project files, the project files themselves are compared.
  • If you specify a project file as the left file but do not specify a right file, the single project file is opened as if you had used the File → Open Project command.
  • If you specify a project file as the left file and any other file on the right side, the contents of the project file and the other file are compared.

To specify a project file on the command line, simply enter it as a single file path.

4.2. プロジェクトファイルの編集と保存

To save a project file, click File → Save Project. The Project File dialog provides fields and options that you can easily edit to build a project file. If a compare window is currently open, the Project File dialog is initialized with values from the current compare; otherwise, you provide the values yourself. To use an existing project, click Open and select a project to load its values (any existing values are overwritten in the dialog).

When you finished editing, click Save to store the file.

Project File dialog

4.3. プロジェクトファイルフォーマット

Project files are simple XML files with a .WinMerge extension. For example:

<?xml version='1.0' encoding='UTF-8'?>
<project>
   <paths>
      <left>c:\work\project1</left>
      <left-readonly>1</left-readonly>
      <middle>c:\work\project2</middle>
      <middle-readonly>1</middle-readonly>
      <right>c:\work\project3</right>
      <right-readonly>0</right-readonly>
      <filter>Visual C++ loose</filter>
      <subfolders>0</subfolders>
   </paths>
</project>

A project file contains a paths element that can contain one of each of these elements:

left

Left path to open

left-desc

Left description

left-readonly

1 = Open read only

0 = Open normally

middle

Middle path to open

middle-desc

Middle description

middle-readonly

1 = Open read only

0 = Open normally

right

Right path to open

right-desc

Right description

right-readonly

1 = Open read only

0 = Open normally

filter

File filter name or list of extensions

subfolders

0 = Subfolders not included

1 = Subfolders included

unpacker

Unpacker plugin name or plugin pipeline

prediffer

Prediffer plugin name or plugin pipeline

window-type

1 = Text compare window

2 = Table compare window

3 = Binary compare window

4 = Image compare window

5 = Webpage compare window

table-delimiter

Delimiter for table editing

white-spaces

0 = Compare whitespaces

1 = Ignore whitespace changes

2 = Ignore all whitespaces

ignore-blank-lines

0 = Do not ignore blank lines

1 = Ignore blank lines

ignore-case

0 = Do not ignore case

1 = Ignore case

ignore-carriage-return-diff

0 = Do not ignore carriage return differences

1 = Ignore carriage return differences

ignore-numbers

0 = Do not ignore numbers

1 = Ignore numbers

ignore-codepage-diff

0 = Do not ignore codepage differences

1 = Ignore codepage differences

ignore-comment-diff

0 = Do not ignore comment differences

1 = Ignore comment differences

compare-method

0 = Full Contents

1 = Quick Contents

2 = Binary Contents

3 = Modified Date

4 = Modified Date and Size

5 = Size

None of the fields is required, and they can be empty (for example, <left></left> or <left/>).


フォルダーの比較とマージ

このトピックは、フォルダー比較ウィンドウを使用して、フォルダーを比較・マージする方法を説明しています。

1. フォルダー比較操作の開始

WinMergeウィンドウ、または、コマンドプロンプトから、フォルダー比較操作を開始できます。

From the WinMerge window

ファイル → 開くをクリックしてください。ファイルまたはフォルダーの選択ダイアログを使用して、比較する1と2のフォルダーを指定してください。デフォルトでは、フォルダー中のすべてのファイルが比較対象に含まれ、サブフォルダーも比較対象に含まれます。これらのオプションの変更と、ファイルまたはフォルダーの選択ダイアログのより詳細な情報については、ファイルとフォルダーを開くを参照してください。

From a Command Prompt window

WinMergeインストールディレクトリにある、WinMergeU.exeを起動してください。コマンド引数には、比較する1と2のフォルダーを含みます。デフォルトでは、フォルダー中のすべてのファイルが比較対象に含まれ、サブフォルダーは比較対象に含まれません。これらのオプションの変更と、その他のコマンドオプションの情報については、コマンドラインを参照してください。

Tips

Recursive mode

再帰モードは、全体のフォルダー構造の中から、差異ファイルを見つけたり、操作したりするのに便利です。しかしながら、多くのサブフォルダーやファイルがある場合は遅くなります。深くネストしたディレクトリ構造を、比較ウィンドウで操作し易くするためにTree viewを有効にすることを考えてください。

非再帰モードは、多くのサブフォルダーが存在しても、それらを検査する必要がないため、速度面で有利です。さらに、表示の管理もより簡単です。なぜなら、選択されたフォルダーの項目だけを表示すれば良いからです。

Quick Contents comparisons

ファイル比較のためのクイックコンテンツ方式は、オプションとコンフィグレーションで説明されています。これは、 巨大なバイナリファイルを比較する時に便利です。そしてそれは、4MBを超えるファイル比較の場合、自動的に使用されます。起こりうる不都合としては、ラインフィルターが効かないことと、フォルダー比較ウィンドウに差異カウントが表示されません。しかし、これは、ほとんどのケースで取るに足らないことです。なぜなら、そのような巨大なファイルは、たいていバイナリだからです。

この方式を使用するために、比較操作をする前に設定をしてください。WinMergeオプションの比較カテゴリで、ファイル比較方法のドロップダウンメニューをクリックし、クイックコンテンツを選択してください。

For advanced users

例えば、とても大きなテキストファイルがたくさんある場合など、クイックコンテンツの境界ファイルサイズを4MBから変更することが可能です。その方法は、Windowsのregeditコマンドを起動し、

HKEY_CURRENT_USER\Software\Thingamahoochie\WinMerge\Settings\QuickMethodLimit

このキーワードを探し、値を変更してください。レジストリの編集は慎重に行ってください。

1.1. フォルダー比較状況ウィンドウ

フォルダー比較操作を開始すると、WinMergeはこのステータスウィンドウを表示します。

比較操作が素早い場合、WinMergeはフォルダー比較結果を表示して、直ぐにそれを閉じるため、プログレスウィンドウに気づかないかもしれません。プログレスウィンドウは、その操作対象に含まれるファイルとフォルダーの数と、比較した項目の数を表示します。プログレスバーは、比較した項目をグラフィカルに表示します。

注意

ファイル比較では大抵サイズが異なるため、ステータスは、経過時間、または、残り時間を表示しません。例えば、50/100という比率は、必ずしも比較操作の半分の時間が完了した、ということを表しません。

停止をクリックすると、比較操作が終了する前に、いつでも操作を中止できます。フォルダー比較ウィンドウは、未完了の結果を省略して、その時に計算された結果で表示されます。

2. フォルダー比較ウィンドウ

フォルダー比較ウィンドウは、フォルダー比較の結果を表示します。二つの異なるビューが使用できます。

Tabular view

テーブルビューでは、ファイルやフォルダーは、それぞれが行に表示されます。これは、デフォルトのビューです。ここに例を示します。

Tree view

ツリービューでは、フォルダーは含んでいるファイルやサブフォルダーを、展開したり畳んだりできます。ツリービューは、再帰比較(サブフォルダーを含む)モードでのみ有効です。例えば、

  • 単独のフォルダーを展開したり、折り畳んだりするには、フォルダーアイコンの隣にある、プラス、または、マイナス記号をクリックするか、行のどこかをダブルクリックしてください。

  • ビュー内のすべてのフォルダーを展開、または、折りたたむには、メニューの表示 → サブフォルダーの展開 → すべてのサブフォルダーをクリック、または、表示 → すべてのサブフォルダーを折りたたむをクリックしてください。

再帰的に比較している間に、(ファイルまたはフォルダーの選択ダイアログで、サブフォルダーを含むオプションを有効にした場合)、表示 → ツリー表示をクリックして、二つのビューを切り替えることができます。表示 → ツリー表示コマンドは、非再帰比較モードでは無効です。

両方のビューで、列はそれぞれの結果項目に対して、異なるタイプのデータを表示します。ビューで、列ヘッダをクリックすることで、項目のソート順を操作できます。ソート順を変更するには、二つの方法があります。

  • 列のソート順をトグル(反対に)する。

  • その列によって、ビュー中の全行を再ソートする。

2.1. 再帰的と非再帰的比較結果

フォルダー比較ウィンドウは、再帰比較モードと非再帰比較モードで、見た目と挙動が少しばかり異なります。

Recursive folder compare

比較結果は、すべてのサブフォルダーが含まれています。表示メニューのオプションによって、フォルダーに含まれる項目のうち、表示される項目のタイプをコントロールできます(例えば、同一項目の表示)。 フォルダー列は、常に空で、フォルダーの中にあるファイルだけが表示されています。一つの項目のサブフォルダーを見て、比較結果列の項目のパスを見てください。表示メニューの、左側のみに存在する項目の表示、中央のみに存在する項目の表示、または、右側のみに存在する項目の表示が有効になっている場合、片方だけに存在するフォルダーが表示されます。

Nonrecursive folder compare

結果は、選択されたフォルダーのファイルと、最上位のサブフォルダーのみを含んでいます。しかしながら、いくつかのサブフォルダーを比較したいなら、それらをブラウズすることができます。

2.2. ファイル・フォルダーアイコン

フォルダー比較ウィンドウの中で、ファイルとフォルダーは比較され、いくつかのカテゴリに分類されます。カテゴリは、各行の左側の列で、これらのアイコンのうちの一つにより明確に識別されます。

同一のテキストファイル
同一のバイナリファイル
同一のファイル(タイプ未確定)
異なるテキストファイル
異なるバイナリファイル
異なるファイル(タイプ未確定)
同一のフォルダー(ツリービューのみ)
異なるフォルダー(ツリービューのみ)
左のみに存在するフォルダー
中央のみに存在するフォルダー
右のみに存在するフォルダー
左のみに存在するファイル
中央のみに存在するファイル
右のみに存在するファイル
スキップ(フィルター)されたフォルダー
スキップ(フィルター)されたファイル
比較できなかった項目。例えば、ファイルが他のプログラムにロックされていたなど。
中断された項目。WinMergeは、比較が中止された時に、この項目の比較を終了していなかった。結果は不明。

2.3. フォルダー比較ウィンドウの操作

キーボードと同様にマウスを使用して、フォルダー比較ウィンドウをコンテキストメニューでナビゲートできます。例えば、 次の差異ボタン 次の差異ボタンは、ファイル、または、フォルダーの次の差異を見つけ、選択します。

注意

ユニークなファイルやフォルダーは、異なるそれと同様の方法でナビゲートされます。

複数のファイルやフォルダーを選択することができます。しかしながら、いくつかの操作(リネームなど)は、複数選択時は無効です。

ナビゲーションボタンを使って、比較されたファイル中の差異を(次の差異, 前の差異など)横断してください。WinMergeの機能を使って、ファイルやサブフォルダーをマージ、コピー、移動、または、削除してください。

3. フォルダー比較のファイル操作

フォルダー比較ウィンドウは、編集、コピー、削除、移動やリネームなど、ファイルに対する一般的な操作をサポートしています (移動は、コピーして削除するのと等価です)。 これらのファイル操作と、フォルダーコンテンツのマージなど、 幾つかの特別なWinMergeの機能を使用することができます。 ファイルを、関連付られたプログラム、または、外部エディターで開くこともできます。

これらのタスクを実行するための最も手近な方法は、一つか複数の項目を右クリックして、すべてのファイル操作が有効なコンテキストメニューを使うことです。

3.1. ファイルのコピー

フォルダー比較ウィンドウ中で最も一般的なファイル操作は、左右にファイルをコピーすることです。WinMergeのコピー機能には、幾つかの形があります。同一ファイルのコピーはマージにおいて使用しないので、異なるファイルのみをすべてコピーする。このコピー機能は、コンテキストメニュー、WinMergeメニュー、そしてツールバーで有効です。

3.1.1. コンテキストメニューの[コピー]メニュー項目

フォルダー比較ウィンドウのコンテキストメニューで、コピーは、4つのショートカットを含んだサブメニュー項目です。

Folder Compare window Copy context menu

  • 左から右と右を左には、一方から他方へ選択項目をコピーします。例の中で、後ろの(2 of 4)は、コピーされる項目の内、2ファイルに差異があるということを示しています(同一のファイルはコピーされません)。これらのショートカットは、差異のあるファイルを選択した場合にのみ有効です。ですので、同一のファイルだけを選択した場合、このショートカットは無効になっています。

  • 左を...と右を...で、比較フォルダーの代わりに、システム中のコピー先フォルダーを指定することができます。フォルダーダイアログが開くので、お使いのシステム中のフォルダーを選択(または、フォルダーを新規作成)し、OKをクリックしてください。

In the Folder Compare window with three folders, the Copy item has a submenu with nine shortcuts:

Folder Compare window Copy context menu

3.1.2. ツールバーと[コピー]メニューコマンド

フォルダー比較ツールバーの、 右へコピーボタン 右へコピーと 左へコピーボタン 左へコピーは、コンテキストメニューの左から右と右を左にと同じ働きをします。これは、they copy from side to side only files that are valid to copy. しかしながら、これらのコマンドは、コピーされるファイル数を直接表示しません。その代わり、コピー元とコピー先をチェックできる確認ダイアログを表示します。

WinMergeメニューの、マージ → 右にコピーとマージ → 左にコピーは、ツールバーのコピーコマンドと同じ動作をします。

3.2. ファイルの削除

コンテキストメニューの削除を使って、どちらか一方、または、両側の選択されたアイテムを削除できます。その他のファイル操作と同様に、削除は、左側、中央と右、そして両側というサブメニューを持っています。

警告

削除されたファイルをゴミ箱に移動するオプションを有効にしたままにすることをオススメします。 オプションとコンフィグレーション)を参照してください。アクシデントが起きた場合、削除をアンドゥすることができます。さらに、ゴミ箱は有効にしておくべきです。Windows上で、ゴミ箱を無効にした場合、WinMergeのオプションは働きません。もう一度。WinMergeの削除されたファイルをゴミ箱に移動するオプションとWindowsのゴミ箱の両方を使用しない限り、ファイル、または、フォルダーの削除のアンドゥはできません！

3.3. ファイル名の変更

ファイル、または、フォルダーをリネームするには、コンテキストメニューの名前を変更、または、F2キーを押下してください。エディットボックス内でReturnキーを押下すると、名前を変更します。また、Escキーを押下するとキャンセルします。一つのファイル、または、フォルダーをリネームできます。リネームは、両側(または3つすべて)のアイテムを変更することに注意してください。現在、片側のアイテムだけのリネームはできません。

3.4. ファイルを開く

コンテキストメニューの、左側を開く、中央を開くと右側を開くのどちらかを使用して、アイテムを操作することができます。それぞれの開くメニューは、いくつかのショートカットを含んだ、サブメニューを持っています。

With Registered Application

Windowsで登録されているファイルタイプに対応したアプリケーションで、ファイルを開きます。

ティップ

このショートカットは、いつも新しいWindowsエクスプローラーでフォルダーを開きます。

With External Editor

外部エディターでファイルを開くデフォルトエディターはメモ帳ですが、WinMergeのオプションで、別のエディターを設定することがきます。

With...

Open Withダイアログを開き、指定したアプリケーションでファイルを開くことができます。

3.5. パス名やファイル名のコピー

コンテキストメニューパス名をコピーとファイル名をコピーショートカットは、選択されたアイテムのパス名、または、ファイル名をWindowsのクリップボードへコピーします。さらに、コピーされた情報を、ファイル、または、アプリケーションへ貼り付けることができます。例えば、変更されたファイルのリストの作成や、チェンジログなど。

  • パス名をコピーは、他のファイル操作と同じような、3つのショートカットを持っています。これは、1つ、または、複数の選択されたアイテムのフルパス名を、1アイテム1行として、クリップボードへコピーします。

  • ファイル名をコピーは、パスを除いたファイル名だけをコピーします。

3.6. ファイルの保護

どちらか片側のファイルとフォルダーを変更から保護するには、 ファイル → 左側を読み取り専用, File → 中央を読み取り専用、または、ファイル → 右側を読み取り専用のチェックボックスを有効にします。

重要項目

ファイルとフォルダーの読み取り専用オプションは、現在の比較ビューのみの設定です。 これらのファイルの、Windows上の属性には影響ありません。

この読み取り専用状態は、フォルダー比較で開いたファイルにも継承されます。例えば、2つのフォルダーの比較で、片側を読み取り専用にセットし、比較のため2つのファイルを開いた場合、 読み取り専用がセットされた側のファイルは書き込み保護されています。同じように、読み取り専用でない側から、 読み取り専用側へのファイルコピーはできません。

左側、中央、右側のペインのステータスバー(ウィンドウの右下付近)のROの記号は、 そちら側が読み取り専用であることを表しています。

3.7. ビュー内の選択された項目を再比較する

大きなフォルダーをフルリフレッシュするには長時間かかります。 WinMerge 2.2 か、それ以前では、WinMergeの外でファイルを編集した後はいつも、フルリフレッシュしなければなりませんでした。 バージョン2.4から、WinMergeは、選択されたアイテムだけをリフレッシュできるようになりました。 コンテキストメニューの選択項目を最新更新、または、 メインメニューから、表示 → 最新の情報に更新を選んでください。

3.8. ファイルの圧縮

コンテキストメニューの圧縮を使って、 選択したアイテムを含んだ新しいアーカイブファイルを作成します。

注意

アーカイブサポートは、 WinMerge 7-Zipプラグインがインストールされている必要があります。

圧縮メニューアイテムは、4つのショートカットを含むサブメニューを持っています。

左側

左側のファイルとフォルダーを再帰的にアーカイブファイルに加えます

中央

中央のファイルとフォルダーを再帰的にアーカイブファイルに加えます

右側

右側のファイルとフォルダーを再帰的にアーカイブファイルに加えます

両側

両側のファイルとフォルダーを再帰的にアーカイブファイルに加えますファイル名が同じため、これらは、アーカイブ中のOriginalと Alteredという名前の、別のサブフォルダーへ入れられます。 左側のファイルは、Originalへ、 右側のファイルは、Alteredへ格納されます。

All

Adds files and folders recursively from all sides to the archive file. Because the filenames are same, they are added to different subfolders, named Original and Altered, inside the archive: left-side files are put to Original, and right-side files are put into Altered.

差異

両側とほぼ同じですが、両側で差異があるファイル(片側にしかないファイルを含む)のみを アーカイブファイルへ加えます

圧縮ショートカットの内のどれかを選択すると、 Save As ダイアログが表示され、 アーカイブファイル名とタイプの入力を促します。WinMergeで、既に存在するアーカイブファイルへのファイル追加はできません。 常に、新しいアーカイブファイルを作成します。

ティップ

WinMergeは、アーカイブファイルの中の、両側で同じ名前のファイルを比較することができます。WinMergeは、サブフォルダーOriginalとAlteredを探し、これら2つのフォルダーの内容を比較します。

フォルダー比較が、アーカイブファイルの内容を含む場合、 WinMerge中で行われたそれらのファイルへの変更(例えば、 開くを使用したファイル編集)は、アーカイブファイル中に保存されます。 しかし、WinMergeのコピー、移動, 、削除操作では、 アーカイブファイルの内容を更新することはできません。代わりに、圧縮ショートカットのうちのどれかを使用して、 新しいアーカイブファイルを作成してください。

4. ファイル比較ウィンドウでフォルダーをブラウズする

このセクションでは、フォルダー比較ウィンドウに表示されている、 フォルダーをブラウズする方法について述べます。 フォルダーをブラウズする時は、全く新しい比較操作を実行します。その結果は、ウィンドウ中の現在の比較結果に上書きします。

4.1. 非再帰的比較でフォルダーをブラウズする

たとえ、非再帰的なフォルダー比較がサブフォルダーの内容を含まないとしても、 サブフォルダーは結果にファイルとしてリストされます。同様に、比較フォルダーの親フォルダーは、 表の一番上にファイルとしてリストされます。直接、フォルダー比較ウィンドウでこれらのフォルダーをくことにより、 ディレクトリツリーを選択的にブラウズすることができます。このアプローチ - あなたが興味のあるサブフォルダーだけを比較することは、 ディレクトリツリー全体を再帰的に比較するより、より効果的です。

Browsing the parent folder

親フォルダーの比較は、(一番上にあるパス..) [image] の行をダブルクリックするか、その行を選択して Enterキーを押下してください。

時々、(あなたがアクセス権を持っていない時などは)親フォルダーを開くことができません。 これら2つのアイコンは、親フォルダーが開けるかどうかを表しています。

親フォルダーを開くことができます。
親フォルダーを開くことができません。
両側(または3つすべてに)存在する単一のサブフォルダーをブラウズする

両側に存在する単一のサブフォルダーを比較するには、 フォルダー比較ウィンドウ内のフォルダーをダブルクリックしてください。

片側にだけ存在するサブフォルダーをブラウズする

左、または、右側にだけ存在するフォルダーをブラウズする場合、 WinMergeは、もう一方にマッチするフォルダーを新しく作成することができます。詳細は、「ユニークフォルダーのブラウズ」を参照してください。

2つの異なるサブフォルダーをブラウズする

それぞれのサブフォルダーが異なる2つのサブフォルダー(つまり2行選択している)を 比較することはできませんただ、以前に同一のフォルダーを比較している場合 (例えば、比較結果中の単一のサブフォルダーをブラウズするなど)は、 2つのサブフォルダーを比較することができます。 次の図に示すように、まず、フォルダー比較ウィンドウ中の2つのフォルダーを選択してください。

Folder Compare window, two folders selected

選択する順番は重要です。最初に選択したフォルダーは、結果の左側のフォルダー、 二番目に選択したフォルダーは、右側のフォルダーになります。

2つのフォルダーが選択された状態で、右クリックし比較(または、メニューのマージ → 比較)を選択してください。

ティップ

さらに、比較操作は、 先のスクリーンショットが示すように、 フォルダー比較ウィンドウ中の、現在の左側と右側のフォルダーのパスが同一の場合にのみ有効です。 例えば、カレントウィンドウが2つの異なるフォルダー比較の場合、これは有効ではありません。

4.2. ユニークフォルダーのブラウズ

WinMergeは、存在するフォルダーと存在しないフォルダーを比較できなかったため、 WinMerge 2.6か、それ以前のバージョンでは、ユニークなフォルダー(比較結果の片側のみに存在するフォルダー) をブラウズできません。 WinMergeで、ユニークなフォルダーから何かコピーするには、 はじめにフォルダー構造全体をコピーしなければなりませんでした。

しかしながら、フォルダー構造全体をコピーすることを好まないかもしれません。 バージョン2.8以降では、WinMergeは、代わりに新しい空のフォルダーを作成する方法を提供します。 これは、作成された空のフォルダーへ、元のユニークなフォルダーから必要な要素だけをコピーすることができます。 この手順を示します。

  1. ユニークフォルダーをブラウズ(フォルダーを選択してEnterを押下するか、それをダブルクリック、または、右クリックし、比較を選択)してください。例えば、

    Folder Compare window, comparing unique folder

    WinMergeのメッセージは、フォルダーが片側のみに存在し、 開くことができなかったことを知らせています。 このメッセージは、一致するフォルダーを作成し、比較結果の片側として開くかどうかを確認します。

  2. はいをクリックすると確定 (いいえは比較をキャンセル)します。新たな比較結果では、 ユニークなフォルダーは左側に、新しく作成された空のフォルダーは右側に開かれます。

    Folder Compare window after browsing to unique and created folders

    比較結果では、アイテムを(例えば、右クリックのコンテキストメニューを使って) ユニークなフォルダーから作成されたフォルダーへコピー、または、移動することができます。

5. フォルダー比較のカスタマイズ

このセクションでは、フォルダー比較ウィンドウの表示結果を制御する方法について説明します。 表の列の、表示・非表示、並べ替えの表示をカスタマイズすることができます。

5.1. ファイルの種類による表示/非表示

表示メニューは、 アイテムの種類を表示・非表示にするショートカットを含んでいます。 有効(チェック)にすると、そのアイテムは表示され、無効にすると、そのアイテムは非表示になります。

  • 同一項目の表示:同一として検出したファイル

  • 差異項目の表示:差異として検出したファイル

  • 左側のみに存在する項目の表示: 左側のみに存在するファイルとディレクトリ

  • 中央のみに存在する項目の表示: 中央のみに存在するファイルとディレクトリ

  • 右側のみに存在する項目の表示: 右側のみに存在するファイルとディレクトリ

  • スキップされた項目の表示: ファイルフィルターにより省かれたファイルとディレクトリ

  • バイナリファイルの表示:バイナリとして検出されたファイル

5.2. 列ソートの変更

フォルダー比較ウィンドウの行は、特定の列のソート順によって並べられます。 このソート列は、ヘッダーの小さな矢印によって表されます。 矢印が上向きの場合は昇順に、下向きの場合は降順で列はソートされています。 このトピックの上部にあるフォルダー比較の例は、 ファイル名の列で昇順にソートされています。

他の順序列を選択するには、単にその列ヘッダーをクリックしてください。 選択した列は、そのデフォルトソート順に設定され、 すべての行は列のソート順によって並べ替えられます。

既にソート列になっている列のソート方向を変更するには、そのヘッダを再度クリックしてください。 これはつまり、ソート列のヘッダをクリックするとその順序を逆にする (昇順と降順を切り替える)ということです。

5.3. 列の追加、削除、順序変更

フォルダー比較ウィンドウに表示されている列を変更するには

  1. これらの列ヘッダーを右クリックし、列の設定 か、ツール → 列の設定を選択してください。

  2. 列表示ダイアログは、それぞれチェックボックスとともに、すべての有効な列名を含んでいます。 これらのアクションを組み合わせて列を設定します。

    • 表示したい列にチェック (リスト中のアイテムを選択するだけでは不十分なことに注意)してください。

    • 非表示にしたい列のチェックを外してください。

    • 列の順序を変更するには、1つかそれより多くのアイテムを選択し、 上へか下へ をクリックしてください。

    • カスタム設定を上書きして、デフォルトのWinMergeの列設定に戻したい場合は、 デフォルトをクリックしてください。

  3. OKをクリックしてください。

The following columns in the Display Columns dialog are displayed by default in the Folder Compare window:

  • ファイル名: 比較されたアイテムの名前非再帰比較では、この列はファイルとフォルダーの両方を含んでいます。 再帰比較では、フォルダーは含まれていません。 代わりに、フォルダーはフォルダー列に表示されます。

  • フォルダー: 比較されたサブフォルダーの、 比較フォルダーからの相対パス非再帰比較の場合、この列はいつも空です。 フォルダーは、代わりにファイル名列に表示されています。

  • 比較結果: 冗長な比較結果 (簡易結果表示も参照してください)

  • 左日付、中日付、右日付: それぞれの側のアイテムの更新日2つの日付のうち新しい方 (または、同一のアイテムの日付)の後ろには、アスタリスク( * )が付いています。

  • 拡張子: ソートに便利なファイルの拡張子

次の追加列が、列表示ダイアログで使用可能です。

  • 簡易結果表示:比較結果列を簡潔な形式で表示します。

  • バイナリ: ファイルがバイナリファイルの場合、 列にアスタリスク( * )が含まれます。 簡易結果表示列は、ソートに使用するために便利です。

  • 左属性、中属性、右属性: ファイル属性を表示します。

  • 左作成日時、中作成日時、右作成日時: アイテム作成日時

  • 左エンコーディング、中エンコーディング、右エンコーディング: ファイルエンコーディング。ANSIファイルはコードページ番号を、UnicodeファイルはUnicodeエンコーディング名を表示します。

  • 左ファイルバージョン、中ファイルバージョン、右ファイルバージョン: 存在する場合、ファイルのバージョン番号Note that the version is read only for some binary file types known to usually have a version resource.

  • 左サイズ、中サイズ、右サイズ: ファイルサイズ(byte)

  • 左サイズ(短縮)、中サイズ(短縮)、右サイズ (短縮): KB, MB, GBに丸められた短縮バージョンのファイルサイズ

  • 新しいファイル: どちら側が新しいかを表示します

  • 差異数: ファイル間で見つかった差異の数(無視された差異を除く)

  • 無視された差異数: ファイル中の無視された差異数これらは、行フィルターによって無視された差異です。

  • 左EOL、中EOL、右EOL: ファイルのEOL(改行)スタイルを表示

5.4. 項目の非表示

コンテキストメニューの項目を非表示を使って、 1つ、または、複数の選択項目を素早く非表示にすることができます。 そのアイテムは、ビューを更新(F5を押下)するか、 表示 → 非表示の項目を表示をクリックするまで、非表示のままです。

ティップ

項目を非表示について知る: 処理済や、 現在興味が無いファイルを除外して、多くの時間を節約することができます。 例えば、どのファイルのマージが残っているかわかり易くするために、 マージした後にファイルを非表示にするかもしれません。

6. フォルダー比較ウィンドウから、Windowsのシェルコマンドを使う

フォルダー比較ウィンドウ内で選択項目を右クリックし、 コンテキストメニューから直接Windowsのシェルコマンドを起動することができます。

両側を選択した場合、左側シェルメニュー、中央シェルメニューか 右側シェルメニューのどちらかを選ぶことができます。 アイテムが片側だけにある場合、そちら側のシェルメニューのみが有効です。

注意

シェルメニューコマンドは、完全にWinMergeの外側で実行されることを、よく考えてください。 つまり、WinMergeは、WinMerge内部で実行される操作と同じ方法で、 いくつかの操作に応答しないかもしれません。 例えば、WinMergeの削除コマンドの代りに、 このシェル統合を介してファイルを削除すると、その変更はフォルダー比較ウィンドウ内に、 自動的には表示されません(変更を見るためには、手動でリフレッシュしなければなりません)。


テキストファイルの比較とマージ

This topic describes how to use the WinMerge File Compare window to compare and merge text files. To understand the basic concepts about differences discussed here, we suggest you read ファイル比較とマージの概観 first. See Hex形式比較 for related information about hex files.

1. ファイル比較操作を開始する

You can start a file compare operation from either the WinMerge window or a Command Prompt window.

From the WinMerge window

Click File → Open. Use the Select Files or Folders dialog to specify the left and right source files to compare. For more details about the Select Files or Folder dialog, see ファイルとフォルダーを開く.

From a Command Prompt window

Run WinMergeU.exe, which is in your WinMerge install directory. In your command arguments, include the left and right files to compare. For more information about using the command line, see コマンドライン.

2. ファイル比較ウィンドウ

The File Compare window displays compared files in two File panes, side by side. The WinMerge toolbar and context menu provides functions for viewing, navigating, and merging differences. The screenshot below shows a comparison of two versions of a file.

2.1. ファイルペイン

The left and right File panes show the text contents and differences of the two files being compared. The File panes are the main area for navigating and merging differences, and also allow you to edit the text directly. This section describes the features that support these actions, and ways that you can customize the File panes.

2.1.1. ファイルペインヘッダー

The header at the top of each File pane shows the full path of the source file. The left and right file names are also identified in the header of the Compare Window, above the File panes.

One of the File panes is always active (indicated by the dark header background); the other is inactive and has a lighter header bar. You can edit only in the active pane (as described in 「ファイルペイン編集機能」). Click in either side to make it active and make the other side inactive.

An asterisk (*) before the filename in the header indicates that there are unsaved changes in the file.

The header bar's context menu has shortcuts that are useful for copying and pasting file information:

Copy Full Path

Copies the full path of the source file into the system clipboard.

Copy Filename

Copies just the source filename into the system clipboard.

2.1.2. 差異の強調表示

WinMerge highlights several types of differences in the File panes. The Colors page in the Options dialog defines a set of background and text colors for most difference types, with variations indicating their state: unselected, selected, or deleted. This section describes how each of the basic difference types is detected and displayed.

Difference

A difference block contains one or more contiguous lines that are different. The default difference background color is gold, but blank lines are marked with the deleted color.

For this and other screens in this section, we enabled View line numbers to show which lines in the source files are compared.

Difference block background colors

This comparison detects three difference blocks:

  1. The first difference is a single line.

  2. The blank line in file2 has no corresponding blank line in file1. WinMerge treats the missing blank line as a deleted difference, marked here with the default gray color.

  3. The last difference block includes two lines.

Ignored Difference

This color marks content that you have configured WinMerge to ignore. In contrast to difference blocks, ignored content is not compared, it is simply highlighted to help you see what has been ignored. Ignored differences include:

  • Blank lines, if you have enabled Ignore blank lines in the Options dialog Compare page.

  • Differences that match patterns in line filters that you have defined (see フィルターの使用 to learn how).

The next example repeats the previous comparison, this time with Ignore blank lines enabled. There are now only two differences. The blank line on the right side is marked with the Ignored Differences color.

Difference block colors with ignored diff

Moved

Moved differences are identical lines found in different locations in the compared files, if Moved block detection is enabled in the Options dialog Compare page. The next screenshot repeats the previous comparison, this time with moved block detection enabled.

Difference block colors with moved block detection

Notice that the two identical lines (containing a and c) that are in different locations are marked with the default orange moved color. Another effect of moved block detection in this case is that the last two lines are now two separate differences instead of a single difference block.

In some cases, showing moved differences can make it easier to visualize changes in files. However, too many moved lines might make your comparison hard to navigate. Use your own judgement!

Word Difference

WinMerge can mark the text that is changed with difference blocks. Line differences are marked with the word difference color. See 「行内差異の強調表示」 for details.

Similar lines

WinMerge tries to match similar lines within difference blocks when you enable Match similar lines in the Options dialog Compare page. What does 「similar」 mean? Generally, this feature works best in simple cases, for example where lines that have strong similarities. When detected, similar lines are adjusted to align in the File pane. The next figure shows comparisons of the same two files, before and after enabling the Match similar lines option:

Disabled: Compare without matching similar lines Enabled: Compare matching similar lines

In the second comparison, the lines 「mice」 and 「mice and a」 are detected as similar. WinMerge adds blank lines in the display to make these lines appear at the same level within the difference block.

2.1.3. 行内差異の強調表示

Sometimes it's useful to highlight not just difference blocks, but also the text within them that is changed. You can disable or enable them in two ways:

  • Set all View line differences options in the Options dialog Editor page.

  • Click View → View line differences to toggle line differences on or off.

注意

Remember that WinMerge navigation and merging functions (like Next Difference or Copy Left) work on difference blocks, not on line differences within them.

This section describes how line differences are detected and marked. Note that the effect of these options is also affected by your current whitespace settings in the Options dialog Compare page.

Word-level line differences

The following examples show how word-level line differences are displayed with each of the whitespace settings:

例1 Line differences with Whitespace: Compare

WinMerge detects all different words and spaces:

Word-level line diff comparing whitespace

例2 Line differences with Whitespace: Ignore change

Multiple spaces and tabs are treated the same as a single space. In the example, the extra space between the last two words is not marked:

Word-level line diff comparing no whitespace changes

例3 Line differences with Whitespace: Ignoring all

No spaces between words are compared, so these lines are treated as identical:

Word-level line diff comparing no whitespace

Character-level line differences

A character-level line difference includes the first and last different characters in a word, and all the characters between them. A single character-level difference can span adjacent words. The following example illustrates:

Character-level line diff comparing no whitespace

注意

As with word-level line differences, character highlighting varies according to how WinMerge is configured to detect word breaks. In the example, the extra space after the word cure in file2 is highlighted only if whitespace is compared.

Breaks for words or character

Words and characters in line differences can be separated by whitespace, or by a combination of whitespace and punctuation. Whitespace (the default) is the typical choice for comparing most text files. All the preceding line difference examples use whitespace to break words and characters.

In some cases it's useful to break at punctuation. For example, the next screenshot compares a comma-separated list. To highlight meaningful line differences, we have enabled Break at whitespace or punctuation in the Options dialog Editor page.

Character-level line diff comparing no whitespace

2.1.4. ファイルペイン編集機能

Although WinMerge is a not a full-featured editor or IDE, it does provide basic editing functions, like Undo and Redo, Find and Replace, and Go to. These basic editing tasks are often needed during merging (for example, to change text within differences). You can edit in the active File pane (remember, click in a pane to make it active). Changes are not written to a file until you save a pane to a result file.

WinMerge editing features also include syntax highlighting. This optional feature supports several file formats, and you can configure the colors used. Note that syntax highlighting is not applied within differences, as the preceding screenshot shows.

ティップ

Make sure that Automatic rescan is enabled, as described in 「ファイルの再スキャン」. If it is not, manually refresh your view (press F5) before and after editing a file, to ensure that WinMerge difference detection is up to date.

2.1.5. ファイルペインのフォント

You can choose fonts for the File pane by clicking View → Select Font. WinMerge supports only fixed width fonts.

Here are font suggestions for using WinMerge with East Asian languages:

  • Simplified Chinese: SimSun or SimHei fixed-width fonts
  • Traditional Chinese: MingLiU fixed-width font
  • Japanese: MS Gothic or MS Mincho fixed-width fonts
  • Korean: GulimChe fixed-width font (not Gulim, because this variant uses proportional-spacing glyphs that are not centered in grid cells and poorly aligned in fixed-width mode).

2.1.6. ファイルペインのマージン

The File panes have optional gray margins that show line numbers and some symbols. To show or hide the margins, clicking View → View Margins. If you are using multiple File Compare windows, you can control margins for each window independently. The margin can show any or all of these features:

  • Line numbers, if View → View Line Numbers is enabled.

  • Bookmarks, if Edit → Bookmarks is enabled. A bookmark is a blue circle, in the margin next to a line, that you can make WinMerge remember and return to.

    • To set a bookmark on a line, double-click in its margin (or press Ctrl+F2). The same action deletes an existing bookmark.

    • To navigate bookmarks, click Edit → Bookmarks and choose Next or Previous.

    • Double-click a single bookmark to delete it (or press Ctrl+F2).

    • Click Edit → Bookmarks → Clear All Bookmarks to delete all bookmarks.

  • Word wrap arrow symbols, if View → Wrap Lines is enabled.

The following screenshot shows a margin with bookmarks and word wrap enabled. Without line numbers, the margin width is minimal.

File Compare window margin with bookmark and word wrap

The next screenshot shows a margin with bookmarks and line numbers enabled. Notice that the margin is wider. In fact, the margin is wide enough for the largest line number. Thus, the margins for large files with many lines can be quite wide.

File Compare window margin with bookmark and line numbers

2.2. ツールバーとメニュー

The WinMerge toolbar and menus provide a range of functions to navigate, select, and merge differences within files.

注意

WinMerge shortcuts have the same names and buttons whether you open a Folder Compare or File Compare window. However, the functions behave differently: with a File Compare window, the functions operate on differences within files, not on differences within folders.

The difference functions you can use depend on your context, which often changes as you work. This means that a function is available only when its operation is possible for a given location or other condition in your WinMerge environment. For example, if you click in a line of text within a difference, you might notice several navigation and merge buttons become enabled in the toolbar. If you click in another area of text that is not within a difference, these functions become unavailable.

Difference functions are available in the WinMerge toolbar,and also through these alternate mechanisms:

  • WinMerge menus, especially Merge

  • Context menus within the File Compare window (when you right-click in text)

  • Keyboard shortcuts

Difference functions are described in 「差異への移動」 and 「差異のマージ」, later in this topic. クイックスタート and ファイル比較とマージの概観 provide examples of comparing and merging.

2.2.1. マージモード

File → Merge Mode (or press F9) restores these WinMerge 1.7.1 single keyboard shortcuts for difference merging and navigating functions:

  • Up and Down keys for the Previous Difference and Next Difference functions.

  • Left and Right keys for the Copy Left and Copy Right functions.

Merge mode omits the Alt key for these common operations (making them quicker to use than the normal mode). Note that the Shift and Alt Arrow key combinations work in merge mode in the same way as normal mode.

Merge mode is indicated in the status bar by the text Merge.

2.3. ロケーションペイン

The Location pane, to the left of the File panes, maps the entire length of the compared files into two vertical bars (corresponding to the left and right File panes). It is especially useful for working with files that are too long to easily navigate in the File panes.

The Location pane shows several kinds of items:

Location pane diff lines Difference blocks

Each difference block in the File panes is indicated in the Location pane by a horizontal line across each vertical bar. The thickness, color , and locations of these lines are clues about of the size (number of lines), types and distribution of all differences in the files. For example, the color of a line is the same as the color of the corresponding difference block. The Location pane in the preceding screenshot shows many basic differences (gold) and some empty difference blocks (gray).

Location pane current diff pointer Current difference

If you have selected a difference, the Location pane marks the current difference line with a pair of small triangles on either side of the vertical bars. If you navigate to another difference, the pointer moves up or down with the location. Scrolling the File pane does not change the location of the difference pointer (or any of the difference lines) in the location pane.

Location pane view area bar View area

The area of the files currently visible in the File panes is indicated by a shaded (translucent) view bar over the Location pane. The area bar's height and location correspond to the portion of the files that is visible in the scroll region. For example, you might see the bar expand or shrink if you change the height of your File panes. This synchronization of the Location pane view bar and File panes enables quick navigation, and some useful actions:

  • When you scroll the File panes, the view area in the Location pane moves with it.

  • Conversely, you can drag the view area bar in the Location pane up or down to scroll the File panes. This scrollbar thumb action is very handy for navigating long files.

  • Click anywhere in the Location pane to jump to the corresponding location in the File panes.

Moved differences

Moved differences are identical lines in different locations. They are shown only if the Enable moved block detection is checked in the Options dialog Compare page. See 「差異の強調表示」 for more details about moved differences in the File pane. The Location pane draws a line connecting moved differences in the left and right location bars. For example:

Location pane with moved diff

The Location pane's context menu contains these shortcuts:

  • Go to Line 1: Moves the cursor to the top of the file.

  • Go to: Moves the cursor to a line you specify (described in 「ナビゲーション機能」).

  • No Moved Blocks: Turns off moved difference color for moved blocks.

  • All Moved Blocks: Turns on moved difference color for all moved blocks.

  • Moved Block for Current Diff: Turns on moved difference color only for current selected moved difference.

2.4. Diff ペイン

The Diff pane shows the contents of the two sides of a selected difference.

When you select a difference, the two versions are loaded in the upper and lower sides of the Diff pane. In this way, the Diff pane confirms which lines are included in a difference, and lets you examine them in isolation from the rest of the file.

You can merge differences directly in the Diff pane by right-clicking in either the top or bottom side and choosing Copy to Right or Copy to Left.

2.5. ステータスバー

Each File pane contains a status bar at the bottom. The status bar contains several panes with different types of information about the document and your location in it:

Line status

  • Ln: Line number in the source file.

  • Col: Column location of the cursor and the total number of columns in the line.

    Col counts tabs as n spaces, where n is the number of characters defined as the Tab size in the Editor page of WinMerge options (4 by default).

  • Ch: Character location of cursor and the total number of chars in the line.

    Ch counts tabs as single tab characters.

  • EOL: Linefeed style of the current line (shown only when the Preserve original EOL chars option is enabled in the Editor page of WinMerge options).

Read-only status

RO is shown in the pane if the file is set to read-only (as described in 「ファイルの保護」). Otherwise the pane is empty.

File encoding

Codepage number for ANSI files, Unicode encoding type for Unicode files.

EOL style

EOL style of the file: Win for Windows/DOS files (CRLF), Unix (LF), Mac (CR), or Mixed.

注意

When the per-line EOL style is used, the file EOL style is not shown (this pane is blank).

When a File Compare window is open, the WinMerge window status bar shows one of these messages about the compared files:

  • Identical: The files contain no differences

  • n Differences Found: The number of differences detected, displayed only when no difference is selected.

  • Difference x of n: The selected difference's sequence number in the total number of differences, starting with 1.

3. 差異への移動

This section describes how to navigate and select differences in the File Compare window. Note that when you select a difference, it is always selected in both or all three File panes.

ティップ

To save time, enable Automatically scroll to first difference in the General page of WinMerge options. Then you don't have to manually navigate to the first difference and select it.

3.1. ナビゲーション機能

Here are the functions for navigating differences in the File Compare window, and their shortcuts in the toolbar and menus:

Difference in the Current Line/Select Line Difference

Enabled if you have clicked in (or selected) text within a difference in a File pane. Selects the word differences within the line. For example:

Select Line Difference example

If you want to select the difference block itself, use Current Difference instead.

Shortcuts: Difference in the Current Line button button, Edit → Select Line Difference, F4, context menu in File pane within a difference.

Next Difference

Selects the next difference below your current cursor location in the document (not necessarily relative to the current difference). Use to step through differences sequentially from any point. Available except when the last difference is currently selected.

Shortcuts: 次の差異ボタン button, Merge → Next Difference, Alt+Down (or Down in merge mode).

Previous Difference

Selects the previous difference above your current cursor location (not necessarily relative to the current difference). Use to step backwards sequentially through differences. Available except when the first difference is currently selected.

Shortcuts: 前の差異ボタン button, Merge → Previous Difference, Alt+Up (or Up in merge mode).

First Difference

Use this to begin comparing or merging differences, or to locate the first difference from any other location. Available except when the first difference is currently selected. You can also select a difference by double-clicking its text.

Shortcuts: 最初の差異ボタン button, Merge → First Difference, Alt+Home.

Current Difference

This function has two modes of action:

  • If your cursor is inside a difference but no difference is selected, this function selects the entire difference. This is a very handy way to select a difference using the keyboard.
  • When there is a current difference, the function jumps to that location. This is handy if you have scrolled the selected difference out of view, and want to quickly return to its location.

Shortcuts: 現在の差異ボタン button, Merge → Current Difference, Alt+Enter.

Last Difference

Enabled except when the last difference is currently selected.

Shortcuts: 最後の差異ボタン button, Merge → Last Difference, Alt+End.

Go to

Enables you to jump to either a line number or a difference number (for example, difference 2 is the second difference). Opens the Go to dialog, where you specify the number, which file to use (either the left or right), and the type of location (either line or difference).

ティップ

The Go to line number can be useful when you need to merge the same change from one file to several target files. Jumping to a particular difference can be quicker than using Find to search text, or stepping through differences.

Shortcuts: Edit → Go to, Ctrl+G, context menu in File pane and Location pane.

Go to Moved Line

Enables to jump to the moved from/to of current diff on the other panel (2 panes).

Shortcuts: Ctrl+Shift+G, context menu in File pane and Diff pane.

Go to Moved Line Between Left and Middle

Enables to jump to the moved from/to of current diff on the other panel (3 panes).

Shortcuts: Ctrl+Shift+G, context menu in File pane and Diff pane.

Go to Moved Line Between Middle and Right

Enables to jump to the moved from/to of current diff on the other panel (3 panes).

Shortcuts: Ctrl+Alt+G, context menu in File pane and Diff pane.

表示を更新

See 「マージ機能」.

4. 同期ポイント

TBD

5. 差異のマージ

Merging copies differences from one File pane to the other: either left to right, or right to left. This is different from directly editing text using WinMerge's editing functions (described earlier in this topic).

5.1. ファイルの再スキャン

By default, the Automatic rescan option is enabled in the Editor page of WinMerge options. Rescanning keeps your your compare and merge operations up to date. Without rescanning, WinMerge differences does not detect changes that might occur to files while you are comparing them, for example in an external editor.

Rescanning occurs when you perform certain actions (like merging a difference or editing a file) during a file compare. If a file has changed, WinMerge displays a dialog advising you that another application has updated the file, and asks whether you want to reload the file.

Click Yes to reload the file before proceeding, or No to ignore the changes and work with the earlier loaded version of the file.

重要項目

If Automatic rescan is disabled, or if you suspect that a file might have changed, we strongly advise that you run Refresh before performing any merge operation: click Edit → Refresh or the 表示更新ボタン toolbar button, or press F5.

If a merge result looks incorrect, click Edit → Undo or press Ctrl+Z to undo the merge. Then rescan the files and try merging again.

5.2. マージ機能

The merging functions can implicitly select differences based on a cursor location or text selection. For example, if you click anywhere in a difference and then click the Copy Right toolbar button, the entire difference block is merged. This makes it easy to merge many small differences. Similarly, if you select text that spans all or part of multiple differences, all the included differences are merged with a single merge command.

If the result of a merge operation is not what you expected, you can click Undo to reverse the operation.

Here are the merge functions and their shortcuts in the toolbar and menus:

Copy Right

Copies one or more difference from left to right. Note that differences do not need to be fully selected: At its simplest, this means replacing text in the target difference with text in source difference. But because differences can also contain empty lines, new lines may be created or removed.

Shortcuts: 右へコピーボタン button, Merge → Copy to Right, Alt+Right (or Right in merge mode), context menu in File pane within a difference, and in Diff pane.

Copy Left

Copies the current difference from the right to the left File pane. See Copy Right description for details.

Shortcuts: 左へコピーボタン button, Merge → Copy to Left, Alt+Left (or Left in merge mode), context menu in File pane within a difference, and in Diff pane.

Copy Right and Advance

Merges the current difference from the right to the left File pane, then selects the next difference (if one exists). Equivalent to Copy Right and Next Difference in one step.

Shortcuts: Copy Right and Advance button button, Merge → Copy to Left, Ctrl+Alt+Right, context menu in File pane within a difference.

Copy Left and Advance

Merges the current difference from left to right, then selects the next difference (if one exists). Equivalent to Copy Left and Next Difference in one step.

Shortcuts: Copy Left and Advance button button, Merge → Copy to Left, Ctrl+Alt+Left, context menu in File pane within a difference.

All Right

Copies all differences from the left to the right File pane. Use to synchronize two files with one command. Similarly, you can back out the entire merge by clicking the 表示更新ボタン Undo or pressing Ctrl+Z.

Shortcuts: All Right button button, Merge → Copy to Left, Alt+Left, context menu in File pane within a difference.

All Left

Copies all differences from the right to the left File pane. Effectively, replaces the content of the left File pane. See similar to All Right.

Shortcuts: All Left button button, Merge → Copy to Left, Alt+Left, context menu in File pane within a difference.

Refresh

Rescans files to update differences. Use after changes are made to files, if automatic scanning is disabled (see 「ファイルの再スキャン」 for details).

Shortcuts: 表示更新ボタン button, View → Refresh, F5.

5.3. コンフリクトファイルの解決

You can use WinMerge to resolve conflict files that some version control systems produce during their merge operations. A conflict file is created when a merge encounters differences that cannot be automatically resolved. It is a single file containing the incompletely merged content of the two files. WinMerge separates the conflict file into separate files and opens those files in file Compare window. You can then use WinMerge's compare and merge functions to resolve the conflicts and save the merged result file.

  1. Click File → Open Conflict File, and use the Open dialog to select the conflict file in your file system. The conflict file opens in the File Compare window:

    • The left File pane file header is titled, Theirs File. This side represents the file that is usually in the version control system's repository. This file usually cannot be edited, so WinMerge sets the left File pane to be read-only. This means that differences can be merged only from this file to the other file.

    • The right File pane is titled, Mine File. This side is the working copy of the file. All changes should be done to this file, which is the result file.

      The Mine File side is set to modified after opening conflict file (you will notice the asterisk in the File pane header). This allows you to save the file quickly if the it does not require any changes. It also ensures that you do not forget to resolve the files. If you choose not to save the file, the original conflict file is not modified.

  2. Use all the normal compare and merge functions described earlier in this topic to resolve the conflicts in the Mine File pane.

  3. When you are done, click Ctrl+S to save the Mine File side as the result file. By default, the new version overwrites the original conflict file. Alternatively, you can click File → Save Right → Save As, and choose a different file name.

Many version control systems allow you to configure an external merge tool. If yours does, you might be able to have your version control system launch WinMerge automatically when a merge conflict occurs.

You can also open a conflict file from the WinMerge command line, which accepts three filename parameters: Theirs, Mine, and optionally, Resolved (if you want a different result file from the conflict file). For more information, see コマンドライン. Single path to the conflict file is also accepted in command line.


Hex形式比較

WinMergeは、ファイルをHex形式で表示・編集することができます。

HEX Compare Window

ファイルがHex形式で開かれるかどうかは、ファイル名が定義されたパターンと一致するかどうかに依存します。デフォルトでは、ファイル拡張子が.binまたは.frxの場合、Hex形式で開かれます。パターンを変更したい場合は、オプションダイアログの比較/バイナリページで指定してください。


テーブル形式比較

バージョン2.16.8からCSVやTSVなどの区切り値テキストファイルを表計算ソフトのようにテーブル形式で表示し、編集することができるようになりました。 この形式での編集操作、差異への移動操作、マージ操作は、通常のテキストファイルウィンドウと同じです。

1. テーブル形式で開く

ファイルがテーブル形式で開かれるかどうかは、ファイル名が定義されたパターンに一致するかどうかで決まります。デフォルトでは、ファイル名が、～.csv、～.tsvならばテーブル形式で開かれます。このパターンを変更したい場合は、オプションダイアログの比較/テーブルページでパターンを指定します。

通常のテキストとして開かれた後、一時的にテーブル形式で開きたい場合は、ファイル → 形式を指定して再比較 → テーブルをクリックします。テーブルダイアログが表示された場合は、形式を指定してOKをクリックします。

逆にテーブル形式で開かれたファイルを一時的に通常のテキストファイルとして開きたい場合は、 ファイル → 形式を指定して再比較 → テキスト をクリックします。

2. ファイル読み込みの調整

デフォルトでは、区切りテキストファイルのデータは、以下のように扱われます。

  • CSVファイルはカンマ、TSVファイルはタブを区切り文字として値が区切られ、値は列ごとに表示される。

  • ただし、引用符文字(ダブルクォーテーション)で括られた範囲にある区切り文字は値として扱われる。

  • また、引用符文字で括られた範囲にある改行文字(CR, LF)は値として扱われる。

上記から変更したい場合は、オプションダイアログの比較/テーブルページや、 ファイル → 形式を指定して再比較 → テーブル で表示されるテーブルダイアログで調整します。 詳細については、「比較/テーブル ページ」を参照してください。

3. テーブル形式固有の操作

  • 列見出しの列の境界をマウスでドラッグすると列幅が変更されます。

  • 列見出しの列の境界をダブルクリックすると自動的に列の内容に応じて列幅が調整されます。

  • 列見出しの列をドラッグすると垂直方向にテキストが選択されます。

  • 表示 → 行を右端で折り返す にチェックを入れると列ごとにテキストが折り返して表示されます。 セル内改行されたテキストを表示するにはこのメニューにチェックを入れてください。


画像ファイルの比較

This topic describes how to compare images using the Image Compare window.

1. 画像比較操作を開始する

You can start an image compare operation from either the WinMerge window or a Command Prompt window.

From the WinMerge window

Click File → Open. Use the Select Files or Folders dialog to specify the left and right source images to compare. For more details about the Select Files or Folder dialog, see ファイルとフォルダーを開く.

From a Command Prompt window

Run WinMergeU.exe, which is in your WinMerge install directory. In your command arguments, include the left and right images to compare. For more information about using the command line, see コマンドライン.

2. 画像比較ウィンドウ

WinMerge support many types of images and can highlight the differences with blocks. Overlaying of the pictures is also possible.

Image Compare Window

You can set the most options in the Location Pane:

2.1. 差異

Highlight

With the check box Highlight you can enable or disable the highlighting of the image differences.

点滅

If the highlighting is enabled you can even make it blinking by checking the check box Blink.

Block Size

The slider Block Size defines the size of the blocks which highlighting the image differences.

Block Alpha

The Block Alpha slider defines how strong the alpha blending of the blocks is.

Color Distance Threshold

The slider CD sets the Color Distance Threshold which helps to ignore color differences.

Ins/Del Detection

TBD

  • None
  • Vertical
  • Horizontal

2.2. 重ね合わせ

Mode

Currently the following Overlay Modes are possible:

  • None
  • XOR
  • Alpha Blend
  • Alpha Blend Animation

Alpha

The Alpha slider defines how strong the alpha blending of the overlay nodes Alpha Blend or Alpha Blend Animation is.

2.3. 拡大

拡大/縮小

With the Zoom slider you can zoom in or out of the images.

Page

If the image format support multiple pages you can select the current page with the Page number box.


Webページの比較

TBD


オプションとコンフィグレーション

オプションダイアログでは、WinMergeの様々なカスタマイズを行うことができます。WinMergeオプションを設定するには、

  1. メニューの、編集 → 設定、または、ツールバー WinMerge Options button 設定ボタンをクリックしてください。

    オプションダイアログには、多くのページがあり、それぞれ、関連する設定のグループを含んでいます。 ダイアログの左端にある カテゴリ リストのタイトルをクリックすることで、ページを開くことができます。

  2. 以下の方法の片方、または、両方を使って、変更したいオプションを設定することができます。

    • オプションページで直接編集

    • エクスポート済の.iniファイルをインポート

  3. オプションを設定し終わったら、 OKをクリックして、それらを保存し、ダイアログを閉じてください。

このトピックでは、オプションの詳細について説明します。オプションダイアログの、それぞれのページにはセクションがあります。

1. 設定情報のインポートとエクスポート

差分比較、または、マージの設定を頻繁に変更する場合、また、 あなたの設定を他のWinMergeユーザーと共有したい場合は、 設定をファイルへエクスポートして保存することを検討してください。 あとでそれらの設定を使いたい時は、手動でオプションを設定する代わりに、単に設定ファイルをインポートすることができます。

インポートオプション

保存された設定を再使用したい時は、 インポートをクリックしてください。インポートダイアログで、保存済の iniファイルを探して、 開くをクリックしてください。

インポートされた設定ファイルの値で、すべてのオプションを置き換えます。

エクスポートオプション

オプションを設定し終わったら、 エクスポートをクリックしてください。 エクスポートダイアログで、設定ファイルのパスと名前を指定して(拡張子 iniは、自動的に付加されます)、 保存をクリックしてください。

生成された iniファイルの各行は、一つのオプションを表す、名前と値のペアを含みます。

2. 一般 ページ

一般ページには、いくつかのオプションがあります。

2.1. 自動的に最初の差異にスクロールする

  • 無効(デフォルト): 比較ウィンドウは、フォルダー、または、ファイルの先頭を表示し、差異を選択しません。

  • 有効: 最初に開いた時、比較ウィンドウは(必要ならそこまでスクロールして)最初の差異を選択します。

    • フォルダー比較では、ファイル、または、フォルダーの最初の差異を選択します。

    • ファイル比較では、ファイル中の最初の差異ブロックを選択します。

2.2. Automatically scroll to first inline difference

  • Disabled (default): TBD

  • Enabled: TBD

2.3. 'Esc'でウィンドウを閉じる

  • MDI子ウィンドウまたはメインウィンドウ(デフォルト):EscキーでWinMergeウィンドウを閉じられるようにします。Escを一度押下すると一つのウィンドウを閉じます。つまり、もう一つファイル比較ウィンドウが開いていた場合、WinMergeを終了するためには、キーを合計3回押下する必要があります(最初に、ファイル比較ウィンドウ、次に、フォルダー比較ウィンドウ、そして最後に、WinMergeウィンドウ)。

    注) WinMergeのコマンドラインの -eパラメーターは、WinMergeを Esc1回で終了することを可能にします。

  • MDI子ウィンドウのみ: Escを押下すると 子ウインドウは閉じますが、最後に残ったメインウィンドウは閉じません。

  • 無効: Esc押下で、WinMergeウィンドウを閉じません。

2.4. 開くダイアログで自動的にパスを検査する

  • 有効(デフォルト):ファイルまたはフォルダーの選択ダイアログで、パスを入力した時に、それらをチェックします。OKボタンは、両方(または3つすべて)のパスが検証されるまで、使用不可となります。注)このチェックは、ほんの少しだけ時間がかかることがあります。

  • 無効: ファイルまたはフォルダーの選択ダイアログの OKボタンは常に使用可能となり、 指定したパスを開こうとします。検証による遅延がないため、 パスの選択が速くなります。しかし、パスが開かれなかった場合、 エラーダイアログが表示されます。

2.5. 複数のインスタンスを起動しない

  • 無効(デフォルト): 複数のWinMergeを起動することができます。 例えば、WinMergeが起動している時に、WinMergeのショートカットをクリックした場合、 新たなWinMergeウィンドウが開かれます。

  • 有効: WinMergeの起動を一つに制限します。

    • WinMergeが起動している時に、新しいインスタンスを起動しようとした場合、 新しいウィンドウは開かれず、 代わりに、現在のWinMergeウィンドウが使われます。

    • (例えば、コマンドラインから)パスと共に新しいインスタンスを起動しようとした場合、 新たな比較ウィンドウが、既存のWinMergeウィンドウ中に開かれます。

2.6. 複数のウィンドウを閉じるときに尋ねる

  • 無効(デフォルト): 複数の比較ウィンドウが開いている時に、WinMergeを終了する場合、 WinMergeは、すべてのウィンドウを閉じるかを尋ねます。

  • 有効: 終了をクリックした時、未保存のファイル変更が無い場合、 WinMergeは直ちに終了します。

2.7. ファイル比較時のファイル時刻を保つ

  • 無効(デフォルト): WinMergeで、ファイルの変更を保存する時、ファイルのタイムスタンプが更新されます。

  • 有効: WinMergeで、ファイルの変更を保存する時、ファイルシステム上のファイルのタイムスタンプは更新されません。

2.8. 起動時にファイルまたはフォルダーの選択ダイアログを表示する

  • 無効(デフォルト): WinMerge起動時に、WinMergeウィンドウが開きます。ファイル、または、フォルダーを選択するには、 ファイル → 開くをクリックしなければなりません。

  • 有効: WinMergeを起動した時、WinMergeウィンドウと共に、ファイルまたはフォルダーの選択ダイアログが開きます。

2.9. OK押下時にファイルまたはフォルダーの選択ダイアログを閉じる

  • 無効 (デフォルト): 比較ボタンをクリックすると、ファイルまたはフォルダーの選択ダイアログは閉じずに開いたままになります。

  • 有効: 比較ボタンをクリックすると、ファイルまたはフォルダーの選択ダイアログが閉じます。

2.10. 開くダイアログのオートコンプリート

次の中から一つ選択してください:

  • 無効(デフォルト): ファイルまたはフォルダーの選択ダイアログでパス入力した時、 オートコンプリートは実行されません。

  • ファイルシステム: 入力した時にパスを調べます。入力した文字と一致するパスを、ファイルシステム上から見つけようとします。一致するパスが見つかった場合、パスを補完します。

  • 最近使ったリスト: パスを、最近使ったリスト(MRU)の中から調べます。 これは、比較用のパスが限定されている場合に便利です。

2.11. 変更されたファイルの自動再読み込み

次の中から一つ選択してください:

  • 無効 (default): 自動再読み込みを無効にします。

  • ウィンドウがアクティブになった時のみ: WinMergeのウインドウがアクティブになった時、 もしファイルが変更されていれば、ファイルを再読み込みします。 ただし、この時ファイルを開きなおすか問い合わせるメッセージボックスが表示されます。 このメッセージボックスを表示したくない場合は、「再びこの質問をしない」をチェックし、 はいボタンを押下してください。

  • 即時: ファイルが変更されたとき再読み込みを即時に行います。 ただし、この時ファイルを開きなおすか問い合わせるメッセージボックスが表示されます。 このメッセージボックスを表示したくない場合は、「再びこの質問をしない」をチェックし、 はいボタンを押下してください。

2.12. 言語

See 「WinMerge GUI言語の変更」.

2.13. リセット

WinMergeは、いくつかのメッセージボックスを抑制することを許可します。 例えば、同一の2つのファイルが開かれた時、通常なら 選択されたファイルは同一です。メッセージボックスが, 開かれます。これ以上、このメッセージを表示して欲しくない場合、 メッセージボックス中のオプションを有効(チェックON)にすることで、そのメッセージを再び表示しないようにすることができます。

あとで、再びメッセージを見たいと思うかもしれません。 リセットボタンをクリックすることで、メッセージボックスを再び表示するようにできます。

注意

WinMergeを新しいバージョンにアップデートした時は、メッセージを省略することはオススメしません。 インストーラーは、それらを自動的に表示するようにします。しかし、インストーラーを使用しない場合、 リセットボタンを使って、メッセージの表示を有効にすることを思い出してください。

3. 比較ページ

このページのオプションでは、WinMergeが、ファイルサイズのみを比較する(つまり、いくつかのタイプの差異を無視する)などの差異を検知する方法を変更することが可能です。

重要項目

いくつかの違いに興味がないかもしれない場合、差異を見つける方法をカスタマイズすることは、比較の間に有効かもしれません。 しかし、これらのオプションは、マージにも影響します。 例えば、スペースの変更を無視する場合は、マージ時にソースコード中のインデント変更は保存されません。

この理由により、いくつかの差異をマージする前に、 このページのオプション(特に無視オプション)をデフォルト値にリセットすることをオススメします。 このページの全オプションをリセットするには、 デフォルトボタンをクリックしてください。

3.1. 様々な無視オプションについて

比較ページ(このセクションの後で説明されている)の、 たくさんのオプションによって、明らかな差異を無視することができます。無視された差異は、 WinMerge内で特別な方法で扱われます。

  • これらは、無視された差異の色でマークされます。

  • 無視された差異はマージできません。

  • 無視された差異は、差異の個数に含められません。

  • フォルダー比較では、無視された差異のみが含まれているファイルは、同一のファイルとしてマークされます。

3.2. 空白

ホワイトスペースは、単語と行の間の空白です。それは、スペースやタブや改行のような、特別な非印字文字です。ホワイトスペースの重要性は、どのように差異を解釈したり、処理したいかに依ります。ホワイトスペースのすべての変更を見つけることは重要かもしれません。反対に、一つのスペース、二つのスペース、一つのインデント、または、タブなど、すべてのホワイトスペースを同様に扱いたいかもしれません。いくつかの構造化ドキュメント(カンマ区切りリストの様な)では、すべてのホワイトスペースを無視したいかもしれません。

注意

行内のホワイトスペースの変更の影響は、行内差異を表示するが有効にされている時だけ見ることができます。 これは、差異ブロックとは対照的に、常にハイライトされます。

例1 行と異なるホワイトスペース

単語間に一つのスペース:

Two Words

単語間に二つのスペース:

Two  Words

単語間にタブ:

Two	Words

単語間にスペースなし:

TwoWords

これらのオプションの一つにより、ホワイトスペースの検出を制御できます:

比較する

すべてのホワイトスペースが比較されます(デフォルト)。 あなたのドキュメントがどのオプションを必要とするか確かでないなら、これは、たぶん最も安全な選択です。 例では、すべての行が差異として検出されます。

変更を無視する

差異中のホワイトスペースを比較します。 例では、最初の3行には異なるホワイトスペースが存在しています。 しかし、それらは同一行として検出されます。タブと複数個のスペースは、単一のスペースとして扱われます。 最後の行にホワイトスペースは存在しないため、差異は無視 されません(結果的に、最後の2行の単語は異なります)

すべて無視する

改行を除く、すべてのホワイトスペース文字を無視します( so lines are detected and preserved in a merge)。例のすべての行は、同一行として検出されます。

関連するトピック

行の差異におけるホワイトスペース設定の影響は、 「行内差異の強調表示」で説明されています。

オプションダイアログのエディターページは、単語間の区切りを検出するために、ホワイトスペースがどのように使われるかの制御に関する設定を含んでいます。詳細は、 「行内差異の強調」を参照してください

3.3. 空行を無視する

  • 無効(デフォルト): ソースファイル中の空行は、 ファイル比較ウインドウ中で、 「差異あり: 削除」の色の空行で表されされます。

  • 有効: ソースファイル中の空行は無視されます。 これらは、ファイル比較ウィンドウ中で、「無視された差異」の色の空行で表されます。 しかしながら、差異はマージできません。

3.4. 大文字と小文字を区別しない

  • 無効(デフォルト): 比較は、大文字小文字を区別します。例えば、 LowerCase、 LOWERCASE、と lowercaseはすべて異なります。

  • 有効: 文字間の大文字、 小文字の差異は無視されます。

3.5. 改行文字の違いを無視する (Windows/Unix/Mac)

  • 無効(デフォルト): 行末(EOL)スタイルの差異は検出されます。 例えば、同じ内容で、行末が異なる2行を比較する場合、 行は異なると判断されます。 この場合、WinMergeは、差異を検出するか、 無視するかの確認ダイアログを表示します。

  • 有効: EOLの差異は無視されます。

3.6. コードページの違いを無視する

  • Disabled (default): ファイルのエンコーディングの違いを検出します。 UTF-8 BOMの有無の違いも検出します。

  • Enabled:ファイルエンコーディングの違いは無視されます。

3.7. コメントの違いを無視する

  • 無効(デフォルト): WinMerge は、他の内容と一緒に、コード中のコメントを比較します。

  • 有効: このオプションは、(C++ や Java のような)プログラミング言語のコメントを検出し、それらを無視することにより、 比較を最適化します。

3.8. 移動ブロックの検出を有効にする

  • 無効(デフォルト): WinMergeは、行の移動による差異を検出しません。

  • 有効: WinMergeは、(ファイル中の異なる場所に)移動された行の検出を試みます。移動されたブロックは、 移動ブロックと 選択された移動ブロックの色で示されます。 ロケーションバーが表示されている場合、左と右のロケーションバーの一致する差異の場所が、線で結ばれます。 移動ブロックの表示は、それが多すぎない場合、ファイル中の変更をより簡単に視覚化することができます。

    一例は、ロケーションペインの説明テキストファイルの比較とマージを参照してください。

3.9. 類似行をマッチさせる

  • 無効(デフォルト): Lines within difference blocks are shown as they occur in the source files.

  • 有効: WinMergeは、異なるブロック中の似ている行を検出しようと試みます。 そして、ファイルペインに空行を追加し、それらの位置を揃えます。 このオプションは、行が似通っている時に最も効果的で、行が全く異なっている場合には、それほど効果的ではありません。

    一例は、「差異の強調表示」にある Similar linesの説明を参照してください。

3.10. Diff アルゴリズム

  • default (デフォルト): 基本的な差分アルゴリズムです。

  • minimal: できるだけ差分が少なくなるように比較します。 その分、比較に時間がかかります。

  • patience: patienceアルゴリズムで差分を比較します。

  • histogram: histogramアルゴリズムで差分を比較します。 このアルゴリズムはpatienceアルゴリズムを低頻度の共通要素に対応するように拡張しています。

  • none: このアルゴリズムは行の挿入や削除を検出しません。

3.11. indent heuristic を有効にする

  • 有効 (デフォルト): 差分のハンク境界をシフトするヒューリスティックを有効にして、差分を読みやすくします。 Diff アルゴリズムがdefaultの場合、効果はありません。

  • 無効: ヒューリスティックを無効にします。

3.12. Completely unhighlight the ignored differences

  • Enabled: Makes the color of the different lines ignored by line filters and substitution filters the same as the color of the identical lines.

  • Disabled (default): Difference lines ignored by line filters and substitution filters are displayed in the color of Ignored Difference.

4. 比較/フォルダーページ

4.1. 比較方法

このオプションは、ファイル比較を完了する方法を決めることができます。5つの選択肢から1つを選んでください。

フルコンテンツ

デフォルト: ファイルの内容すべてを比較します。 この方法はプラグインを発動し、正確な差異と移動ブロック検出のために diffutils エンジンを使用します。 これは、もっとも完璧でオススメの方法です。

クイックコンテンツ

スリムダウンされた、ファイルの内容による比較です。この方法は、プラグインと移動ブロック検出をスキップし、簡素化されたファイル比較コードを使用します。この方法は、 ファイルを読み込まないため、 フルコンテンツよりも高速です。

短所は、比較時に行フィルターが許可されないことです。例えば、この方法は、行フィルターをファイルのすべての差異を無視するように設定していても、それらを差異として検出します。

バイナリコンテンツ

この比較方法は、クイックコンテンツの比較方法よりも高速です。 ただし、プラグインや行フィルター、「大文字と小文字を区別しない」 オプションなどは適用されません。まず、ファイルサイズを比較し、 ファイルサイズが異なる場合は、内容を比較せずにファイルの内容を異なるもの として扱います。ファイルサイズが一致していれば、単にファイルの内容を バイト単位で比較します。 ファイルのエンコード検出、EOL検出、バイナリファイルの検出は行われません。 この比較方法は、バックアップされたファイルとの比較に適しています。

更新日時

ファイルの更新日時のみを比較するため、他のどの比較方法よりもずっと高速です。 しかし、明らかに、それはただ更新日時と同じくらい正確です。

更新日時とサイズ

更新日時と似ていますが、 日時が同一の時に、ファイルサイズもチェックします。

サイズ

ファイルサイズのみを比較するため高速ですが、 内容を比較する方法よりも不正確です。

4.2. 最初の差異で比較を終了する

このオプションは、比較方法に クイックコンテンツが選択された場合にのみ有効となります。

  • 無効(デフォルト): WinMerge は、ファイル中のすべての差異を検査します。

  • 有効: このオプションは、常にファイル全体をスキャンする代わりに、 最初の差異が見つかるまでファイルを検査することにより比較を最適化します。

    欠点は、WinMerge が、バイナリファイルをバイナリとして検出できないかもしれないことです。 最初の差異がファイルの先頭付近にある場合、このようなことが起こります。 どんな種類のファイルを比較するか知っているなら、このオプションは比較を高速化するための良い方法となるでしょう。 しかし、比較するファイルがどんな種類か確かでないなら、このオプションを有効にしないでください。

4.3. 3秒以下の時間差を無視する

  • 無効(デフォルト): 異なるタイムスタンプを持つファイルは、差異として検出されます。

  • 有効: 時々(例えば、ネットワーク共有を使用中の場合)、 僅かなタイムスタンプの差異は重要なことではありません。 そのような状況でより意味のある結果を得るために、 このオプションで3秒以下の時間差を無視することができます。

    このオプションは、( 「比較方法」で説明されている)比較方法が、 更新日時か 更新日時とサイズの場合にのみ動作します。 他の比較方法と共に使用しても効果はありません。

    警告

    このオプションは、時間差が検出された時のみ有効です。さもなければ、それは不正な比較結果の原因となります。

4.4. 片方にしか存在しないフォルダー内も含める

  • Disabled (default): WinMerge ignore unique subfolders when comparing folders.

  • Enabled: WinMerge also shows the content from unique subfolders.

4.5. Include subfolders

  • Enabled (default): WinMerge doing a recursive comparing and also includes subfolders.

  • Disabled: WinMerge only comparing the files in the root folder.

4.6. 比較後自動的にサブフォルダーを展開する

展開しない

(デフォルト): フォルダ比較後、自動的にサブフォルダを展開しません。

すべてのサブフォルダーを展開

フォルダ比較後、自動的にすべてのサブフォルダを展開します。

差異のあるサブフォルダーを展開

フォルダ比較後、自動的に差異のあるサブフォルダを展開します。

同一のサブフォルダーを展開

フォルダ比較後、自動的に同一のサブフォルダを展開します。

4.7. 再解析ポイントを無視する

  • Disabled (default): TBD

  • Enabled: TBD

4.8. クイック比較切替閾値 (MB)

  • Disabled: Is not active unless the Compare method is set to other than Full Contents compare method.

  • Enabled: Is active when the Compare method is set to Full Contents compare method.

    Threshold size for switching to Quick Contents compare method. When Full Contents compare method is selected, files bigger (in mega bytes) than this value are compared using Quick Contents compare method.

4.9. Threshold for switching to binary compare (MB)

  • Disabled: Is not active unless the Compare method is set to other than Full Contents and Quick Contents compare method.

  • Enabled: Is active when the Compare method is set to Full Contents or Quick Contents compare method.

    Threshold size for switching to Binary Contents compare method. When Full Contents or Quick Contents compare method is selected, files bigger (in mega bytes) than this value are compared using Binary Contents compare method.

4.10. 比較スレッドの数

Number of threads which use to comparing. With a negative value WinMerge will use addition of the number of available CPU cores.

5. 比較/テーブル ページ

5.1. CSV ファイルとして扱うパターン

テーブル形式で比較したいカンマ区切り値のファイルのファイル名パターンを指定します。 セミコロン区切りで複数指定することが可能です。 デフォルトでは、*.csv が指定されています。拡張子.csvのファイルをテーブル形式 で比較したくない場合は、*.csv を取り除いてください。

5.2. TSV ファイルとして扱うパターン

テーブル形式で比較したいタブ区切り値のファイルのファイル名パターンを指定します。 セミコロン区切りで複数指定することが可能です。 デフォルトでは、*.tsv が指定されています。拡張子.tsvのファイルをテーブル形式 で比較したくない場合は、*.tsv を取り除いてください。

5.3. ユーザー指定文字区切り値

カンマやタブ文字ではなく、別の文字で区切られた値のテキストファイルをテーブル形式で開きたい場合、 そのファイルのファイル名パターンと区切り文字を指定します。

5.4. 引用符内の改行文字を値として扱う

  • 有効 (デフォルト): テキストに引用符文字が現れてから次の引用符文字が現れる前に改行文字が現れた場合、 この改行文字を値とみなします。 一つのフィールドに複数の行が格納されているCSV/TSVファイルを処理する場合は、このオプションを有効にします。

  • 無効: 上記を無効にします。引用符の数に誤りのあるファイルを開く場合は、 このオプションを無効にしてください。

5.5. 引用符文字

引用符として扱われる文字を指定します。 ここで指定した文字で括られたテキスト範囲内にある区切り文字は値として扱われます。 この入力エリアを空にすることが可能です。 引用符が単なる値でしかないファイルを開く場合、 空にするか、そのファイルに存在しない文字を指定してください。

6. 比較/バイナリ ページ

6.1. バイナリファイルとして扱うパターン

TBD

6.2. Frhed settings

TBD

View Settings...

TBD

Binary Mode...

TBD

Character Set...

TBD

7. 比較/画像 ページ

7.1. 画像ファイルとして扱うパターン

TBD

7.2. フォルダー比較で画像比較を有効にする

TBD

7.3. OCRの結果

TBD

8. エディターページ

8.1. シンタックスハイライト

  • 有効(デフォルト): WinMerge は、多くのプログラミング言語とwebフォーマットを、シンタックスハイライトすることができます。デフォルトでサポートされている形式を見るには、 表示 → シンタックスハイライト。

  • 無効: シンタックスハイライトは、多少のCPUパワーを消費するため、WinMerge の画面描画が遅いと思う場合は、これを無効にすると良いかもしれません。

8.2. 自動的に再スキャンする

  • 無効(デフォルト): WinMerge は、差異をマージした時、または、 表示更新ボタンをクリックするなどした時、 自動的に再スキャンします。

  • 有効: WinMerge は、すべての編集イベント (入力するなど、ファイルへの変更)の後、強制的に再スキャンします。

    注意

    編集作業を遅くするのを避けるために、WinMerge は、自動再スキャンを僅かながら遅らせます(編集イベント後1秒待ちます)。 それにより、それぞれの新しい編集イベントがタイマーをリセットし、 編集を中断するか止めるまで、再スキャンは起こりません。

8.3. 元のEOL文字を保存する

  • 無効(デフォルト): ファイルが、Windows のファイルであると仮定します。ファイルが、Windows 標準の行末文字を使用していない場合、WinMerge は、これをエラーとみなします。 それらを、差異として検出する代わりに、Windows スタイルの行末文字へ静かに変更します。 それゆえ、ファイル比較ウィンドウのステータスバーには、EOLスタイル Winとして表示します。

    ほとんどの場合、このオプションは無効のままにしておくべきです。 行末文字の異なる2つのファイルを比較する場合、 デフォルトの振る舞いで、十分うまく動作するでしょう。

  • 有効: WinMerge が行末文字を自動的に変更するのを防ぎます。 その結果、すべての行のEOLスタイルの差異を検出します。これは、(Windows と Unixなど)異なるEOLスタイルを持つシステムからのファイルを扱うために便利かもしれません。

    重要項目

    また、これは、EOLバイトに詳しい方や、 1つのファイルに異なるEOLスタイルが混在するファイルを比較したい方のための高等なオプションです。 あなたが、この高等な機能を必要としないなら、このオプションを有効にしないことをオススメします。 このオプションは、異なるEOLスタイルの2ファイルを比較するためには、 不要であることを憶えておいてください。

8.4. タブ

タブ幅

タブの幅です。値を指定してください n: 設定した幅は、同数の nの文字と同じになります。 デフォルト: 4。 最大値は64です。

タブ挿入オプション

テキスト中でtabキーを押下した時に、どの種類の文字が使われるかを指定します。次のうち、1つだけを有効にすることができます:

  • タブを挿入(デフォルト):1つのタブ文字を使用します。

  • スペースを挿入: タブ文字の代わりに、( タブ幅)で指定された個数分のスペースを挿入します。例えば、デフォルトのタブ幅の場合、4つのスペースが挿入されます。

8.5. 行内差異の強調

これらは、 行内差異(差異ブロックの行内の変更)の検出を有効にし、また、その設定をします。:

View line differences

  • 有効(デフォルト): WinMerge は、行内の差異をハイライトします。メニューの 表示 → 行内差異を表示でも有効にできます。

    次のサブオプションから、1つ選択してください:

    • 文字単位: 異なる文字をハイライトします。 このオプションは、単語内の変更を探す場合や、 明確な単語分割をしていないファイルの場合に役立つでしょう。

    • 単語単位(デフォルト) 差異のある単語全体をハイライトします。

      • 空白で区切る(デフォルト): 単語は、空白で区切られていると仮定されます。 これは、大抵の典型的なテキストファイルに作用します。

      • 空白か句読点で区切る: 空白と句読点の両方を単語境界とみなします。 これは、(カンマ区切りリストのような) 句読点で区切られたリストを扱うために便利です。

  • 無効: WinMerge は、行内差異をハイライトしません。そして、レベルと空白オプションは無視されます。メニューの、 表示 → 行内差異を表示も無効になります。

Word break characters

TBD

関連トピック

「行内差異の強調表示」 WinMerge が、行内差異をどのように検出しマークするのかを、もっと詳細に説明します。

8.6. Rendering Mode

  • GDI (default): TBD

  • DirectWrite Default: TBD

  • DirectWrite Aliased: TBD

  • DirectWrite GDI Classic: TBD

  • DirectWrite GDI Natural: TBD

  • DirectWrite Natural: TBD

  • DirectWrite Natural Symmetric: TBD

9. 色 ページ

ファイル比較ウィンドウで使用される差異などの色を変更したい場合は、 このページで行ってください。 背景、削除、テキストを設定可能です。

色を変更するには色ボックスをクリックし、標準的な色の設定ダイアログを開きます。 基本色か作成した色から1つ選択し OKをクリックすると、新しい色がボックスに読み込まれます。

To revert to the default colors of a scheme, choose a different scheme and return to the modified scheme.

10. Differences Colors page

TBD

11. 色/シンタックス ページ

デフォルトでは、WinMerge のファイル比較ウィンドウは、 「シンタックスハイライト」で説明されている、ある程度の種類のソースコードのシンタックスを評価します。 このページは、認識されるシンタックス要素を列挙し、これらのテキストの色と太さを変更可能にします。

To revert to the default colors of a scheme, choose a different scheme and return to the modified scheme.

12. 色/テキスト ページ

テキスト色を変更するには、このページを使用してください。はじめに、 カスタムテキストカラーを使用にチェックしてください。 これは、カスタムテキストカラーを有効化します。空白、標準テキスト、選択の3種類のテキストの設定があります。 それぞれの種類のテキストに対し、背景と文字の色を選択することができます。

13. 色/マーカー ページ

TBD

14. 色/フォルダー比較 ページ

By default, the WinMerge Folder Compare window use background colors to show the status from a item (equal, different, not exists on all sides or filtered).

色を変更するには色ボックスをクリックし、標準的な色の設定ダイアログを開きます。 基本色か作成した色から1つ選択し OKをクリックすると、新しい色がボックスに読み込まれます。

To revert to the default colors of a scheme, choose a different scheme and return to the modified scheme.

15. アーカイブサポートページ

このページは、7-Zip を使用した Winzipアーカイブサポートの設定のためのオプションを含んでいます。

15.1. アーカイブファイルサポートを有効にする

このオプションは、WinMerge が(7-Zip統合を基にした)アーカイブファイルを扱う方法を制御します。

  • 有効(デフォルト): WinMerge は、7-Zipアーカイブを識別します。

  • 無効: 7-Zipアーカイブサポートを無効にします。

15.2. ファイルのシグネチャからアーカイブの種類を検出する

  • 無効(デフォルト): WinMerge は、お使いのシステムにおいて、既知の拡張子のアーカイブファイルのみを見分けることができます。 (for example, in the registry or through a file association)

  • 有効: WinMerge は、ファイルの拡張子が不明な形式の場合でも、アーカイブファイルを見分けることができます。アーカイブを見分けるために、WinMerge は、ファイルの先頭から、アーカイブシグネチャバイトを探します。

    ティップ

    WinMergeが、OpenOfficeファイルを見分けるために、このオプションを有効にすることができます。

16. システムページ

16.1. 削除されたファイルをゴミ箱に移動する

  • 有効(デフォルト): フォルダー比較ウィンドウで削除したファイルやフォルダーは、 可能な場合、ゴミ箱へ移動されます。

    重要項目

    お使いのシステムでゴミ箱が無効にされている場合、このオプションは動作しないことを、憶えておいてください。 その場合、ファイルは削除され失われます！

  • 無効: フォルダー比較ウィンドウで削除されたファイルやフォルダーは、 本当に削除されます。

16.2. 外部エディター

WinMergeのファイル比較ウィンドウは、一般的な編集機能を提供します。 あなたのお気に入りのフル機能のエディターを使いたい場合、フォルダー比較コンテキストメニューから、WinMerge が外部エディターを開くように設定することができます。

デフォルトの外部エディターには、すべての Windows システムにある、メモ帳(notepad.exe)が設定されています。 異なる外部エディターを設定するには、その実行ファイルのフルパスを入力してください。

ティップ

パスと一緒に、その外部ツールでサポートされている、いくらかのコマンドラインパラメーターを含むことができます。このようなフォーマットです。 実行ファイルのパス -option1 -option2 ...

設定された外部エディターを使うには、フォルダー比較ウィンドウ中のファイルを右クリックし、 左を開く → 外部エディターで、または、右を開く → 外部エディターでを選択してください。

16.3. フィルターフォルダー

ファイルフィルター用の個人フォルダーの指定には、このフィールドを使用してください。デフォルトでは、このフォルダーは、 Windows 10 では ドキュメントといった)、あなたのユーザープロファイルフォルダーです。ファイルフィルターを作成したら、このフォルダーへ自動的に追加されます。

16.4. テンポラリファイルフォルダー

WinMerge が、一時ファイルを保存するフォルダーを指定してください。次のうち、何れか1つが有効です:

  • システムのテンポラリフォルダー (デフォルト): 例えば、お使いのシステムでは、 C:\Windows\Tempかもしれません。

  • カスタムフォルダー: 参照をクリックし、書き込み可能なフォルダーを選択してください。

17. バックアップファイルページ

このページは、WinMerge がバックアップファイルを作る方法を制御することを可能にします。

17.1. 作成するバックアップ

WinMerge がバックアップファイルを作るべきなら指定してください。次のオプションは、それぞれ独立に、有効、または、無効にすることができます。

  • フォルダー比較(デフォルトで無効): ファイルが上書き(コピー)される度に、バックアップファイルが作成されます。

  • ファイル比較(デフォルトで有効): ファイルが保存される度に、バックアップファイルが作成されます。

17.2. バックアップファイル生成先

バックアップファイルが作成される場所を指定してください。次のうち、1つのみ有効にすることができます:

  • 元ファイルのフォルダー(デフォルトで有効): バックアップファイルは、元ファイルと同じフォルダーに作成されます。 これは、大抵良い選択です。マイナス面は、巨大なフォルダーは、バックアップファイルを片付けるのが大変だということです。

  • バックアップフォルダー(デフォルトで無効):すべてのバックアップファイルは、1つのフォルダーに作成されます。これは、バックアップファイルを片付けるのを容易にします。しかし、複数のソースファイルが同じファイル名だった場合、最も新しいバックアップファイルは、以前に作成された同名のファイルを上書きします。

17.3. バックアップファイル名

WinMerge がバックアップファイルを作る時、 元ファイル名に拡張子を付加します。次のうち、 一方か両方の拡張子構成を選ぶことができます:

  • .bak拡張子を追加する(デフォルトで有効): 例えば、 file.txtは、 file.txt.bakでバックアップされます。

  • (デフォルトで無効): タイムスタンプはほぼ常にユニークであるため、このオプションは元ファイル名が同じ場合に、大抵、バックアップファイルの重複を回避します。

    また、保存する毎にファイルが蓄積されるため、ファイルの変更を追跡する方法を提供します。 しかし、このオプションが、たくさんのファイルを作成することを考慮すべきでしょう。

18. コードページページ

このページは、ANSI版 WinMerge が、ANSIファイルに対して使うコードページを指定します。 また、あるファイル形式のコードページは、 ファイルの内容から検出されるべきかどうかを指定します。

注意

完全なテキストエンコーディングと Windows コードページの説明は、WinMerge ドキュメントの範囲を超えています。 幸いにも、インターネット上には、 それらについての情報がたくさんあります。 例えば、ここに始めるべきいくつかの場所があります:

  • Wikipedia: Code pages, Character encoding

  • Microsoft: Code Pages Supported by Windows

18.1. デフォルトコードページ

WinMerge が、非Unicode ファイルを扱う際の、デフォルトコードページを設定するために、 次のラジオボタンから1つ選んでください:

  • システムコードページ(デフォルト):あなたの Windows システムにより使用されているコードページです。 このデフォルトは、ほぼ、ベストチョイスです。 しかし、システムコードページを使用していないファイルを比較することが分かっているなら、他のオプションを考慮してください。

  • 現在のWinMergeユーザーインターフェイス言語に従う: WinMerge のインストールに使用したエンコーディングです。

  • カスタムコードページ: 明示的にコードページ番号を入力してください。例えば、 UTF-8や ISO-8851-1など。

18.2. html, .rc, .xml ファイルのコードページ情報を検出する

重要項目

WinMerge.exeでは、このオプションはチェックを外してください。文字列変換は、不可逆変換を生じる可能性があり、そしてそれは、非常にハイリスクです。WinMerge.exeは、現在のコードページのファイルのみを表示することができます。

  • 無効(デフォルト): WinMerge は、ソースファイルから、コードページ情報を読み取りません。その代わりに、デフォルトコードページ設定を使用します。

  • 有効: WinMerge は、次の拡張子のコードページを検出します: html, rc(VC++ のリソースファイル), xml。検出されたコードページは、デフォルトコードページオプションの設定を上書きします。

    このオプションは、あなたのドキュメントが、 Windows のものと異なるコードページを使用する場合に重要です。

    例えば、英語環境で、2つのスロバキア語か、 2つの日本語ファイルをマージするかもしれません。 このオプションが有効にされている(さらに、必要なフォントがある)場合、 あなたのスロバキア語か日本語のファイルは、スロバキア語か日本語の文字で表示されます。

    WinMergeは、左右のファイル間のコードページの差異も検出します。 マージ、コピー、ペースト時の不可逆変換を避けるために、 コードページ情報を無視することをオススメします。

    注意

    外部アプリケーションにテキストをコピー、または、貼り付ける時、外部アプリケーションは、WinMerge と同じコードページを使用するでしょう。外部エディターのドキュメントを参照してください。 WinMerge へのコピーについては、Internet Explorer は、コードページ選択機能を提供しています。 外部エディターが、カスタムコードページをサポートしていない場合、 このオプションは無効にしてください。

18.3. Detect codepage for text files using mlang.dll

TBD

19. シェル統合ページ

19.1. エクスプローラー

The コンテキストメニューに追加オプションは、Windows エクスプローラーから、直接、WinMerge を起動可能にし、そこで選択したアイテムを比較します。 それは、WinMergeインストールの最中に、デフォルトで有効か無効にされます。 有効な場合、次のオプションのうち、一方、または、両方を有効にすることができます:

拡張メニューを有効にする

  • 無効(デフォルト): Windows エクスプローラーのコンテキストメニューには、 WinMergeショートカットのみが含まれます。

  • 有効: エクスプローラーのコンテキストメニュー中の、 WinMergeショートカットを、 比較ショートカットで置き換えます。

「形式を指定して比較」メニューを有効にする

  • 無効(デフォルト): 形式を指定して比較メニューをエクスプローラーのコンテキストメニューから削除します。

  • 有効: 形式を指定して比較 メニューをエクスプローラーのコンテキストメニューに追加します。

「WindowsエクスプローラーからWinMergeの起動」では、WinMerge と 比較ショートカットの使用方法について説明しています。


ロケールサポート

WinMergeのインターフェイスはデフォルトで英語となっていますが、ローカライズが可能です。 各種インターフェイス、メニュー、ダイアログ、ツールチップ、メニュー、 メッセージの各種インターフェイスが 選択した言語に翻訳されます。

ローカライズされるのは文字列のみであることに注意してください。 例えば、数値の桁区切りや、単語の並び替えの順序などには影響されません。 (これらはWindowsのコントロールパネルの「地域と言語」設定に依存します。)

WinMergeのローカライズする手順は以下の２ステップとなります。

  1. 「言語の設定」1つ以上の翻訳ファイルをWinMergeに利用可能なファイルに設定

  2. 「WinMerge GUI言語の変更」使用可能な言語から翻訳したい言語を選択

1. 言語の設定

WinMergeでは、インストール中またはインストール後に簡単に言語の設定を行うことができます。

  • WinMergeインストール中に言語の設定を行うのが最も簡単です。 「インストーラーを使用する (推奨)」には、コンポーネントの選択ページから 1つ以上の翻訳ファイルを選択する方法が説明されています。

  • インストール時に、翻訳ファイルを構成しなかった(または、インストーラーを全く使用しなかった)場合も、 WinMergeを再インストールする必要はありません。WinMergeサイトから最新の翻訳ファイルを手に入れて構成することができます。

    1. WinMergeのインストールディレクトリ(WinMerge.exeかWinMergeU.exeがあるディレクトリ）に Languagesという名前のフォルダーを作成します。（既にLanguagesフォルダーが存在する場合はスキップして構いません。）
    2. WinMerge ダウンロードサイトに行き、 アーカイブされたバイナリファイル(Zipか7z形式のいずれか)をダウンロードし、保存します。
    3. ダウンロードされたアーカイブを解凍し、その中より*.poファイルを探します。 (*の個所は言語名となります。例えば、スウェーデンの翻訳ファイル名であればSwedish.poとなります。) WinMergeインストールディレクトリのLanguagesサブフォルダーにあなたの欲しい翻訳ファイルをコピーしてください。

    翻訳ファイルは次回WinMergeを起動した際に反映されます。

2. WinMerge GUI言語の変更

複数の翻訳ファイルがある場合は、それらから任意の言語を選択し、 設定することができます。

  1. WinMergeを起動します。
  2. Select Options from the Edit menu.
  3. Select your language and click OK in the Options dialog General page.

GUI言語の変更は、即座にWinMergeの各インターフェイスに反映されます。

3. 利用可能なWinMergeの言語

これまでの寄贈により、WinMergeは以下の言語のローカライズが可能となっています。

  • アラビア語
  • バスク語
  • ブルガリア語
  • カタロニア語
  • 中国語（簡体字・繁体字）
  • コルシカ語
  • クロアチア語
  • チェコ語
  • デンマーク語
  • オランダ語
  • フィンランド語
  • フランス語
  • ガリシア語
  • ドイツ語
  • ギリシア語
  • ハンガリー語
  • イタリア語
  • 日本語
  • 韓国語
  • リトアニア語
  • ノルウェー語
  • ペルシア語
  • ポーランド語
  • ポルトガル語
  • ブラジルポルトガル語
  • ルーマニア語
  • ロシア語
  • セルビア語
  • シンハラ語
  • スロバキア語
  • スロベニア語
  • スペイン語
  • スウェーデン語
  • タミル語
  • トルコ語
  • ウクライナ語

4. 翻訳ミスの報告

あながたが翻訳ミスを見つけた場合は、バグとして バグリストに投稿してください。 また、翻訳された文章の訂正版を提供してくだされば幸いです。

5. 新しい翻訳の提出

新たに翻訳ファイルをリストに追加したい場合は、WinMergeのサイトにある翻訳ドキュメント を読み、方法を学んでください。ほとんどの翻訳が完全にできていないため、ぜひご協力をお願いいたします。翻訳する（または翻訳を改善する）に あたって、コンパイルツールや、WinMergeの知識をすべて備えている必要はありません。もし困ったことがあれば、 WinMergeフォーラムより、私たちに支援を求めてください。


プラグイン

WinMergeプラグインは、COM APIで書かれたカスタムDLLまたはスクリプトレットです。 これは、比較の前にデータを前処理します。 例えば、WinMergeで比較するためにMS Word のファイルからテキストデータを抽出するプラグインがあります。

プラグインは:

  • １つのdllまたはスクリプトレット (sct) ファイル

  • MergePlugins サブフォルダーにインストールされます。WinMergeは、いくつかのプラグインをインストールします。

  • インストールが簡単: WinMergeのインストールに含まれていないプラグインをインストールするには、プラグインファイルをMergePlugins にコピーするだけです。 プラグインは、次回WinMergeを開いたときに利用可能になります。 ウェブ上で他の開発者が書いた多くのプラグインを見つけることができます。

1. プラグインの種類

プラグインは3つの主なカテゴリに分類されます:

エディタースクリプトプラグイン

このタイプのプラグインは、ファイル比較ウィンドウのアクティブなエディター（ファイルペイン）で選択したテキストに対してカスタム操作を実行します。

展開プラグイン - ファイルからテキストフォーマットへ

このタイプのプラグインは、圧縮ファイルを解凍して表示可能な形式に変換します。 元のファイルは変更されません。 一時的に変換されたファイルが作成され、WinMergeにロードされます。

展開プラグインは、選択されたテキストやファイル内の差分に対してではなく、ファイル全体に対して機能します。 したがって、フォルダー比較ウィンドウまたはファイルまたは フォルダーの選択ダイアログからファイル比較を起動するときのみ利用可能です。 展開プラグインはファイル比較ウィンドウでは利用できません。

プラグインによっては、展開されたファイルを再圧縮することができます (「使用できるプラグイン」 の詳細を参照して、 再圧縮がサポートされているかどうかを確認してください）。 その後、変換されたファイルをマージして保存できます。 この場合、梱包は自動的に行われます。 安全のために、変換したファイルを保存するときに名前を変更することをお勧めします。

注意

フォルダーを比較すると、WinMergeは圧縮ファイルと非圧縮ファイルに 対して異なる結果をもたらす可能性があります。 たとえば、圧縮されていないときには同一のファイルでも、 圧縮された場合、作成日が含まれているために異なる場合があります。 WinMergeはすべての状況で展開プラグインを適用します。フォルダーを比較するときや、 ２つのファイルを比較するときでも同じ結果が得られます

プラグインの例: 「CompareMSExcelFiles」 Microsoft® Excel ファイルのテキスト内容を表示します。

比較前処理プラグイン: 差異を隠すためのファイルの前処理

この種類のプラグインは、 比較ウィンドウに表示されている元のファイルには作用しません。 代わりに元のファイルから何らかの加工を行ったファイルを一時的に作成し、 そのファイルから差異リストを作成します。

プラグインの例: 「IgnoreColumns」 指定された列範囲に表示されている文字の違いを 無視します。

2. 提案されたプラグインと自動モード

WinMergeはどのようにして渡されたファイルに適切なプラグインを適用しているのでしょうか？ 各プラグインはファイル拡張子のリストを持っています （「使用できるプラグイン」セクションの各プラグインのファイルフィルターにも リストされています) その拡張子は、1つ以上のファイルタイプをプラグインに関連付けるために使用されます。: 比較するファイルの拡張子があるプラグインの拡張子リストと一致する場合、 そのプラグインが提案されたプラグインとなります。

このトピックで後述する展開プラグインタイプと比較前処理プラグインタイプには 別々のオプションがあり、これらを使用して手動または自動でプラグインを適用できます。 エディタースクリプトプラグインには自動モードはありません。

自動モードを使用して選択したファイルにプラグインを適用すると、 WinMergeは、そのファイルタイプの推奨プラグインのリストを検索し、 名前が一致する最初のプラグインを適用します。 検索はアルファベット順で実行されます。このため、ファイルタイプに複数の推奨プラグインがある場合、 最初に見つかったもののみが適用されます。

3. プラグインの適用

次のサブセクションでは、各タイプのプラグインを適用する方法について説明します。 方法はプラグインのタイプごとに異なり、 フォルダーとファイルのどちらを比較するかどうかによっても異なります。

3.1. ファイル比較ウィンドウでのエディタースクリプトプラグイン適用

ファイル比較ウィンドウのファイルペインにカーソルを置き、 プラグイン → スクリプトをクリックして、次の機能のいずれかを選択します:

  • 大文字に変換

  • 小文字に変換

  • 重複行を削除

  • 重複行をカウント

  • 昇順にソート

  • 降順にソート

  • 列を逆順

  • 行を逆順

  • 列を抽出...

  • 行を抽出...

  • 置換...

  • フィルターコマンドを適用...

  • トークン分割...

  • 行頭行末の空白を削除

  • 日付を挿入

  • 時刻を挿入

スクリプト メニューのこの機能は、「editor addin」 と 「insert datetime」 プラグイン によるものです。

注意

エディター補完プラグインは、フォルダー比較ウィンドウでは使用できません。

3.2. フォルダー比較ウィンドウでの展開プラグインの適用

展開プラグインを適用する前に、 モードを自動モードまたは手動モードに設定できます。

  • このタイプのプラグインの自動モードを設定するには、 プラグイン → 自動展開をクリックしてください。

  • 手動モードを設定するには、プラグイン → 手動展開をクリックしてください。

新たな設定を反映するにはフォルダー比較ウィンドウをF5をクリックして、 リロードしてください。

3.2.1. 自動展開モードの使用

自動展開が設定されているときにプラグインを適用するには、 フォルダー比較ウィンドウでファイルの比較操作を開始するだけです。 ファイルのタイプから自動的に選択された展開プラグイン（存在する場合）がファイルを前処理し、 WinMergeがファイル比較ウィンドウで開きます

たとえば、MS Wordのdocファイルを右クリックして Compareを選択するとします (「CompareMSWordFiles」プラグインが利用可能であると仮定します)。 WinMergeは、docファイル（またはそのコピー）をプレーンテキストファイルに変換し、 ファイル比較ウィンドウで開きます。

3.2.2. 手動展開モードの使用

手動モードでは、自動モードで選択されたものとは異なる展開プラグインを選択できます。 プラグインを使用せずに比較することもできます。

手動展開が設定されているときにプラグインを適用するには:

  1. 比較するファイルを選択します。

  2. プラグイン → 展開プラグインで開くをクリックします

    選択したファイルのタイプが利用可能な展開プラグインによってサポートされている場合にのみ、 このメニュー項目が有効になります。

  3. 展開プラグインの選択ダイアログで:

    1. 自動展開を設定するか、または手動でプラグインを選んでください。

      • 自動展開モード(最初の利用可能なプラグインを適用)を使用するには、ファイル展開プラグイン にて<自動展開>を選択してください。

      • 異なったプラグイン(利用可能であれば)を選択したい場合は、ファイル展開プラグインにてプラグインを選択してください。

        デフォルトでは、比較する対象にファイルに応じた拡張子用のプラグインだけを表示します。すべての利用可能なプラグインを見るためには、 すべての展開プラグインを表示し、拡張子をチェックしませんオプションを有効にしてください。

      • プラグインを使用せずに比較を行い対場合は、ファイル展開プラグインにて <なし>を選んでください。

    2. OKをクリックして、展開プラグインの選択ダイアログを閉じてください。

  4. OKをクリックして、 「展開プラグインの選択」ダイアログを閉じて、ファイル比較を開始します。

3.3. ファイル/フォルダー選択ダイアログでの展開プラグインの適用

「ファイルまたはフォルダーの選択」ダイアログからファイル比較を起動するときに、 「展開プラグインの選択」ダイアログを使用してプラグインを適用できます。 詳細は、「ファイル比較で使用する展開プラグインの選択」 を参照してください。

3.4. フォルダー比較ウィンドウでの比較前処理プラグインの適用

比較前処理プラグインでは、モード(<Automatic>または <None>）またはプラグイン名を個々のファイルに設定します。 （これをすべてのファイルのモードを設定する展開プラグインと比較してください。） つまり、同じフォルダー内のいくつかのファイルには異なる比較前処理モードがあります。

フォルダー比較ウィンドウで1つ以上のファイルのモードを設定するには、 ファイルを右クリックしてプラグイン設定 → 比較前処理プラグイン設定を選択し、サブメニューオプションのいずれかを選択します。

  • <Automatic> は、 指定したファイルのタイプに使用できる比較前処理プラグインの最初のものを選択します。

  • <None>は、比較前処理プラグインを使用しません。

ウィンドウを更新するにはF5をクリックしてください。

注意

非再帰比較中にサブフォルダーを開くと、モードは常に <None>にリセットされます。

フォルダー比較ウィンドウからファイルを開くと、 ファイル比較ウィンドウが開く前にそのファイルの比較前処理プラグイン設定が適用されます。

3.5. ファイル比較ウィンドウでの比較前処理プラグインの適用

ファイル比較ウィンドウで、 プラグイン → 比較前処理プラグインをクリックして、リスト内のプラグインの1つを選択することにより、 比較前処理プラグインを適用できます。推奨されるプラグインはリストの上部に示されています。 プラグインが適用された後にファイルが再度比較されるため、ファイルを再スキャンする必要はありません。

4. 使用できるプラグイン

4.1. CompareMSExcelFiles

Microsoft® Excel ファイルのテキストの内容を表示します。すべてのフォーマットおよび埋め込みオブジェクトは取り除かれて表示されます。

分類: 展開プラグイン
ファイルフィルター: *.xls, *.xlsx, *.xlsm, *.xlsb, *.xla, *.xlax, *.xltx, *.xltm
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: Yes
依存するもの: Microsoft® Excel

4.2. CompareMSPowerPointFiles

Microsoft® PowerPoint ファイルのテキストの内容を表示します。すべてのフォーマットおよび埋め込みオブジェクトは取り除かれて表示されます。

分類: 展開プラグイン
ファイルフィルター: *.ppt, *.pptx, *.pptm, *.ppa, *.ppam, *.pot, *.potx, *.potm
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: Yes
依存するもの: Microsoft® PowerPoint

4.3. CompareMSVisioFiles

Microsoft® Visio ファイルのテキストの内容を表示します。すべてのフォーマットおよび埋め込みオブジェクトは取り除かれて表示されます。

分類: 展開プラグイン
ファイルフィルター: *.vsd, *.vsdx, *.vsdm, *.vss, *.vssx, *.vssm, *.vst, *.vstx, *.vstm
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: Yes
依存するもの: Microsoft® Visio

4.4. CompareMSWordFiles

Microsoft® Word ファイルのテキストの内容を表示します。すべてのフォーマットおよび埋め込みオブジェクトは取り除かれて表示されます。

分類: 展開プラグイン
ファイルフィルター: *.doc, *.docx, *.docm, *.dot, *.dotx, *.dotm
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: Yes
依存するもの: Microsoft® Word

4.5. PrettifyHTML

tidy-html5 を使用して HTML ファイルを整形します。

PrettifyHTML [arguments...]

arguments

tidy コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.html, *.htm
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: tidy-html5

4.6. PrettifyXML

tidy-html5 を使用して XML ファイルを整形します。

PrettifyXML [arguments...]

arguments

tidy コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.xml
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: tidy-html5

4.7. PrettifyJSON

jq コマンドを使用してJSON ファイルを整形します。

PrettifyJSON [arguments...]

arguments

フィルターまたは jq コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.json
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: jq

4.8. PrettifyYAML

yq コマンドを使用してYAML ファイルを整形します。

PrettifyYAML [arguments...]

arguments

フィルターまたは yq コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.yaml, *.yml
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: yq

4.9. QueryCSV

q コマンドを使用して CSVファイルからデータを抽出します。

QueryCSV [arguments...]

arguments

SQL文または q コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.csv
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: q

4.10. QueryTSV

q コマンドを使用して TSVファイルからデータを抽出します。

QueryTSV [arguments...]

arguments

SQL文または q コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.tsv
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: q

4.11. QueryJSON

jq コマンドを使用して JSONファイルからデータを抽出します。

QueryJSON [arguments...]

arguments

フィルターまたは jq コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.json
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: jq

4.12. QueryYAML

yq コマンドを使用して YAMLファイルからデータを抽出します。

QueryYAML [arguments...]

arguments

フィルターまたは yq コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.yaml, *.yml
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: yq

4.13. ValidateHTML

tidy コマンドを使用して HTMLファイルを検査します。

ValidateHTML [arguments...]

arguments

tidy コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.html, *.htm
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: tidy-html5

4.14. PreviewGraphviz

Graphviz ファイルを画像化して表示します。

PreviewGraphviz [arguments...]

arguments

dot コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.gv, ,*.dot
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Graphviz

4.15. PreviewMarkdown

Markdown ファイルをHTMLに変換して表示します。

PreviewMarkdown [arguments...]

arguments

md2html コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.md, ,*.markdown
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: md4c

4.16. PreviewPlantUML

PlantUML ファイルを画像化して表示します。

PreviewPlantUML [arguments...]

arguments

plantuml.jar コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.pu, ,*.puml
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Java, PlantUML, Graphviz

4.17. ApacheTika

Apache Tika を使用してファイルからテキストを抽出します。

ApacheTika [arguments...]

arguments

tika-app.jar に渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.*
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Java, Apache Tika

4.18. DisassembleJVM

javap を使用してJVMバイトコードをディスアセンブルします。

DisassembleJVM [arguments...]

arguments

javap コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.class
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Java

4.19. DisassembleIL

ildasm を使用してILコードをディスアセンブルします。

DisassembleIL [arguments...]

arguments

ildasm コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.obj, *.lib, *.exe, *.dll
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Visual Studio

4.20. DisassembleNative

dumpbin を使用してネイティブコードをディスアセンブルします。

DisassembleNative [arguments...]

arguments

dumpbin コマンドに渡すコマンドラインオプション。

分類: 展開プラグイン
ファイルフィルター: *.obj, *.lib, *.exe, *.dll
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Visual Studio

4.21. ExecFilterCommand

フィルターコマンドを適用します。

ExecFilterCommand [command]

command

実行するコマンド。 コマンド内の %1 はファイル名に置き換わります。

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.22. MakeUpper

テキストを大文字に変換します

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.23. MakeLower

テキストを小文字に変換します

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.24. RemoveDuplicates

重複行を削除します

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.25. CountDuplicates

重複行をカウントします

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.26. SortAscending

行を昇順にソートします

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.27. SortDescending

行を降順にソートします

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.28. ReverseColumns

列を逆順にします

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.29. ReverseLines

行を逆順にします

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.30. SelectColumns

指定した列を抽出します。

SelectColumns [ranges]

SelectColumns [-v] [-i] [-g] [-e patterns]

ranges

抽出する列範囲のリスト (例 -3,5-10,30-)

patterns

正規表現

-v

マッチしない列を抽出します

-i

大文字小文字を無視します

-g

グローバルフラグを有効にします

-e

パターンマッチングにpatternsを使用します

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.31. SelectLines

指定した行を抽出します。

SelectLines [ranges]

SelectLines [-v] [-i] [-e patterns]

ranges

抽出する行範囲のリスト (例 -3,5-10,30-)

patterns

正規表現

-v

マッチしない行を抽出します

-i

大文字小文字を無視します

-e

パターンマッチングにpatternsを使用します

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.32. Replace

テキストを置換します。

Replace [-i] [-e] [text_to_find] [text_to_replace]

text_to_find

検索するテキスト

text_to_replace

置換するテキスト

-i

大文字小文字を無視します (-e指定時のみ有効)

-e

指定したテキストを正規表現として扱います

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.33. Tokenize

トークン分割を行います。

Tokenize [patterns]

patterns

トークン分割に使用する正規表現 (例 [^\w]+)

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: Yes
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.34. Trim

行頭行末の空白を削除します

分類: 展開プラグイン
ファイルフィルター: *.nomatch
プラグイン引数: No
書き戻し: No
設定ダイアログサポート: No
依存するもの: Windows Script Host

4.35. IgnoreColumns

このプラグインは、指定された列の文字を無視します。 最初の列の番号は1です。

このプラグインはタブ付きのファイルをサポートしていないことに注意してください。 プラグインは失敗しませんが、すべてのタブは通常の文字として扱われます。

列を指定するには、プラグイン設定ダイアログを使用するか、次のフィールドをパラメーターとして使用してdllの名前を変更します:

  • 範囲間の区切り文字: _ または ,
  • 最小と最大の間の区切り文字: その他の文字
  • 最小と最大は範囲に含まれます。
  • max = minの場合、maxは省略できます。

例1 IgnoreColumns examples

IgnoreColumns _ 3 _ 10 - 20 _ 32 - 33.dll
列3、列10から20、列32から33のすべての文字を無視します。
IgnoreColumns_1,30 to 40.dll
列1と列30から40のすべての文字を無視します。

分類: 比較前処理プラグイン
ファイルフィルター: *.txt
プラグイン引数: Yes

4.36. IgnoreCommentsC

このプラグインはC言語, C++, PHP, JavaScript ファイルの //... と /* ... */ で区切られたコメントを無視します。

分類: 比較前処理プラグイン
ファイルフィルター: *.cpp, *.cxx, *.h, *.hxx, *.c, *.php, *.js, *.cs, *.ts
プラグイン引数: No
設定ダイアログサポート: No

4.37. IgnoreFieldsComma

このプラグインは、フィールドとコンマを区切り文字として使用するファイル用です （CSVファイルなど）。 区切り文字は無視されます。 最初のフィールドの番号は1です。

区切り文字を指定するには、プラグイン設定ダイアログを使用するか、 「IgnoreColumns」に使用されるのと同じパラメーターフィールドを使用して dllの名前を変更します。

分類: 比較前処理プラグイン
ファイルフィルター: *.csv
プラグイン引数: Yes
設定ダイアログサポート: Yes

4.38. IgnoreFieldsTab

このプラグインは、フィールドとタブを区切り記号として使用するファイル用です (たとえばExcel ファイルは*.txt形式で保存されます）。 区切り文字は無視されます。 最初のフィールドの番号は1です。

区切り文字を指定するには、プラグイン設定ダイアログを使用するか、 「IgnoreColumns」に使用されるのと同じパラメーターフィールドを使用して dllの名前を変更します。

分類: 比較前処理プラグイン
ファイルフィルター: *.txt
プラグイン引数: Yes
設定ダイアログサポート: Yes

4.39. IgnoreLeadingLineNumbers

このプラグインは、テキストファイル (NCファイルやBASICファイルなど)の先頭の行番号を無視します。

分類: 比較前処理プラグイン
ファイルフィルター: *.nc
プラグイン引数: No
設定ダイアログサポート: No
必要なもの: 「Visual Basic ランタイムライブラリ」

4.40. editor addin

いくつかの関数をプラグイン → スクリプト メニューに追加します:

  • 大文字に変換 選択範囲を大文字に変換します。
  • 小文字に変換 選択範囲を小文字に変換します。
  • 重複行を削除 選択範囲内の重複した行を削除します。
  • 重複行をカウント 選択範囲内の重複した行を削除し、重複行の数+1を行末に挿入します。
  • 昇順にソート 選択範囲の行を昇順にソートします。
  • 降順にソート 選択範囲の行を降順にソートします。
  • 列を逆順選択範囲内の列を逆順にします。
  • 行を逆順選択範囲内の行を逆順にします。
  • 列を抽出... 選択範囲内の指定した列を抽出します。
  • 行を抽出... 選択範囲内の指定した行を抽出します。
  • 置換... 選択範囲内の文字列を別の文字列に置換します。
  • フィルターコマンドを適用... 選択範囲を指定したフィルターコマンドの出力に置き換えます。 コマンド内の %1 は現在のペインのファイル名に置き換わります。
  • トークン分割... 選択範囲内でトークンの区切りを改行に置換します。
  • 行頭行末の空白を削除 選択範囲内の行頭と行末の空白を削除します。
分類: エディター補完
ファイルフィルター: *
設定ダイアログサポート: No

4.41. insert datetime

プラグイン → スクリプト メニューに2つの機能を追加します:

  • 日付を挿入 insert date in the current locale format.
  • 時刻を挿入 insert time in the current locale format.
分類: エディター補完
ファイルフィルター: *
設定ダイアログサポート: No

5. 必要なもの

5.1. Windows Script Host

一部のエディター補完プラグインには、 Microsoft®のコンポーネントが必要です

Windows XPより前の古いバージョンのWindowsを使用しない限り、既に含まれているはずです。

5.2. Visual Basic ランタイムライブラリ

一部のプラグインでは、動作するためにVisual Basic ランタイムライブラリが必要です。

Microsoft®のRun-Time Redistribution Packが使用できます。 プラグインが不要な場合は、安全に削除できます。


フィルターの使用

ファイルやフォルダー比較の際、比較範囲を限定するためにファイルフィルターを使用することができます。 これは、比較結果から、あなたが興味のない差異を取り除きたい場合に便利です。 フィルターは、正規表現を元に規定します。 WinMerge は、ポピュラーな PCRE (Perl Compatible Regular Expressions) 正規表現エンジンを使用しています。

フィルターの基本機能はシンプルです。 通常比較されるであろう、それぞれのアイテム(フォルダー、ファイル、ファイル中の行)を評価し、 対象のアイテムがフィルター式にマッチした場合、フィルターを適用します。 フィルタータイプにより、アイテムは、比較に含められるか、除外されるかのどちらかです。

フォルダー比較用とファイル比較用の異なるWinMergeフィルターがあります。

フォルダー比較: ファイルマスクとファイルフィルター

単純なファイルマスク、または、より複雑なフィルターにより、 ファイルフィルター中で指定された複数の規則を適用することで、 フォルダー比較中に含めるファイルを指定することができます。 ファイルマスクとファイルフィルターの両方を、同一の操作中で適用することができます。

フィルターされるファイルやフォルダーは、デフォルトで隠されます。それは、典型的にあなたが望むものでしょう。フィルターされたアイテムを表示するには、表示 → スキップされた項目の表示をクリックしてください。しかし、フォルダー比較ウィンドウは、それらについて最小限の情報しか表示しません。例えば、あなたは、スキップされたファイルがテキストファイルかバイナリファイルか判らないでしょう。

ファイル比較: 行フィルターと置換フィルター

行フィルターは、ファイル比較操作のみに適用されます。 それにより、単一行の差異を無視することができます。

置換フィルターは、ファイル比較操作のみに適用されます。 置換フィルターは、diffブロック内の文字列を指定された文字列に置換して比較し、 結果が一致する場合はそのdiffブロックを無視します。 これは、興味のない多数の変更を無視するのに役立ちます。

1. ファイルマスクの使用

フォルダー比較中に含める拡張子を指定する、1つか複数の ファイルマスクを使用することができます。 その他すべてのファイルは、選択から省かれます。

1.1. ファイルマスクと定義と適用

フォルダー比較操作を実行時に、ファイルマスクを定義し適用する:

  • ファイルまたはフォルダーの選択ダイアログを使用しているなら、 1(左)と 2(右)のフォルダー選択後、 フィルターフィールドへ、 1つか複数のファイルマスクを入力してください。 マスクは、フォルダー比較操作を開始した時に適用されます。

  • WinMergeのコマンドラインを使用している場合は、ファイルマスクを指定する -fフラグ(次のセクションの例を参照)を使用してください。

フィールドやコマンドラインで、ファイルマスクとファイルフィルターの、 両方を指定することはできないことを憶えておいてください。

1.2. ファイルマスクの文法と例

このシンタックスは、ファイルマスク用です:

[!](*.[拡張子]|フォルダーマスク\)[区切り文字[!](*.拡張子|フォルダーマスク\) ...]

有効な区切り文字はスペース、カンマ、コロン、セミコロンです。

拡張子なしのマスク(*.)は、 README の様な、拡張子なしのファイルを選択します。

2.16.19 以降、感嘆符(!) をマスクの前に付加した場合、そのマスクに一致したファイルは除外されます。 また、バックスラッシュ(\)をマスクの後に付加した場合、 そのマスクはファイルではなくフォルダーが対象となります。

例1 ファイルマスク

このコマンドラインの例では、フォルダー比較操作は、拡張子 xmlか txtのファイルのみを含みます。 その他すべてのファイルは省かれます:

WinMergeU c:\project\docs c:\temp /f *.xml;*.txt

例2 フォルダーの除外(2.16.19以降)

このコマンドラインの例では、フォルダー比較操作は、 .gitと .vsフォルダーを除外します:

WinMergeU c:\project\docs c:\temp /f !.git\;!.vs\

2. ファイルフィルターの使用

ファイルフィルターは、拡張子 fltのテキストファイルです。 これらは、フォルダー比較用の複数のフィルタールールを適用することを可能にします。 ファイルマスクと異なり、ファイルフィルターは、含むか除外、どちらかにマッチすることができます。

WinMergeは、たくさんの定義済ファイルフィルターをインストールします。 もし、必要なフィルターが、これらのファイルフィルターで提供されていなかったら、 自分自身で作成することができます。 タスクをもっと簡単にするために、WinMergeは、 FileFilter.tmplという名前のテンプレートも提供しています。 このセクションは、比較にファイルフィルターを適用する方法と、ファイルフィルターの文法を説明します。 「フィルターダイアログの使用」では、フィルターの追加、編集、管理方法について説明します。

2.1. ファイルフィルターの場所

WinMergeは、次の場所のファイルフィルターを自動的に検出します:

WinMerge インストールフォルダーのFilters フォルダー

ここには、定義済ファイルフィルターがインストールされています。例えば、 C:\Program Files\WinMerge\Filters。 システム上のすべてのユーザーに有効にするために、 ここにファイルフィルターを作成、または、コピーすることができます。

新しいファイルフィルターを作る前に、定義済フィルターに必要なものが含まれているか確認してください。 含まれていない場合、定義済ファイルの中から役立つルールが見つかるかもしれません。

デフォルトプライベートフィルターフォルダー

このフォルダーの場所は、WinMerge オプションの、システムページで定義されています。 デフォルトでは、あなたのユーザープロファイルフォルダーのサブフォルダーとして指定されています (Windows 10なら、Documents\WinMerge\Filters)。 通常、ここに作成、または、コピーされたフィルターは、 あなただけが見ることができます。 新しいファイルフィルターを作成したら、それらをプライベートにするために、 ここにコピーすることができます。

その他のフォルダーにあるファイルフィルターを適用する前に、 それらをインストールしなければなりません。

2.2. ファイルフィルターの適用

次のいくつかの方法で、ファイルフィルターを適用することができます:

  • ファイルまたはフォルダーの選択ダイアログから、フォルダー比較を起動した時:

    1. 1(左)と 2(右)のフォルダー選択後、 フィルターフィールドの隣にある 選択ボタンをクリックしてください。

    2. フィルターダイアログで、ファイルフィルターを選択し、 フィルターフィールドへロードするには、ファイルフィルタータブを使用します。

      注意

      ファイルフィルターが有効になっている(訳注: 何れかのファイルフィルターが選択されている状態)場合、選択されたファイルフィルターは、 フィルターフィールドへ既にロードされています。

    3. 比較操作を続けてください。操作を開始した時、 フィルターフィールドのファイルが適用されます。

  • フォルダー比較操作起動後(違うフィルターを適用した、 または、フィルターを無効にしてしまった時など)にファイルフィルターを変更するには:

    1. ツール → フィルターをクリックしてください。

    2. フィルターダイアログで、新しいフィルターを設定し、 OKをクリックしてください。

    3. フィルターダイアログを閉じた時、新しいフィルターは自動では適用されません: フォルダー比較ウィンドウ中で新しい結果を見るには、 F5を押下してください。

  • WinMerge コマンドラインから、 フォルダー比較起動時にファイルフィルターを指定するには、 -fフラグを使用してください。

フィールドやコマンドラインで、 ファイルマスクとファイルフィルターの両方を指定する ことはできないことを思い出してください。

2.3. ファイルフィルターの文法

このセクションは、WinMerge ファイルフィルターの文法と、記述のためのガイドラインの提供について説明します。

コメント記号は、 ##です。 コメント記号の後にある、行内のすべての文字は無視されます。 WinMergeは、ルール中のほとんどの空白文字を無視します。 しかしながら、通常は、コメントの前に1つか複数の空白文字(スペースかタブ)が置かれるでしょう。 ルール中で、 ##を文字列として使用するには、後ろの空白文字を取り除いてください。

ファイルフィルターで、まずはじめに必要な2行は:

name

ファイルダイアログに表示されるフィルター名です

def

適用されるフィルタータイプです。次の値のうち、1つを指定してください:

include

指定されたルールにマッチしたアイテム以外はすべて含めます。

exclude

指定されたルールにマッチしたアイテム以外はすべて除外します。

excludeメソッドを選択した時は、サブフォルダーを指定するd(ディレクトリ)ルールも追加しなければなりません。このように、すべてのサブフォルダーを指定するのは、通常良いアイデアです:

d: \\*$ ## Subfolders

ティップ

これらの用語で混乱しないでください。ファイルフィルターのincludeルールは、「何を含めるか」を指定するわけではありません。「何を含めない」かを指定します。同様に、excludeルールは、「何を除外する」かを指定するわけではありません。「何を除外しないか」を指定します。

次に、フィルターファイルは、1つ以上のフィルタールールを含むべきです。 あなたは、たくさんのルールを好きなだけ追加できます。 1行には1つのルールがあるべきで、それぞれのルールは、 それぞれ1行にあるべきです(ルール中での改行は許可されません)。 (訳注: 回りくどいですが、「ルールは1行で記述してください」ということです。) それぞれのルールは、タイプデザイナー f:かd:を含み、その後に、正規表現が続きます:

f: regexp

ファイルにマッチ、または、

d: regexp

フォルダーにマッチ

2.16.19 以降、 f: と d: でマッチしたファイルまたはフォルダーの一部を除外するためのタイプデザイナー f!: と d!: が使用できます。

多くの正規表現の特殊文字の中で、次の文字は、ファイルフィルターでは特に重要です:

^ (行頭)

ルールが正しく動作するために頻繁に必要になります。

$ (行末)

ルールが正しく動作するために頻繁に必要になります。例えば:

\.c$ ## 拡張子
              cのファイルのみにマッチします。
              \.c ## cppや
              comのような、拡張子が
              cで始まるファイルにマッチします。
\ (エスケープ)

通常の文字を、特殊文字にマッチさせるために使います。 例えば、フォルダー名にマッチするために、 フォルダー区切り文字のバックスラッシュの前に、 バックスラッシュを置きます(\\)。 ファイル名中のドットにマッチするために、 バックスラッシュを指定し、その後にドットを置きます(\.)。

特殊文字やワイルドカードは、ファイル名とマッチさせるためには、使用されません。 ある型のすべてのファイル名にマッチするためには、単にファイル名を省略します。

ルールは、大文字・小文字を区別しません。例えば、 f: \.bat$は、 winmerge.batと compare.BATにマッチします。

例3 ファイルフィルタールールの例

シンプルなファイルフィルタールール:

f: \.cpp$ ## *.cppファイルにマッチ
          f: \.h$ ## *.hファイルにマッチ
          f: ^My ## My*.*ファイルにマッチ
          f: Dlg\. ## *Dlg.*ファイルにマッチ
          d: \\test$ ## testフォルダーにマッチ
          d: ^\\Build$ ## Buildフォルダーマッチ
          d: Temp$ ## *Tempフォルダーにマッチ (例:FirstTemp)
          d: Src ## *Src*フォルダーにマッチ

いくつかのルールは、もっと複雑な正規表現です:

          f: ^\.#.*$ ## .#filename.versionファイル
          f: Dlg\.c(pp)?$ ## *Dlg.cと*Dlg.cppファイル
          f: ^I.*\.h$ ## I*.hファイル
          f: Srv[1-9]\.def$ ## *Srv1.def から *Srv9.defファイル
          f: ^[h,k,m] ## h*.*d、k*.*、m*.*ファイル

3. 行フィルターの使用

ファイル比較で単一行を無視するために、行フィルターを使用することができます。 例えば、コメント、生成されたコードの決まった型や、 バージョン管理システムのタイムスタンプの様なものを無視するために、 行フィルターを使うかもしれません。各行フィルターは1つのルールです。 ファイル比較のために、たくさんの行フィルターを使用することができます。

フィルターの追加、編集、管理については、 「フィルターダイアログの使用」を参照してください。

3.1. 行フィルターの適用

次の方法で、行フィルターを適用することができます:

  • ファイルまたはフォルダーの選択ダイアログから、 ファイル比較を起動する場合

    1. 1(左)と 2(右)のファイル選択後、 フィルターフィールドの隣の 選択をクリックしてください。

    2. フィルターダイアログで、使用したい行フィルターを有効化するため、 また、現在どの行フィルターが有効かを確認するには、行フィルタータブを使います。

      注意

      フィルターフィールドは、 どの行フィルターが有効化されているかを表示しません。

    3. ファイル比較操作を続けてください。 操作を開始した時に、有効化された行フィルターが適用されます。

  • 既に、ファイル比較操作を起動後 (違うフィルターを適用した、または、フィルターを無効にしてしまった時など)は、

    1. ツール → フィルターをクリックしてください。

    2. ファイルフィルタータブを開いてください。

    3. あなたが適用したい行フィルターの行にチェックしてください。 また、適用したくないフィルターは、チェックを外してください。

      新規、 編集、 削除ボタンを使用して、 フィルターを追加、編集、削除することもできます。

    4. 行フィルター機能を有効にするには、 行フィルターを有効にするにチェックしてください。 行フィルター機能を無効にするには、チェックを外してください。

    5. OKをクリックして、 ファイルフィルターダイアログを閉じてください。

    6. F5を押下して変更を適用し、 ファイル比較ウィンドウをリフレッシュしてください。

3.2. 行フィルターの文法

行フィルターは、行フィルタールールが有効化されている場合、 比較ファイル中の単一行の差異毎に評価されるルールです。 単一行の差異にルールがマッチした時、その差異は無視されます。

無視された差異は、ファイル比較ウィンドウ中では、 無視された差異の色(WinMergeオプションの色ページで定義されている) でマークされます。 これは、その他のタイプと無視された差異を区別できるようにします。 しかし、無視された差異は、選択やマージすることができません。

行フィルターマッチは、2つの考えに基づいて記述されるかもしれません:

  • ルールが、行のある部分にマッチした時、差異全体が無視されます。 つまり、行の一部だけをフィルターすることはできません。 例えば、2つのファイルに、次の単一行の差異があると仮定した場合:

    File1:

    # Jean Sibelius

    File2:

    # Janne Sibelius

    フィルターなしの場合、行は差異として検出されます。 しかし、行フィルターを ^#の式とともに適用する場合、その行は同一であると評価されます。 なぜなら、式は、両方のファイルにマッチする最初の文字のみを指定しているからです。

  • ルールは、すべての行にマッチした場合に、複数行差異に適用されます。例えば、次の2行の差異を考えてみてください:

    File1:

    # Jean Sibelius
# Pekka Himanen

    File2:

    # Janne Sibelius
Pekka Himanen

    同じ ^#ルールは、1行目にマッチしますが、2行目にはマッチしません。 したがって、差異は無視されません。

ティップ

パターンの正確さを制御するために、 行頭(^)と行末($) 記号を使用することは、大抵、良い習慣です。 なぜなら、式が、行のある部分にマッチした場合に、 ルールが適用されるからです。

例4 行フィルターサンプル

^MYTAG$

厳密に、 MYTAGにマッチする行をフィルターします

^::

::で始まる行をフィルターします

^/\*.*\*/$

/*で始まり、*/で終わる行をフィルターします

^[1-5]00

数字の、100、200、300、400、500 で始まる行をフィルターします

例5 CVS の Id 行にマッチする行フィルタールール

CVS の Id 行は、次の様なものです:

// $Id: Filters.xml 7591 2013-01-20 15:47:42Z christianlist $

そしてこれは、次のルールでフィルターできます:

^// \WId: .*\$

例6 poファイルの行コメントフィルター

poファイルの行コメントは、次の様なものです:

#: src/filename.c:766

そしてこれは、次のルールでフィルターできます:

^#

4. Using substitution filters

TBD

5. フィルターダイアログの使用

このセクションは、ファイルフィルターと行フィルターの作成・管理機能を提供する、 フィルターダイアログの説明をします。

フィルターダイアログを開くには、次の何れかの方法を使用してください:

  • ファイルまたはフォルダーの選択ダイアログで、 フィルターフィールドの右にある、 選択ボタンをクリックしてください。 フォルダー比較用のファイルフィルターを適用したい時は、方法を使用してください。

  • ツール → フィルターをクリックしてください。 この方法は、ファイルまたはフォルダーの選択ダイアログを開いている時以外に使用可能です。

フィルターダイアログには、それぞれの WinMergeフィルター用のタブがあります:

ファイルフィルター

フォルダー比較用のファイルフィルターを設定するには、このタブを選択してください。

Line Filters

ファイル比較用の行フィルターを設定するには、こちらのタブを使用してください。

Substitution Filters

Choose this tab to work with substitution filters for file compare operations.

5.1. ファイルフィルタータブの使用

このタブの主要部分は、フォルダー比較用に利用可能なファイルフィルターの一覧です。 このリストは、共有、個人、そして、 「ファイルフィルターの場所」で説明されている、 WinMergeが知り得るインストール済みのファイルフィルターを含んでいます。

5.1.1. ファイルフィルターの有効化と無効化

ファイルフィルターが、フォルダー比較操作で、それを有効にすること、 また、フィルターが使用され始めてから、 現在のフィルターを止めるために無効にすることを可能にしなければなりません:

  1. まだ、フィルターダイアログを開いていない場合は、開いてください

  2. ファイルフィルターを選択、もしくは、リストから <なし>を選択しくてださい。

  3. OKをクリックして、 フィルターダイアログを閉じてください。

ファイルフィルターを有効にした後でそれらを適用する方法が、いくつかあります。 詳細は、 「ファイルフィルターの適用」を参照してください。

5.1.2. ファイルフィルターの設定

ファイルフィルターリストの管理と フィルターの新規作成には、これらのボタンを使用してください:

テスト

フィルターがどのように動作するか素早く確認するには、 リスト中のファイルフィルターを選択し、 テストをクリックしてください。 詳細は、 「ファイルフィルターのテスト」を参照してください。

インストール

ファイルフィルターを配置し、フィルターリストへ追加することができます。 ファイルフィルターは、それらをインストールしない限り、 共有フォルダー、デフォルトのプライベートフォルダーのどちらでも検出されません。

新規

共有フォルダーかプライベートフィルターフォルダーのどちらかに、 ファイルテンプレートの新しいコピーを作成します。 「ファイルフィルターの作成」で説明されているように、 テンプレートを編集、ルールの追加を行ってください。

編集

デフォルトエディターでファイルを開くには、リスト中のファイルフィルターを選択し、 編集をクリックしてください。

削除

ファイルを削除しリストから取り除くには、 リスト中のファイルフィルターを選択し、 削除をクリックしてください。 これで、本当にファイルは削除されました。

OKをクリックして、 フィルターダイアログを閉じた時、変更は保存されます。 行フィルターは、Windowsのレジストリに保存されます。

5.1.3. ファイルフィルターの作成

WinMergeにインストール済のファイルフィルターが、 お望みのフィルターを提供していないなら、あなた自身で作成することができます:

  1. ツール → フィルターをクリックしてください。 または、ファイルまたはフォルダーの選択ダイアログから、 フィルターフィールドの右にある、 選択ボタンをクリックしてください。

  2. フィルターダイアログのファイルフィルタータブの、新規ボタンをクリックしてください。

  3. 共有/プライベートフィルターダイアログで、 共有フィルター、または、 プライベートフィルター (これらを何に使用するかは、 「ファイルフィルターの場所」を参照してください)を選択し、 OKをクリックしてください。

    お使いのシステムの共有、または、プライベートフォルダーが、 「新しいフィルターのファイル名を指定してください」ダイアログに開きます (プライベートフォルダーが存在しない場合は、WinMergeが作成します)。

  4. 「新しいフィルターのファイル名を指定してください」ダイアログで、 ファイル名を入力し 保存をクリックしてください。

    注意

    既存のファイル名を選ばないでください: 既存のファイルを編集するには、 2に戻って、 「新規」の代わりに、「編集」をクリックしてください。

    WinMergeは、新しいファイルを、テンプレート: FileFilter.tmplを用いて作成し、 デフォルトのテキストエディターでそれを開きます。

  5. テンプレートの編集は、テンプレートの指示に従って、 プレースホルダー名と説明の更新、 「ファイルフィルターの文法」で説明されている、 フィルタールールの追加を行ってください。 テキストエディターでファイルを保存してください。

    ティップ

    あなたが作成中のルールを、素早くテストしたい場合は、 フィルターダイアログの「テスト」ボタンをクリックしてみてください。 詳細は、「ファイルフィルターのテスト」を参照してください。

  6. 標準のフィルターフォルダーに、ファイルフィルターを作成したにも関わらず、フィルターダイアログがその新しいファイルフィルターを表示しない場合は、一度、OKをクリックしてダイアログを閉じてください。次に、ツール → フィルターをクリックし、再度ダイアログを開いてください。ファイルフィルターリストは、新しいファイルフィルターを含んでいるでしょう。

    お使いのシステム上の、別の場所にファイルを保存した場合、 あなたがインストールしない限り、WinMergeは、それを検出することができません。 システム上のどこかにあるファイルフィルターを検出させるには:

    1. フィルターダイアログの インストールをクリックしてください。

    2. 「インストールするファイルフィルターの位置」ダイアログで、システム上の fltファイルを選択し、 開くをクリックしてください。 ファイルフィルターリストは、インストールされたファイルフィルターを含んでいるでしょう。

5.1.4. ファイルフィルターのテスト

新しいルール作成や既存のルールの理解を補助するため、 サンプルデータに対し素早くファイルフィルターをテストするには、 テストフィルターダイアログを使用してください。 それは、フルで比較操作を走らせるより簡単です。

フィルターダイアログから始めます:

  1. ファイルフィルタータブで、テストしたいファイルフィルターを選択してください。

  2. テストするルールを確認したい場合は、 編集をクリックしてください。 ファイルが開き、次のステップの間、内容を確認することができます。

  3. テストをクリックしてください。

  4. フィルターのテストダイアログで、テストするルールの型を選択してください:

    • ファイルフィルター中のファイルルール、 f:をテストするには、 フォルダー名オプションのチェックを外してください。

    • フォルダールール、 d:をテストするには、 フォルダー名オプションにチェックを入れてください。

  5. テスト用のテキストを入力してください。

    テキストは、テストするルールの型に適したものであるべきです。 例えば、フォルダー名オプションをチェックした場合、 あなたは「\temp」の様なフォルダー名を入力したいでしょう。

    結果欄は、入力したテキストを、 次のどちらかのステータスと共に表示します: passed、または、 failed。

5.2. 行フィルタータブの使用

ファイル比較用の行フィルターの設定と有効化には、このタブを使用してください。 タブは、ルールの一覧を持っています。それぞれのルールは、1つの正規表現を含みます。 ファイル比較用に、リストから複数のルールを組み合わせて適用することができます。

5.2.1. 行フィルターの設定

下の 正規表現リストには、 いつでもルールの追加、編集、削除に使うことのできる、編集欄とボタンがあります。

新しいルールを追加するには:

  1. 新規ボタンをクリックしてください。 カーソルが自動的に編集欄へ移動します。

  2. 正規表現リストの下にある、編集欄に式を入力してください。

  3. 保存をクリックし、リストへ式を読み込んでください。

既存のルールを編集するには:

  1. 行を選択し、 編集をクリックしてください。

  2. 編集欄の式を編集してください。

  3. 編集が完了したら、保存をクリックしてください。

ルールを削除するには、ルールを選択(チェック)し、 削除ボタンをクリックしてください。

5.2.2. 行フィルターの有効化と無効化

  1. 正規表現リストで、 適用したいフィルターにチェックを入れ、適用したくないフィルターはチェックを外すだけです。

  2. 行フィルターを有効にするオプションに チェックを入れるか、外してください。 行フィルターを有効にした場合、 正規表現リストで、現在チェックされているすべてのルールが使用されます。 行フィルターを無効にした場合、たとえそれらがチェックされていても、ルールは使用されません。

  3. OKをクリックして、フィルターダイアログを閉じ、設定を保存してください。

それらを有効にした後にファイルフィルターを適用する、いくつかの方法があります。 詳細は、 「行フィルターの適用」を参照してください。

5.3. Using the Substitution Filters tab

TBD

5.3.1. Configuring substitution filters

TBD

5.3.2. Enabling and disabling substitution filters

TBD

6. 正規表現のヘルプ

正規表現は、非常に複雑になり得ます。幸い、WinMerge のほとんどのファイルフィルターは、このトピックの例からもわかるように、シンプルな範囲の表現です。 WinMergeと共にインストールされるフィルターファイルは、多くの役に立つ例を含んでいます。

最後に、Web上には、正規表現を手助けする、これらのサイトを含むたくさんの情報源があります:

Good site devoted to regexps:
https://www.regular-expressions.info/
Tutorial:
http://www.zvon.org/comp/r/tut-Regexp.html
PDF quick reference:
https://github.com/GordonMcKinney/gist-assets/raw/master/regex.pdf


コマンドライン

WinMergeのコマンドラインは、比較するパスに加えいくつかのパラメーターを受け付けます。これらのパラメーターのほとんどは、外部比較ツールとして使用したり、バッチファイルから比較操作を開始できるようにすることを目的としています。

WinMergeをコマンドラインから実行するには以下の書式のうちの1つを使用します:

WinMergeU [/?]

WinMergeU [/r] [/r-] [/e] [/f filter] [/m compare-method] [/t window-type] [/x] [/xq] [/s] [/sw] [/s-] [/ul] [/um] [/ur] [/u] [/wl] [/wm] [/wr] [/new] [/self-compare] [/clipboard-compare] [/minimize] [/maximize] [/fl] [/fm] [/fr] [/l linenumber] [/c charpos] [/table-delimiter delimiter] [/dl leftdesc] [/dm middledesc] [/dr rightdesc] [/al] [/am] [/ar] [/noninteractive] [/noprefs] [/enableexitcode] [/ignorews] [/ignoreblanklines] [/ignorecase] [/ignoreeol] [/ignorecodepage] [/ignorecomments] [/unpacker unpacker-name] [/prediffer prediffer-name] [/cp codepage] [/fileext file-extension] [/cfg name=value] [/inifile inifile] leftpath [middlepath] rightpath [/o outputpath] [/or reportpath]

WinMergeU conflictfile

パラメーターなしかパス名を入力すると単にWinMergeウィンドウを開きます。パラメーターは、スラッシュ( / ) か、ダッシュ ( - ) 文字が前に付加されます。パス名にはプリフィックス文字を付加しません。

/?

このトピックのWinMergeヘルプを開きます。

/r

すべてのサブフォルダー内のすべてのファイルを比較します(再帰比較)。ユニークフォルダー (片方のみ存在するフォルダー)は、分離された項目として比較結果内にリストされます。サブフォルダーまで含めるとかなり比較時間が増大してしまうことに注意してください。このパラメーターを指定しなかった場合、WinMergeは比較するフォルダー内のファイルとトップレベルのサブフォルダーのみリストします。サブフォルダーの中までは比較しません。

/r-

指定されたフォルダー内のすべてのファイルを比較しますが、そのサブフォルダー内のファイルとサブフォルダーは除外します。これにより、比較時間を短縮することができます。

/e

EscキーでWinMergeが閉じるようにします。WinMergeを外部比較アプリケーションとして使用する場合に便利です。(ダイアログのようにすばやくWinMergeを閉じることができます) この引数を指定しなかった場合、すべてのウインドウを閉じるのに何回もEscキーを押さなければならないことになるかもしれません。(2つ以上タブが開かれている場合、一回のESCキーの押下でWinMergeが終了してしまうのを期待している人はいないような気がしたので、日本語版ではこのオプションを指定しても2つ以上タブが開かれている場合は1つのタブを閉じるだけにし、タブが1つの時またはタブが一つもない時にWinMergeを終了するようにしました)

/f

比較を制限するために、指定したフィルターを適用します。フィルターは*.h *.cppのようなファイルマスクか、XML/HTML Develのようなファイルフィルターの名前です。スペースを含むフィルターマスクやフィルター名はダブルクォーテーションマークで括ってください。

/m compare-method

フォルダー比較方法を指定します。次のキーワードが指定できます。Full, Quick, Binary, Date, SizeDate, Size

/t window-type

ファイルを表示するウィンドウの種類を指定します。次のキーワードが指定できます。 Text, Table, Binary, Image, Webpage

/x

同一ファイルの比較をしたときにWinMergeを閉じます。(情報ダイアログを表示した後) このパラメーターは比較後に効果がなくなります。例えば、もしファイルがマージか編集の結果として同一となった場合です。このパラメーターは、WinMergeを外部アプリケーションとして使用したり、差異のないファイルを無視することによって余分なステップを取り除きたい場合に便利です。

/xq

オプション /x に似ていますが、同一ファイルであってもメッセージボックスを表示しません。

/s

WinMergeウィンドウを1つのインスタンスに制限します。例えば、WinMergeが既に実行中ならば、新しい比較は同じインスタンス内で実行されます。この引数を指定しなかった場合、複数のウィンドウが開かれる可能性があります: 設定によっては、新しい比較が既に存在するウィンドウで実行されることも新しいウィンドウで実行されることもあります。

/sw

/s と同様にWinMergeウィンドウを1つのインスタンスに制限します。ただし、ウインドウを表示しているインスタンスが終了するまで待機します。

/s-

"複数のインスタンスを起動しない"の設定値を無視して、常に別のインスタンスが起動されるようにします。

/ul

左側パスが最近使用した項目(MRU)リストに追加されるのを防ぎます。外部アプリケーションは、ファイルまたはフォルダーの選択ダイアログのMRUリストにパスを追加するべきではありません。

/um

中央のパスが最近使用した項目(MRU)リストに追加されるのを防ぎます。外部アプリケーションは、ファイルまたはフォルダーの選択ダイアログのMRUリストにパスを追加するべきではありません。

/ur

右側パスが最近使用した項目(MRU)リストに追加されるのを防ぎます。外部アプリケーションは、ファイルまたはフォルダーの選択ダイアログのMRUリストにパスを追加するべきではありません。

/u

(または/ub) 各々(左、右、中央)のパスが最近使用した項目(MRU)リストに追加されるのを防ぎます。外部アプリケーションは、ファイルまたはフォルダーの選択ダイアログのMRUリストにパスを追加するべきではありません。

/wl

読み取り専用として左側を開きます。比較時、左側を変更したくない場合に使用してください。

/wm

読み取り専用として中央を開きます。比較時、中央を変更したくない場合に使用してください。

/wr

読み取り専用として右側を開きます。比較時、右側を変更したくない場合に使用してください。

/new

新規ブランクウィンドウを開きます。

/self-compare

指定された１つのファイルとそのファイルのコピーを比較します。

/clipboard-compare

クリップボード履歴の直近2つの内容を比較します。

/minimize

最小化状態でWinMergeを開始します。このオプションは長時間かかる比較を行う場合に便利です。

/maximize

最大化状態でWinMergeを開始します。

/fl

起動時、左側にフォーカスを当てます。

/fm

起動時、中央にフォーカスを当てます。

/fr

起動時、右側にフォーカスを当てます。

/l linenumber

ファイルを読み込んだ後にジャンプする行番号を指定します。

/c charpos

ファイルを読み込んだ後にジャンプする文字位置を指定します。

/table-delimiter delimiter

テーブル編集用の区切り文字を指定します。タブ文字を指定する場合、「tab」または「\t」、「\x09」を指定してください。

/dl

左側タイトルバーの説明を指定します。デフォルトのフォルダーやファイル名テキストに上書きされます。例: /dl "Version 1.0" や /dl WorkingCopy. スペースを含む説明はダブルクォーテーションマークで括ってください。

/dm

/dlと同様に中央タイトルバーの説明を指定します。

/dr

/dlと同様に右側タイトルバーの説明を指定します。

/al

起動時、左側で自動マージします。

/am

起動時、中央で自動マージします。

/ar

起動時、右側で自動マージします。

/noninteractive

TBD

/noprefs

TBD

/enableexitcode

比較結果をプロセス終了コードに設定します。0: 同一, 1: 差異あり, 2: エラー

/ignorews

TBD

/ignoreblanklines

TBD

/ignorecase

TBD

/ignoreeol

TBD

/ignorecodepage

TBD

/ignorecomments

TBD

/unpacker

TBD

/prediffer

TBD

/cp

TBD

/fileext file-extension

シンタックスハイライトの種類を決定するため、ファイル拡張子を指定します。

/cfg

TBD

leftpath

左側で開くフォルダーやファイルを指定します。

middlepath

中央で開くフォルダーやファイルを指定します。

rightpath

右側で開くフォルダーやファイルを指定します。

WinMergeは、ファイルとフォルダーを比較できません。そのためパスパラメーター両方(または3つすべて)(leftpath と(middlepath と)rightpath) には、同じ種類(フォルダーかファイルのどちらか)を指し差なければなりません。もし、WinMergeが指定したパスのどちらかを見つけることができなければ、ファイルまたはフォルダー選択ダイアログを開きます。ファイルまたはフォルダー選択ダイアログでは、正しいパスを選択できます。

ティップ

ファイル比較では、パスパラメーターの一つとしてフォルダー名を指定できます。ただし、フォルダーは他方のファイル名と同じファイルを含んでいる必要があります。

例えば、以下のコマンドを考えます:

WinMergeU C:\Folder\File.txt C:\Folder2

もし、C:\Folder2がファイル名File.txtを含んでいれば、WinMergeは、暗黙的にファイル指定として第二のパスを解決します。当然ながら、C:\Folder2がファイル名File.txtを含んでいなければ、コマンドは不正とみなされます。

/o outputpath

マージした結果のファイルを保存するオプションの出力ファイルパスを指定します。

出力パスはコマンドラインからWinMergeを開始する時まれにしか必要となりません。それはバージョンコントロールツールとともに使用されることになります。結果ファイルとして出力パスを指定する必要があるかもしれません。もし、出力パスを指定した場合、あるペインを変更後保存すると、変更は出力パスのファイルに保存され、元ファイルは前の状態のままになります。

バージョンコントロールシステムは一般的にtheirsやmine、mergedかまたはresolvedのような用語を使用し元と結果ファイルを参照します。もし、WinMergeコマンドラインに出力パスを指定し、バージョンコントロールシステムと連携するならば、この順番でファイルを並べるべきです。

/or

TBD

conflictfile

コンフリクトファイルを指定します。コンフリクトファイルは通常バージョンコントロールシステムによって生成されます。コンフリクトファイルはファイル比較ウインドウで開かれ、「コンフリクトファイルの解決」で説明している様にマージやコンフリクトを解決することができます。コンフリクトファイルと共に他のパスは使用できないことに注意してください。

/inifile inifile

レジストリの代わりに設定の読み込みと保存に使用するINIファイルを指定します。


ほかのツールと共にWinMergeを使用する

ファイルを比較することと、マージすることは、大きな変更を管理する上でよくあることです。 そのような理由により、WinMergeは、それ単体で使用されるだけでなく、 他のツールと連携しても使用されます。さらに、 diffとマージユーティリティは、異なる特徴を提供するので、 それは、時々、異なるツールを結合するのに便利です。 このトピックは、他のツールと共に使用するための主な方法について説明しています。

1. コマンドインターフェイス(CLI)を使用する

コマンドラインで説明されている、コマンドライン・インターフェイス(CLI)により、 コマンド・プロンプト、スクリプト、または、他のツールやプログラムから、 WinMergeを起動することができます。 基本的に、少なくともパスを指定して外部の実行ファイルを呼び出せるプログラムならどれでも WinMergeを起動できます。

ここにいくつかの例を示します

  • バッチファイルは、WinMergeを起動することができ、 パラメーターを対話的に指定することができます。

    start "WinMerge" /B "C:\Program Files\WinMerge\WinMergeU.exe" /e /s /u /dl %3 /dr %5 %6 %7

  • Subversionクライアントは、次に示すように、外部のdiffプログラムを呼ぶことを許可しています。

    $ svn diff --diff-cmd "C:\Program Files\WinMerge\WinMergeU.exe" -x "-dl -dr" myfile

ティップ

同様に、組み込みのdiffツールを含む、多くのGUIツール(バージョン管理システムのクライアントやIDE)は、 それらのデフォルトのdiffツールの代わりにWinMergeを設定することが可能です。 次のセクションは、TortoiseSVN、Visual Studio Team Foundation Server で、 このような方法でWinMergeを使う方法を説明しています。 EclipseやPerforceなど他のツールは、それらのドキュメントを参照するか、 インターネットで詳細や例を調べてください。

2. バージョン管理システムで、WinMergeを使う

あなたは、WinMergeが、2、3のサポートされているバージョン管理システム(VCS)と、 協調し合うように設定できます。 このセクションは、VCS統合と、例を説明しています。

2.1. WinMergeを、バージョン管理システムの、差分ツールとして使用する

TortoiseCVS、TortoiseSVN、または、TortoiseGit でファイル比較する際、 VCSは、組込みの差分ツールの代わりに、WinMergeを起動することができます。 この設定は、WinMergeのインストールの最中のみで可能です。

例1 TortoiseSVNとの統合

これは、WinMerge統合を使用した、TortoiseSVNでの比較操作のサンプルです。 この統合は、TortoiseCVS と TortoiseGit も同じです。

  1. Windowsのエクスプローラー中で、チェックアウトしたSubversion作業コピーをナビゲートします。

  2. Subversionの管理下にあるファイル(大抵は、目立つTortoiseSVNアイコンで示されます)を、 右クリックし、コンテキストメニューの TortoiseSVNをクリックしてください。

    • ファイルが修正されていない場合、 コンテキストメニューは、前のバージョンと比較 のショートカットを含んでいます。このコマンドは、 チェックアウトされているバージョンと、リポジトリにチェックインされている、 前のバージョンを比較します。

    • ファイルを変更している場合、コンテキストメニューは、同じ 前のバージョンと比較 のショートカットと、それに加え、比較のショートカットを含んでいます。 このコマンドは、あなたの版と最新版(チェックアウトされている版)を比較します。 それは、変更を加えた箇所をレビューするのに便利です。

  3. 前のバージョンと比較 、または、比較ショートカットのどちらかを選んでください。 WinMergeのウィンドウが開き、ファイル比較ウィンドウに、 目的のファイルのバージョンが読み込まれます。

TortoiseSVN → 比較のショートカットでは、ファイルシステムにある、 Subversionで管理されていない二つのファイルの比較が可能です。 WinMerge統合の方法を次に示します。

  1. Windowsのエクスプローラーで、Ctrlを押しながら二つのファイルを選択し、 右クリックします。

  2. コンテキストメニューから、TortoiseSVN → 比較を選択します。

    WinMergeウィンドウが開き、選択されたファイルが、 ファイル比較ウィンドウに表示されます。

例2 Visual Studio Team Foundation Server の統合

Team Foundation Server（TFS）で管理されているファイルの差異を表示するために、 Visual Studioで使用する既定のツールとしてWinMergeを手動で設定できます。 他のバージョン管理システムも、非常によく似た方法で設定できます。

  1. Visual Studio で、 Tools → Options... メニューを選択します。

  2. Source Controlで、 Visual Studio Team Foundation Server オプションを探します。

  3. Configure User Tools... ボタンをクリックします。

  4. Add... ボタンをクリックします。

  5. Configure Tool で次のオプションを指定します

    • Extension: .*

    • Operation: Compare

    • Command: {Path to WinMerge}\WinMergeU.exe

    • Arguments: /e /u /dl %6 /dr %7 %1 %2

    {Path to WinMerge}はWinMergeがインストールされているパスです。 上記のスクリーンショットでは、デフォルトのインストールパス C:\Program Files (x86)\WinMerge\WinMergeU.exe にインストールされています。

    上記引数はコマンドラインで記載されています。

TFSに2つのファイルを比較するように指示するたびに、WinMergeが使用されます。


よくたずねられる質問

1. 一般的な質問

1.1.

Does WinMerge run on older Windows versions?

Beginning with Version 2.14, WinMerge ended support for older 32-bit Windows systems, including Windows 9x, ME, and NT4. In addition, WinMerge version 2.16 does not support Windows 2000.

Previously, WinMerge provided an ANSI (8-bit) executable, WinMerge.exe, that was designed around the old Windows codepages. WinMerge.exe internally stored only the ANSI characters supported by the Windows codepage. This executable had severe limitations for working with Unicode: if you opened a Unicode file, the characters were converted to the Windows ANSI codepage. Because there are over 100,000 Unicode characters, and only 256 can be represented in the ANSI character set, data loss could occur. Conversion might be approximate (for example, accents are lost) or impossible: characters were replaced by question marks ( ? ).

WinMerge.exe also could not open files with names outside the current ANSI codepage. For example, on an English system, WinMerge.exe could not open a file with a Hebrew name.

WinMerge developed the Unicode-enabled WinMergeU.exe executable to work with newer, Unicode-based Windows systems. WinMergeU.exe has none of the limitations of the ANSI executable.

WinMergeU.exe has been installed by default for some time, and since few ANSI-based Windows systems remain, the value of maintaining WinMerge.exe is minimal. As of Version 2.14, WinMerge no longer includes WinMerge.exe in the installer.

1.2.

I want to compare folders, but I cannot select a folder in the Browse dialog.

Browse in the folder contents to the folder you want to compare. Do not select any of the files or subfolders, just click Open when Folder Selection is displayed in the File name field. If you already selected a files or subfolders, just type a random string in the File name field and click Open. If the file name you enter is not found, WinMerge opens the folder.

1.3.

Windows以外のOSにWinMergeを移植する予定はないの?

There are currently no plans for cross-platform support but you can try the unofficial version WinMerge 2011 by Jochen Neubeck. This version should work with Wine also under Linux.

1.4.

なぜCVS統合機能とかがないの?

CVS統合機能を提供することは微妙です。 なぜなら、すでに多くの良質なCVSクライアントが存在するからです。 けれども、WinMergeは、それらのCVSクライアントのひとつ、TortoiseCVS(ほかのツールと共にWinMergeを使用するで後述) の差分機能を統合します。 WinMergeは、コンフリクトファイルを解決することもできます。 (さらなる情報は、「コンフリクトファイルの解決」を参照)。

1.5.

MRU (リスト)てなに?

MRUは「Most Recently Used」(最近使ったファイル)の省略形で、 ファイル及びフォルダー選択ダイアログの履歴一覧に関係しています。 この一覧は、最近使用した20のパスを含みます。

1.6.

OpenOfficeのファイルは比較できる?

OpenOfficeのファイルは書庫です。 WinMergeが開くことができるように、アーカイブサポートを設定しなければなりません。

  • In WinMerge, click the Options button (or click Edit → Options). In the Archive Support page, enable the Detect archive type from file signature option

1.7.

なんで大きいファイルを比較するとたまに、フォルダー比較では差異があるといっているのに、 ファイル比較では同一だといわれるの?

これは、WinMergeが大きなファイルを比較する時は、 常にクイックコンテンツを使用しているからです。 この方法は、WinMergeで大きなファイルをより効率的に比較することを可能にします。 このことがあなたの見ている現象を発生させるかどうかをテストするために、クイックコンテンツ用の大きなファイルとみなすしきい値を上げてみることができます。 どのようにすればよいか学ぶために「フォルダー比較操作の開始」での、この方法の説明を見てください。

2. ファイル比較

2.1. | なんで僕のファイルは全行に差異があると色づけされるの? 全行同じはずだよ。
 | おそらく、ファイルの改行コードが異なっているからです(例えば、WindowsとUnix)。 デフォルト設定では、WinMergeは、改行コードを比較します。 無効にするには、編集(E) → 設定(O) とクリック。「比較」カテゴリの、改行文字の違いを無視する(R) (Windows/Unix/Mac)にチェックしてください。

3. エディターについての質問

3.1. | ファイル内の文字がクエスチョンマークになってみえるよ?
 | 私たちは、これを、非可逆式変換と呼んでいます。 ANSIのファイルに関しては、多分コードページの問題です。障害調査をする為に、編集(E) → 設定(O)とクリックしてください。「コードページ」カテゴリにあるファイルのコードページ情報を検出するがチェックされているか確認してください。もしチェックされていたら、チェックを外し、OKをクリックし、問題が解決するかを確認してください。
3.2. | エディターでプロポーショナルフォントは選択できないの?
 | 残念ながら、WinMergeは等幅フォントしかサポートしていません。
3.3. | (自動)再スキャンの遅延てなに?なぜそれが必要なの?
 | (自動)再スキャンが可能な時(「設定」の「エディター」カテゴリ)、 WinMergeは、ファイルが編集されている間、再スキャンを遅延させます。 つまり、編集を止めるまで、再スキャンは起こりません。 この遅延が無い場合、WinMergeは文字をタイプする毎にファイルをスキャンし、編集作業を遅くさせるでしょう。 この遅延は、特に(再スキャンに数秒かかるような)大きなファイルの編集を改善します。
3.4. | ファイル比較ウィンドウのファイルペインからファイルを印刷できる?
 | できます。 基本的な印刷をサポートしています。 ファイル(F) → 印刷(P)をクリックしてください。
3.5. | エディターで類似行を非表示にできないの? (差異のある行だけ表示したい)(日本語版では実装)
 | できません。 この機能は、多くのユーザーからリクエストされていますが、これを実装する予定はありません。 私たちは、それが本当にユーザビリティを改善するとは思っていません。

4. 外部比較ツールとしてのWinMerge

4.1.

Escキーを一回押したらWinMergeが終了するようにしたいな。

WinMergeをコマンドラインから-eスイッチ付きで起動してください。

4.2.

同じファイルを比較した時、選択されたファイルは同一ですを表示せずに、WinMergeを終了したい。

コマンドラインスイッチ「-x」を使用してください。

4.3.

「開く」ダイアログの履歴がテンポラリファイルで埋まらないようにできないかな?

外部プログラムからWinMergeを起動する時、/ubオプションを付けて起動してください。 これは、テンポラリファイルを履歴に加えないようWinMergeに伝えます。

4.4.

でも、使っているプログラムがコマンドライン引数をサポートしてないよう！

これらのうち、どれか一つを含むバッチファイルを作成してください。

  • CALL "<winmerge path>\WinMerge" /e /u %1 %2 %3
  • start "WinMerge" "<winmerge path>" /e /u %1 %2 %3

あなたが使っているプログラムから、このバッチファイルを呼び出してください。

5. アーカイブサポート

5.1. | WinMergeの開発者がパッチをなげる時につかう「ペリースタイル」なパッチファイルをどうやって開けばいいの?
 | ペリースタイルのパッチは、別のフォルダーに、元ファイルと変更後のファイルが入っているzipファイルです。 WinMergeは、(驚くべきことに！)これらのファイルの取扱いを内部的にサポートしています。 比較操作を実行し、zipファイルを左右両方とも選択してください。WinMergeは、zipファイルの内容をフォルダー比較ウィンドウに展開し、 元ファイルと変更後ファイルを比較します。
5.2. | WinMergeは、標準的じゃない拡張子のアーカイブファイルを開けないの? (例えば、形式はzipな.jar ファイルとか)
 | はい。設定ボタンをクリック(または、編集(E) → 設定(O))。「アーカイブサポート」カテゴリの、ファイルのシグネチャからアーカイブの種類を検出する(D)オプションを有効にしてください。

6. テキストエンコーディング (コードページ)

6.1.

どうしたら僕のファイルのコードページがわかるの?

メモ帳でファイルを開いてください(例えば、 スタート → すべてのプログラム → アクセサリ → メモ帳をクリック)。 ファイル(F) → 名前を付けて保存(A)とクリックし、保存ダイアログで エンコーディング ドロップダウンリストの項目をスクロールしてみてください。 そこに、有効な値が含まれています。

  • ANSI: そのファイルは、明らかに、ローカルなWindowsのコードページです。 もしファイルが完全に英語で、普通の句読点であるなら、ファイルはASCIIでしょう。

  • Unicode: そのファイルは、多分、WindowsのデフォルトのUnicodeエンコーティングである、UCS-2LEです。

  • UTF-8: そのファイルは、クロスプラットフォームなUnicodeエンコーディングである、UTF-8です。

  • Unicode ビッグ・エインディアン: そのファイルは、あまり使用されていないかWindowsでサポートされている 異なるUnicodeエンコーディングで、恐らく、UCS-2BEです。

7. パッチファイル

7.1. | コマンドラインからパッチファイルを作る方法はないの?
 | ありません。それは、最新バージョンでは追加されるかもしれません。 それまで、diffutilsのWin32移植版が使えます。 最新版のdiffutils(とパッチ)は、 SourceForgeのGnuWin32 プロジェクトページ: https://sourceforge.net/projects/gnuwin32 からダウンロードできます。
7.2. | WinMergeでパッチをあてられる?
 | You can apply patches using the experimental plugin ApplyPatch.sct. The extensions of patches supported by the plugin are .diff or .patch.


付録A ショートカットキー

WinMergeは、他のWindowsアプリケーションで一般的に使用されている、 おなじみのショートカットキーを含んでいます。

表A.1 フォルダー比較

キー | 機能
Enter | 選択されているファイル、または、フォルダーを開く
Backspace | もし、可能なら(サブフォルダーが比較対象に含まれない時のみ)親フォルダーを開く
F5 | フォルダーの再スキャン
Alt+Home | ファイル、または、フォルダーの最初の差異に移動
Alt+End | ファイル、または、フォルダーの最後の差異に移動
Alt+Enter | 現在選択されている項目に移動(もしスクリーンの外にあるなら)
Alt+上矢印 | ファイル、または、フォルダーの前の差異に移動
Alt+下矢印 | ファイル、または、フォルダーの次の差異に移動
Alt+左矢印 | 選択されている項目を右から左へコピー
Alt+右矢印 | 選択されている項目を左から右へコピー

表A.2 ファイル比較

キー | 機能
Esc | ウィンドウを閉じる(設定が有効になっているなら)
F4 | 次の行内差異を表示
Shift+F4 | 前の行内差異を表示
F5 | 表示を更新
Ctrl+F5 | Reload
F6 | ペイン(アクティブなファイル)を切り替える
Shift+F6 | Change to previous pane (active file)
F7 | 前の差異へ移動
Shift+F7 | 前のコンフリクトへ移動
Ctrl+F7 | 前のファイルへ移動
F8 | 次の差異へ移動
Shift+F8 | 次のコンフリクトへ移動
Ctrl+F8 | 次のファイルへ移動
F9 | マージモードのオン・オフを切り替える
Ctrl+B | Begin column selection
Ctrl+D | Toggle diff context mode
Ctrl+Alt+E | Open with external editor
Ctrl+G | 差異、または、行へ移動
Ctrl+Shift+G | Go to moved line (2 panes)
Ctrl+Shift+G | Go to moved line between left side and middle (3 panes)
Ctrl+Alt+G | Go to moved line between middle and right side (3 panes)
Shift+Ctrl+M | Add marker
Ctrl+Alt+M | Do auto merge
Alt+S | Add synchronization point
Ctrl+U | Convert selected text to lower case
Ctrl+Shift+U | Convert selected text to upper case
Ctrl+Y | 前の操作をやり直す
Ctrl+Z | 最後に行った操作を元に戻す

表A.3 差異のナビゲートとマージ (通常モード)

キー | 機能
Alt+Home | 最初の差異へ移動
Alt+End | 最後の差異へ移動
Alt+Enter | 現在の差異へ移動、または、差異を選択
Alt+上矢印 | 前の差異へ移動
Alt+下矢印 | 次の差異へ移動
Alt+Shift+Up Arrow | 前のコンフリクトへ移動
Alt+Shift+Down Arrow | 次のコンフリクトへ移動
Alt+左矢印 | 右から左へ差異をコピー
Alt+右矢印 | 左から右へ差異をコピー
Ctrl+Alt+左矢印 | 右から左へ差異をコピーし、次の差異を選択
Ctrl+Alt+右矢印 | 左から右へ差異をコピーし、次の差異を選択

表A.4 差異のナビゲートとマージ (マージモード)

キー | 機能
上矢印 | 前の差異へ移動
下矢印 | 次の差異へ移動
左矢印 | 右から左へ差異をコピー
右矢印 | 左から右へ差異をコピー
Ctrl+Alt+左矢印 | 右から左へ差異をコピーし、次の差異を選択
Ctrl+Alt+右矢印 | 左から右へ差異をコピーし、次の差異を選択

表A.5 検索と置換

キー | 機能
Ctrl+F | 文字を検索(検索ダイアログを開く)
Ctrl+H | 文字を置換(置換ダイアログを開く)
F3 | 次を検索
Shift+F3 | 前を検索
Ctrl+F3 | ファイル中から選択されているテキストを検索
Ctrl+Shift+F3 | ファイル中から選択されているテキストを上方向に検索

表A.6 ブックマーク

キー | 機能
F2 | 次のブックマークへ移動
Shift+F2 | 前のブックマークへ移動
Ctrl+F2 | ブックマークの作成・削除
Ctrl+Shift+F2 | 全てのブックマークをクリア
Alt+0 | ブックマーク0へ移動
Ctrl+0 | ブックマーク0の作成・削除
Alt+1 | ブックマーク1 へ移動
Ctrl+1 | ブックマーク1の作成・削除
Alt+2 | ブックマーク2 へ移動
Ctrl+2 | ブックマーク2の作成・削除
Alt+3 | ブックマーク3 へ移動
Ctrl+3 | ブックマーク3の作成・削除
Alt+4 | ブックマーク4 へ移動
Ctrl+4 | ブックマーク4の作成・削除
Alt+5 | ブックマーク5 へ移動
Ctrl+5 | ブックマーク5の作成・削除
Alt+6 | ブックマーク6 へ移動
Ctrl+6 | ブックマーク6の作成・削除
Alt+7 | ブックマーク7 へ移動
Ctrl+7 | ブックマーク7の作成・削除
Alt+8 | ブックマーク8 へ移動
Ctrl+8 | ブックマーク8の作成・削除
Alt+9 | ブックマーク9 へ移動
Ctrl+9 | ブックマーク9の作成・削除

表A.7 拡大/縮小

キー | 機能
Ctrl++ | フォントの表示倍率を拡大
Ctrl+- | フォントの表示倍率を縮小
Ctrl+* | フォントの表示倍率を標準に戻す
Ctrl+マウスホイールを上へ | フォントの表示倍率を拡大
Ctrl+マウスホイールを下へ | フォントの表示倍率を縮小